// BlastEmailDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetControl.h"
#include "BlastEmailDlg.h"
#include "Mail/SMTP.h"
#include "Mail/MIMEMessage.h"
#include "FileDialogST.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlastEmailDlg dialog


CBlastEmailDlg::CBlastEmailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlastEmailDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlastEmailDlg)
	m_szFrom = _T("\"W4DJW (Dave in Greer SC)\" <davewatson@charter.net>");
	m_szServer = _T("smtp.charter.net");
	m_szSubject = _T("Invitation: Check-in to the Blue Ridge 2m Net @ 9:00 PM on 146.61 or via APRS -> (W4DJW)");
	m_szTo = _T("Use Distribution list to the right -->");
	m_szBody = _T("Enter the message here.");
	//}}AFX_DATA_INIT

	//m_szTo = _T("\"B.R.A.R.S. Member\" <watson_d@ix.netcom.com>");
   m_pSet = NULL;
}


void CBlastEmailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlastEmailDlg)
	DDX_Control(pDX, IDC_DISTR_LIST, m_ctrlDistributionList);
	DDX_Control(pDX, IDC_ATTACHMENTS, m_ctrlAttachmentList);
	DDX_Text(pDX, IDC_EDIT_FROM, m_szFrom);
	DDX_Text(pDX, IDC_EDIT_SERVER, m_szServer);
	DDX_Text(pDX, IDC_EDIT_SUBJECT, m_szSubject);
	DDX_Text(pDX, IDC_EDIT_TO, m_szTo);
	DDX_Text(pDX, IDC_EDIT_BODY, m_szBody);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBlastEmailDlg, CDialog)
	//{{AFX_MSG_MAP(CBlastEmailDlg)
	ON_BN_CLICKED(IDC_BUTTON_ATTACHMENTS, OnButtonAttachments)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_ATTACH, OnButtonClearAttach)
	ON_BN_CLICKED(IDC_BLAST_ALL, OnBlastAll)
	ON_BN_CLICKED(IDC_BLAST_NONE, OnBlastNone)
	ON_BN_CLICKED(IDC_LOAD_STORED, OnLoadStored)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlastEmailDlg message handlers

void CBlastEmailDlg::OnButtonClearAttach() 
{
      m_ctrlAttachmentList.ResetContent();	
      m_Files.RemoveAll();
}

void CBlastEmailDlg::OnButtonAttachments() 
{
   CFileDialogST	dlg(TRUE, NULL, NULL, OFN_ALLOWMULTISELECT, _T("Select files to be attached:\0*.*\0"), NULL);
   
   dlg.m_ofn.lpstrTitle = _T( "Attach File" );
   if(dlg.DoModal() == IDOK)
   {
      CString szFileName, szPathName;
      POSITION Pos = dlg.GetStartPosition();
      while(Pos)
      {
         szPathName = dlg.GetNextPathName(Pos);
         m_ctrlAttachmentList.AddString(szPathName);
         m_Files.Add(szPathName);
      }
   }   
}

void CBlastEmailDlg::OnButtonSend() 
{
   CString szToAddress;
	UpdateData( TRUE );
   CWaitCursor cursor;
   
   int nCount = m_ctrlDistributionList.GetItemCount();
   
   for (int i=0;i < nCount;i++)
   {
      if(m_ctrlDistributionList.GetCheck(i))
      {
         CString szBody(m_szBody);
         char* pszCall  = (char*) new char[10];
         char* pszName  = (char*) new char[25];
         char* pszEmail = (char*) new char[50];
         m_ctrlDistributionList.GetItemText( i, 0, pszCall, 10 );
         m_ctrlDistributionList.GetItemText( i, 1, pszName, 25 );
         m_ctrlDistributionList.GetItemText( i, 2, pszEmail, 50 );
         szToAddress.Format("\"%s (%s)\" <%s>", pszCall, pszName, pszEmail);
         szBody.Replace("<NAME>",pszName);
         szBody.Replace("<CALL>",pszCall);
         SendToSingleAddress(szToAddress, szBody);
         delete pszCall;
         delete pszName;
         delete pszEmail;
         Sleep(5000);
      }
   }

	AfxMessageBox( _T( "Message(s) sent successfully" ) );

	UpdateData( FALSE );
   
}

bool CBlastEmailDlg::SendToSingleAddress(CString szToAddress, CString szBody)
{
   bool bSuccess = true;
	CSMTP smtp( "" );
	CMIMEMessage msg;

	smtp.SetServerProperties( m_szServer );
	msg.m_sFrom = m_szFrom;
	msg.AddMultipleRecipients( szToAddress );
	msg.m_sSubject = m_szSubject;
	msg.m_sBody = szBody;

   for( int lp = 0; lp <= m_Files.GetUpperBound(); lp++ )
	{
		msg.AddMIMEPart( m_Files[ lp ] );
	}

	if( !smtp.Connect() )
		bSuccess = false;

	if(bSuccess && !smtp.SendMessage( &msg ) )
		bSuccess = false;

   if(bSuccess)
      smtp.Disconnect();
   else
      AfxMessageBox( smtp.GetLastError() );

   return bSuccess;
}

void CBlastEmailDlg::OnBlastAll() 
{
   int nCount = m_ctrlDistributionList.GetItemCount();
   
   for (int i=0;i < nCount;i++)
   {
      m_ctrlDistributionList.SetCheck(i, TRUE);
   }
}

void CBlastEmailDlg::OnBlastNone() 
{
   int nCount = m_ctrlDistributionList.GetItemCount();
   
   for (int i=0;i < nCount;i++)
   {
      m_ctrlDistributionList.SetCheck(i, FALSE);
   }
}

BOOL CBlastEmailDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_pSet = new CNetControlSet();
   m_pSet->m_strFilter.Format("Date Like #%s#", m_szSelectedDate);

   m_pSet->Open();
   if(m_pSet->IsOpen())
   {
      int total_cx = 0;
      LV_COLUMN lvcolumn;
      memset(&lvcolumn, 0, sizeof(lvcolumn));

      lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
      lvcolumn.fmt  = LVCFMT_LEFT;
      lvcolumn.pszText = "Call";
      lvcolumn.iSubItem = 0;
      lvcolumn.cx = 75;
      total_cx += lvcolumn.cx;
      m_ctrlDistributionList.InsertColumn(0, &lvcolumn);

      lvcolumn.pszText = "Name";
      lvcolumn.iSubItem = 1;
      lvcolumn.cx = 60;
      total_cx += lvcolumn.cx;
      m_ctrlDistributionList.InsertColumn(1, &lvcolumn);

      lvcolumn.pszText = "eMail";
      lvcolumn.iSubItem = 2;
      lvcolumn.cx = 200;
      total_cx += lvcolumn.cx;
      m_ctrlDistributionList.InsertColumn(2, &lvcolumn);


      m_ctrlDistributionList.SetExtendedStyle(LVS_EX_CHECKBOXES |
                                              LVS_EX_HEADERDRAGDROP |
                                              LVS_EX_ONECLICKACTIVATE |
                                              LVS_EX_FULLROWSELECT |
                                              LVS_EX_GRIDLINES );

      m_ctrlDistributionList.LockWindowUpdate();

      int iCount = 0;

      for(m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
      {
         if(!m_pSet->m_eMailAddr.IsEmpty())
         {
            int iIdx = m_ctrlDistributionList.InsertItem(iCount++, m_pSet->m_CallSign);
            m_ctrlDistributionList.SetItemText(iIdx,0, m_pSet->m_CallSign);
            m_ctrlDistributionList.SetItemText(iIdx,1, m_pSet->m_Name);
            m_ctrlDistributionList.SetItemText(iIdx,2, m_pSet->m_eMailAddr);
            m_ctrlDistributionList.SetItemText(iIdx,3, m_pSet->m_Class);
         }
      }

      m_ctrlDistributionList.UnlockWindowUpdate();
   }
	
	return TRUE;
}

void CBlastEmailDlg::OnCancel() 
{
	m_pSet->Close();
   delete m_pSet;
   m_pSet = NULL;
	
	CDialog::OnCancel();
}


void CBlastEmailDlg::OnLoadStored() 
{
   CFileDialogST	dlg(TRUE, NULL, NULL, NULL, _T("Select stored message:\0*.msg\0"), NULL);
   
   dlg.m_ofn.lpstrTitle = _T( "Select Stored Message" );
   if(dlg.DoModal() == IDOK)
   {
      CString szFileName, szPathName;
      POSITION Pos = dlg.GetStartPosition();
      while(Pos)
      {
         szPathName = dlg.GetNextPathName(Pos);
         CFile cf;
         CFileStatus cfs;
         if(cf.GetStatus(szPathName, cfs))
         {
            cf.Open(szPathName,CFile::modeRead);
            int nCount   = cf.GetLength();
            char *lpbuf  = (char*) new char[nCount+1];
            int iRead    = cf.Read(lpbuf,nCount);
            lpbuf[iRead] = '\0';
            CString szData(lpbuf);
            delete [] lpbuf;
            cf.Close();

            m_szBody = szData;
            UpdateData(FALSE);
         }
      }
   }   	
}

