// BuildFCCDbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "netcontrol.h"
#include "BuildFCCDbDlg.h"
#include "FileDialogST.h"

#include <process.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CBuildFCCDbDlg dialog

CBuildFCCDbDlg::CBuildFCCDbDlg(CView* pView)
{
	//{{AFX_DATA_INIT(CBuildFCCDbDlg)
	m_szInputFolder = _T("");
	m_szOutputFolder = _T("");
	m_szStatus = _T("");
   m_pView = pView;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBuildFCCDbDlg::~CBuildFCCDbDlg()
{
   CDialog::~CDialog();
}

BOOL CBuildFCCDbDlg::Create()
{
    return CDialog::Create(CBuildFCCDbDlg::IDD);
}

void CBuildFCCDbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuildFCCDbDlg)
	DDX_Text(pDX, IDC_INPUT, m_szInputFolder);
	DDX_Text(pDX, IDC_OUTPUT, m_szOutputFolder);
	DDX_Text(pDX, IDC_STATUS, m_szStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBuildFCCDbDlg, CDialog)
	//{{AFX_MSG_MAP(CBuildFCCDbDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE_FCC, OnBrowseFcc)
	ON_BN_CLICKED(IDC_BROWSE_OUT, OnBrowseOut)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuildFCCDbDlg message handlers

BOOL CBuildFCCDbDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

   CString szTempPath;
   char szPath[512];
   _getcwd(szPath,_MAX_PATH);

   szTempPath.Format("%s\\AM.dat", szPath);
   m_szInputFolder = AfxGetApp()->GetProfileString("Settings", "InputFolder", szTempPath);

   szTempPath.Format("%s\\FCC97.mdb", szPath);
   m_szOutputFolder = AfxGetApp()->GetProfileString("Settings", "OutputFolder", szTempPath);

	m_JobQ.setMaxNoOfExecuter(10);

   m_AMSet.SetDBName(m_szOutputFolder);
   m_ENSet.SetDBName(m_szOutputFolder);
   m_HDSet.SetDBName(m_szOutputFolder);

   UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBuildFCCDbDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBuildFCCDbDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBuildFCCDbDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBuildFCCDbDlg::OnBrowseFcc() 
{
   CFile cfOutputFile;
   CFileStatus rStatus;
   CString szFileName, szMsg;
   bool bPermission2Save = true;
   CFileDialogST	dlg(FALSE, _T("dat"), m_szInputFolder, NULL, _T("All dat files\0*.dat\0"), this);
   
   if(dlg.DoModal() == IDOK)
   {
      POSITION Pos = dlg.GetStartPosition();
      szFileName = dlg.GetNextPathName(Pos);
      
      int iNameLoc = szFileName.ReverseFind('\\');
      
      if(iNameLoc != -1)
      {
         m_szInputFolder = szFileName.Mid(0,iNameLoc);
         m_szOutputFolder = m_szInputFolder + "\\FCC97.mdb";
         m_szInputFolder += "\\*.dat";
      }
      
      if(cfOutputFile.GetStatus(m_szOutputFolder,rStatus))
      {
         szMsg.Format("File %s exists! Overwrite?", m_szOutputFolder );
         if(AfxMessageBox(szMsg, MB_YESNO) != IDYES)
            bPermission2Save = false;
      }

      if(bPermission2Save)
      {
         AfxGetApp()->WriteProfileString("Settings", "InputFolder", m_szInputFolder);      
         AfxGetApp()->WriteProfileString("Settings", "OutputFolder", m_szOutputFolder);      
         UpdateData(FALSE);
      }
   }
   
}

void CBuildFCCDbDlg::OnBrowseOut() 
{
	OnBrowseFcc();
}

void CBuildFCCDbDlg::OnOK() 
{ 
   if(CreateDatabase()) {

      m_AMSet.Open(AFX_DAO_USE_DEFAULT_TYPE,NULL,dbAppendOnly|dbInconsistent);

      //m_AMCompilerJob = new CDbCompiler();
      m_AMCompilerJob.m_szInputFolder = m_szInputFolder;
      m_AMCompilerJob.m_szOutputFolder = m_szOutputFolder;
      m_AMCompilerJob.m_pView = m_pView;
      m_AMCompilerJob.m_pAMSet = &m_AMSet;
      m_AMCompilerJob.m_szJobToDo = "AMSet";
      m_AMCompilerJob.setAutoDelete(FALSE);
      m_AMCompilerJob.m_pDlg = (this);
      m_AMCompilerJob.execute();
      m_AMCompilerJob.m_Completed = TRUE;
      //TRACE("Adding AM Job to the Queue\n"); m_JobQ.addJob(&m_AMCompilerJob);

      SetTimer(1001,1000,NULL);
   }
}

void CBuildFCCDbDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 1001)
   {
      TRACE("Checking AM Status\n");

      if(m_AMCompilerJob.m_Completed)
      {
         TRACE("Killing AM Timer\n");          KillTimer(1001);
         TRACE("Closing the AM Dataset\n");    m_AMSet.Close();
         //TRACE("Deleting the AM Job\n");       delete m_AMCompilerJob;

         TRACE("Opening ENSet\n");
         m_ENSet.Open(AFX_DAO_USE_DEFAULT_TYPE,NULL,dbAppendOnly|dbInconsistent);
         //TRACE("Creating EN Job\n");           m_ENCompilerJob = new CDbCompiler();
         m_ENCompilerJob.m_szInputFolder =   m_szInputFolder;
         m_ENCompilerJob.m_szOutputFolder =  m_szOutputFolder;
         m_ENCompilerJob.m_pView = m_pView;
         m_ENCompilerJob.m_pENSet = &m_ENSet;
         m_ENCompilerJob.m_szJobToDo = "ENSet";
         m_ENCompilerJob.setAutoDelete(FALSE);
         m_ENCompilerJob.m_pDlg = (this);
         m_ENCompilerJob.execute();
         m_ENCompilerJob.m_Completed = TRUE;
         //TRACE("Adding EN Job to the Queue\n"); m_JobQ.addJob(&m_ENCompilerJob);
         TRACE("Starting 1002 Timer\n");        SetTimer(1002,1000,NULL);
      }
   } 
   else if (nIDEvent == 1002)
   {
      TRACE("Checking EN Status\n");
      if(m_ENCompilerJob.m_Completed)
      {
         TRACE("Killing EN Timer\n");          KillTimer(1002);
         TRACE("Closing the EN Dataset\n");    m_ENSet.Close();
         //TRACE("Deleting the EN Job\n");       delete m_ENCompilerJob;

         TRACE("Opening HDSet\n");
         m_HDSet.Open(AFX_DAO_USE_DEFAULT_TYPE,NULL,dbAppendOnly|dbInconsistent);
         //TRACE("Creating HD Job\n");           m_HDCompilerJob = new CDbCompiler();
         m_HDCompilerJob.m_szInputFolder =   m_szInputFolder;
         m_HDCompilerJob.m_szOutputFolder =  m_szOutputFolder;
         m_HDCompilerJob.m_pView = m_pView;
         m_HDCompilerJob.m_pHDSet = &m_HDSet;
         m_HDCompilerJob.m_szJobToDo = "HDSet";
         m_HDCompilerJob.setAutoDelete(FALSE);
         m_HDCompilerJob.m_pDlg = (this);
         m_HDCompilerJob.execute();
         m_HDCompilerJob.m_Completed = TRUE;
         //TRACE("Adding HD Job to the Queue\n"); m_JobQ.addJob(&m_HDCompilerJob);
         
         TRACE("Starting 1003 Timer\n");        SetTimer(1003,1000,NULL);
      }
   } 
   else if (nIDEvent == 1003)
   {
      TRACE("Checking HD Status\n");
      if(m_HDCompilerJob.m_Completed)
      {
         TRACE("Killing HD Timer\n");          KillTimer(1003);
         TRACE("Closing the HD Dataset\n");    m_HDSet.Close();
         //TRACE("Deleting the HD Job\n");       delete m_HDCompilerJob;
         SetStatus("Compile Complete");
      }
   }
	
	CDialog::OnTimer(nIDEvent);
}

bool CBuildFCCDbDlg::CreateDatabase()
{
   bool bSuccess = true;

   // try  {
      CFile cf;
      CFileStatus rStatus;
      BOOL bStatus = cf.GetStatus(m_szOutputFolder,rStatus);
      
      if(bStatus)
         CFile::Remove(m_szOutputFolder);
      
      CDaoWorkspace ws;
      CDaoDatabase db(&ws);
      ASSERT_VALID(&ws);
      
      db.Create(m_szOutputFolder);
      
      CDaoTableDef td( &db );

      // ###################################
      // Start work in the EN data set now.
      // ###################################
      td.Create("EN");
      ASSERT_VALID(&td);

      td.CreateField("RecordType",             dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("UniqueSystemIdentifier", dbLong,  0, dbFixedField|dbUpdatableField);
      td.CreateField("ULSFileNumber",          dbText, 14, dbVariableField|dbUpdatableField);
      td.CreateField("EBFNumber",              dbText, 30, dbVariableField|dbUpdatableField);
      td.CreateField("CallSign",               dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("EntityType",             dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("LicenseID",              dbText,  9, dbVariableField|dbUpdatableField);
      td.CreateField("EntityName",             dbText,200, dbVariableField|dbUpdatableField);
      td.CreateField("FirstName",              dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("MI",                     dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("LastName",               dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("Suffix",                 dbText,  3, dbVariableField|dbUpdatableField);
      td.CreateField("Phone",                  dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("Fax",                    dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("Email",                  dbText, 50, dbVariableField|dbUpdatableField);
      td.CreateField("StreetAddress",          dbText, 60, dbVariableField|dbUpdatableField);
      td.CreateField("City",                   dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("State",                  dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("ZipCode",                dbText,  9, dbVariableField|dbUpdatableField);
      td.CreateField("POBox",                  dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("AttentionLine",          dbText, 35, dbVariableField|dbUpdatableField);
      td.CreateField("SGIN",                   dbText,  3, dbVariableField|dbUpdatableField);
      td.CreateField("FRN",                    dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("ApplicantTypeCode",      dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("ApplicantTypeCodeOther", dbText,  4, dbVariableField|dbUpdatableField);
      td.CreateField("StatusCode",             dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("StatusDate",             dbDate,  0, dbUpdatableField);

      CDaoIndexFieldInfo indexFieldinfo[1];
      indexFieldinfo[0].m_strName.Format("CallSign");
      indexFieldinfo[0].m_bDescending = false;

      CDaoIndexInfo indexInfo;
      indexInfo.m_strName.Format("CallSign");
      indexInfo.m_pFieldInfos = indexFieldinfo;
      indexInfo.m_nFields = 1;
      indexInfo.m_bRequired = true;
      indexInfo.m_bUnique = false;
      indexInfo.m_bPrimary = false;

      td.CreateIndex(indexInfo);
      td.Append();
      td.Close();
      
      // ###################################
      // Start work in the AM data set now.
      // ###################################
      td.Create("AM");
      td.CreateField("RecordType",              dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("UniqueSystemIdentifier",  dbLong,  0, dbFixedField|dbUpdatableField);
      td.CreateField("ULSFileNumber",           dbText, 14, dbVariableField|dbUpdatableField);
      td.CreateField("EBFNumber",               dbText, 30, dbVariableField|dbUpdatableField);
      td.CreateField("CallSign",                dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("OperatorClass",           dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("GroupCode",               dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("RegionCode",              dbSingle,0, dbFixedField|dbUpdatableField);
      td.CreateField("TrusteeCallSign",         dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("TrusteeIndicator",        dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("PhysicianCertification",  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("VESignature",             dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("SystematicCallSignChange",dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("VanityCallSignChange",    dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("VanityRelationship",      dbText, 12, dbVariableField|dbUpdatableField);
      td.CreateField("PreviousCallSign",        dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("PreviousOperatorClass",   dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("TrusteeName",             dbText, 50, dbVariableField|dbUpdatableField);

      indexFieldinfo[0].m_strName.Format("UniqueSystemIdentifier");
      indexFieldinfo[0].m_bDescending = false;

      indexInfo.m_strName.Format("UniqueSystemIdentifier");
      indexInfo.m_pFieldInfos = indexFieldinfo;
      indexInfo.m_nFields = 1;
      indexInfo.m_bRequired = true;
      indexInfo.m_bUnique = true;
      indexInfo.m_bPrimary = true;

      td.CreateIndex(indexInfo);
      td.Append();
      td.Close();
      
      // ###################################
      // Start work in the HD data set now.
      // ###################################
      td.Create("HD");
      td.CreateField("RecordType",             dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("UniqueSystemIdentifier", dbLong,  0, dbFixedField|dbUpdatableField);
      td.CreateField("ULSFileNumber",          dbText, 14, dbVariableField|dbUpdatableField);
      td.CreateField("EBFNumber",              dbText, 30, dbVariableField|dbUpdatableField);
      td.CreateField("CallSign",               dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("LicenseStatus",          dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("RadioServiceCode",       dbText,  2, dbVariableField|dbUpdatableField);
      td.CreateField("GrantDate",              dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("ExpiredDate",            dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("CancellationDate",       dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("EligibilityRuleNum",     dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("Reserved1",              dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Alien",                  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("AlienGovernment",        dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("AlienCorporation",       dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("AlienOfficer",           dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("AlienControl",           dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Revoked",                dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Convicted",              dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Adjudged",               dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Reserved2",              dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("CommonCarrier",          dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("NonCommonCarrier",       dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("PrivateComm",            dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Fixed",                  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Mobile",                 dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Radiolocation",          dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Satellite",              dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("DevelopmentalorSTA",     dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("InterconnectedService",  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("CertifierFirstName",     dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("CertifierMI",            dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("CertifierLastName",      dbText, 20, dbVariableField|dbUpdatableField);
      td.CreateField("CertifierSuffix",        dbText,  3, dbVariableField|dbUpdatableField);
      td.CreateField("CertifierTitle",         dbText, 40, dbVariableField|dbUpdatableField);
      td.CreateField("Female",                 dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("BlackorAfricanAmerican", dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("NativeAmerican",         dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Hawaiian",               dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Asian",                  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("White",                  dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("Hispanic",               dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("EffectiveDate",          dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("LastActionDate",         dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("AuctionID",              dbText,  9, dbVariableField|dbUpdatableField);
      td.CreateField("BroadcastServices1",     dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("BandManager",            dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("BroadcastServices2",     dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("AlienRuling",            dbText,  1, dbVariableField|dbUpdatableField);
      td.CreateField("LicenseeNameChange",     dbText,  1, dbVariableField|dbUpdatableField);

      indexFieldinfo[0].m_strName.Format("UniqueSystemIdentifier");
      indexFieldinfo[0].m_bDescending = false;

      indexInfo.m_strName.Format("UniqueSystemIdentifier");
      indexInfo.m_pFieldInfos = indexFieldinfo;
      indexInfo.m_nFields = 1;
      indexInfo.m_bRequired = true;
      indexInfo.m_bUnique = true;
      indexInfo.m_bPrimary = true;

      td.CreateIndex(indexInfo);
      td.Append();
      td.Close();

      db.Close();

   /* } catch (CDaoException e) {

      LPSTR lpszError = new char[100];
      e.GetErrorMessage(lpszError, 100);
      delete lpszError;
      CString szErr(lpszError);
      AfxMessageBox(szErr);

      bSuccess = false;

   } catch (CException e) {

      LPSTR lpszError = new char[100];
      e.GetErrorMessage(lpszError, 100);
      delete lpszError;
      CString szErr(lpszError);
      AfxMessageBox(szErr);

      bSuccess = false;*/
   // }

   return bSuccess;
}

void CBuildFCCDbDlg::OnCancel() 
{
   if (m_pView != NULL) {
      m_pView->PostMessage(WM_GOODBYE_FCCBUILD, IDOK);
   }
}

void CBuildFCCDbDlg::SetStatus(CString szMsg)
{
   m_szStatus = szMsg;
   UpdateData(FALSE);
}
