// CallInfoSet.cpp : implementation file
//

#include "stdafx.h"
#include "NetControl.h"
#include "CallInfoSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCallInfoSet

IMPLEMENT_DYNAMIC(CCallInfoSet, CDaoRecordset)

CCallInfoSet::CCallInfoSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CCallInfoSet)
	m_RecordType = _T("");
	m_UniqueSystemIdentifier = 0;
	m_ULSFileNumber = _T("");
	m_EBFNumber = _T("");
	m_CallSign = _T("");
	m_OperatorClass = _T("");
	m_GroupCode = _T("");
	m_RegionCode = 0.0f;
	m_TrusteeCallSign = _T("");
	m_TrusteeIndicator = _T("");
	m_PhysicianCertification = _T("");
	m_VESignature = _T("");
	m_SystematicCallSignChange = _T("");
	m_VanityCallSignChange = _T("");
	m_VanityRelationship = _T("");
	m_PreviousCallSign = _T("");
	m_PreviousOperatorClass = _T("");
	m_TrusteeName = _T("");
	m_nFields = 18;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CCallInfoSet::GetDefaultDBName()
{
	return _T("FCC97.mdb");
}

CString CCallInfoSet::GetDefaultSQL()
{
	return _T("[AM]");
}

void CCallInfoSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CCallInfoSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[RecordType]"), m_RecordType);
	DFX_Long(pFX, _T("[UniqueSystemIdentifier]"), m_UniqueSystemIdentifier);
	DFX_Text(pFX, _T("[ULSFileNumber]"), m_ULSFileNumber);
	DFX_Text(pFX, _T("[EBFNumber]"), m_EBFNumber);
	DFX_Text(pFX, _T("[CallSign]"), m_CallSign);
	DFX_Text(pFX, _T("[OperatorClass]"), m_OperatorClass);
	DFX_Text(pFX, _T("[GroupCode]"), m_GroupCode);
	DFX_Single(pFX, _T("[RegionCode]"), m_RegionCode);
	DFX_Text(pFX, _T("[TrusteeCallSign]"), m_TrusteeCallSign);
	DFX_Text(pFX, _T("[TrusteeIndicator]"), m_TrusteeIndicator);
	DFX_Text(pFX, _T("[PhysicianCertification]"), m_PhysicianCertification);
	DFX_Text(pFX, _T("[VESignature]"), m_VESignature);
	DFX_Text(pFX, _T("[SystematicCallSignChange]"), m_SystematicCallSignChange);
	DFX_Text(pFX, _T("[VanityCallSignChange]"), m_VanityCallSignChange);
	DFX_Text(pFX, _T("[VanityRelationship]"), m_VanityRelationship);
	DFX_Text(pFX, _T("[PreviousCallSign]"), m_PreviousCallSign);
	DFX_Text(pFX, _T("[PreviousOperatorClass]"), m_PreviousOperatorClass);
	DFX_Text(pFX, _T("[TrusteeName]"), m_TrusteeName);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CCallInfoSet diagnostics

#ifdef _DEBUG
void CCallInfoSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CCallInfoSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
