// DbCompiler.h: interface for the CDbCompiler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DBCOMPILER_H__92F38692_1D46_4E7E_A643_2307928CA7E7__INCLUDED_)
#define AFX_DBCOMPILER_H__92F38692_1D46_4E7E_A643_2307928CA7E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FCCDbSet.h"
#include "FCCAMSet.h"
#include "FCCHDSet.h"
#include "Job.h"
#include "ProgressCtrlST.h"

class CBuildFCCDbDlg;

class CDbCompiler : public CJob  
{
public:
	CString m_szJobToDo;
	CString m_szInputFolder;
	CString m_szOutputFolder;
	CString m_szStatus;
	CView* m_pView;
   CBuildFCCDbDlg* m_pDlg;
   //CBuildFCCDbDlg* m_pParent;

	bool ParseENRecord(CString szRecord);
	bool ParseAMRecord(CString szRecord);
	bool ParseHDRecord(CString szRecord);

	bool PopulateHDDatabase();
	bool PopulateENDatabase();
	bool PopulateAMDatabase();

	CDbCompiler();
	virtual ~CDbCompiler();
	virtual void execute();

   CFCCHDSet* m_pHDSet;
   CFCCDbSet* m_pENSet;
   CFCCAMSet* m_pAMSet;

   CProgressCtrlST m_wndProgress;

protected:
	CString	m_szAMData;
	CString	m_szENData;
	CString	m_szHDData;

};

#endif // !defined(AFX_DBCOMPILER_H__92F38692_1D46_4E7E_A643_2307928CA7E7__INCLUDED_)
