#if !defined(AFX_DOWNLOADDLG_H__7A068F9B_AF18_4708_9689_D542426829A7__INCLUDED_)
#define AFX_DOWNLOADDLG_H__7A068F9B_AF18_4708_9689_D542426829A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DownloadDlg.h : header file
//
#include "file.h"
#include "http_download.h"
#include "ProgressCtrlST.h"

#define WM_GOODBYE_DNLD WM_USER + 5

/////////////////////////////////////////////////////////////////////////////
// CDownloadMonitorg
class CDownloadMonitor : public FCTimerNotify
{
    int    m_task_id ;
    DWORD  m_start_time ;
    HWND   m_dlg ;
public:
    CDownloadMonitor (HWND hDlg, int nTaskID)
    {
        m_dlg = hDlg ;
        m_task_id = nTaskID ;
        m_start_time = GetTickCount() ;
        StartTimer(500) ;
    }

    // in milliseconds
    int GetElapseTime() const
    {
        return (int)(GetTickCount() - m_start_time) ;
    }

private:
    // Update progress
    virtual void OnHandleTimer()
    {
       TRACE("\n\n\nPOSTING MESSAGE UIS_WM_UPDATE_PROGRESS_UI\n\n\n");
        PostMessage (m_dlg, UIS_WM_UPDATE_PROGRESS_UI, (WPARAM)m_task_id, 0) ;
    }
};

/////////////////////////////////////////////////////////////////////////////
// CDownloadDlg dialog

class CDownloadDlg : public CDialog,
                     public FCHttpDownloadManager
{
public:
   CDownloadDlg(CWnd* pParent = NULL) : CDialog(IDD_DOWNLOAD, pParent)
   {
      m_tmp_data_file = FCFileEx::QueryTempFilePath() ;
   }
   ~CDownloadDlg()
   {
      DeleteFile(m_tmp_data_file) ;
   }
   BOOL GetFolder(CString* strSelectedFolder,
                  const char* lpszTitle,
                  const HWND hwndOwner, 
                  const char* strRootFolder, 
                  const char* strStartFolder);
private:
	CView* m_pView;
   //std::auto_ptr<CDownloadMonitor> m_monitor ;
   CDownloadMonitor* m_monitor;
   CString   m_tmp_data_file ;

public:
   CDownloadDlg(CView* pView);
   BOOL Create();
	CProgressCtrlST m_wndProgress;

// Construction
public:
	//CDownloadDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDownloadDlg)
	enum { IDD = IDD_DOWNLOAD };
	CProgressCtrl	m_ctrlProgress;
   CString	m_szFccUrl;
   CString	m_szFccFile;
   CString	m_szFccPath;
   CString	m_szFccFullPath;
   CString	m_szFccServer;
	CString	m_szSaveLocation;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDownloadDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDownloadDlg)
	afx_msg void OnDownloadBut();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSaveTo();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DOWNLOADDLG_H__7A068F9B_AF18_4708_9689_D542426829A7__INCLUDED_)
