// FCCDbInfo.cpp : implementation file
//

#include "stdafx.h"
#include "netcontrol.h"
#include "FCCDbInfo.h"
#include "WebRequest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFCCDbInfo dialog


CFCCDbInfo::CFCCDbInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CFCCDbInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFCCDbInfo)
	m_szAvailableDB = _T("Unknown");
	m_szCurrentDB = _T("Unknown");
	m_szStatic1 = _T("");
	m_szStatic2 = _T("");
	//}}AFX_DATA_INIT

   m_bIsFCC = true;
   m_bIsQRZ = false;
   m_szStatic1 = "Current FCC Database: ";
   m_szStatic2 = "Available FCC Database: ";
}


void CFCCDbInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFCCDbInfo)
	DDX_Text(pDX, IDC_DB_AVAILABLE, m_szAvailableDB);
	DDX_Text(pDX, IDC_DB_CURRENT, m_szCurrentDB);
	DDX_Text(pDX, IDC_STATIC1, m_szStatic1);
	DDX_Text(pDX, IDC_STATIC2, m_szStatic2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFCCDbInfo, CDialog)
	//{{AFX_MSG_MAP(CFCCDbInfo)
	ON_BN_CLICKED(IDC_CHECK_FCC, OnCheckFcc)
	ON_BN_CLICKED(IDC_CHECK_FCC, OnCheckQrz)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFCCDbInfo message handlers

void CFCCDbInfo::OnCheckQrz() 
{
	CWebRequest webRequest;
   webRequest.SetUserName("w4djw");
   webRequest.SetPassWord("yourLoginPasswordGoesHere");
   // http://www.qrz.com/dl/?f=qrz_csv_111016.zip
   webRequest.SetServer("www.qrz.com");
   webRequest.SetProcessor("dl/?f=qrz_csv_111016.zip&username=w4djw&password=yourLoginPasswordGoesHere");
   webRequest.SetPort("80");

   CString szResponse(webRequest.SubmitRequest(""));	

}

void CFCCDbInfo::OnCheckFcc() 
{
   if(m_bIsQRZ)
   {
      OnCheckQrz();
      return;
   }

	CWebRequest webRequest;
   webRequest.SetUserName("");
   webRequest.SetPassWord("");
   // http://wireless.fcc.gov/uls/index.htm?job=transaction&page=weekly
   webRequest.SetServer("wireless.fcc.gov");
   webRequest.SetProcessor("uls/index.htm?job=transaction&page=weekly");
   webRequest.SetPort("80");

   CString szResponse(webRequest.SubmitRequest(""));	

   int iLoc = szResponse.Find("l_amat.zip");
   if(iLoc != -1)
   {
      int iNote1 = szResponse.Find("note", iLoc)+6;
      int iNote2 = szResponse.Find("note", iNote1)+6;
      int iEnd1 = szResponse.Find("</", iNote1);
      int iEnd2 = szResponse.Find("</", iNote2);
      CString szSize = szResponse.Mid(iNote1,iEnd1-iNote1);
      CString szDate = szResponse.Mid(iNote2,iEnd2-iNote2);
      m_szAvailableDB.Format("%s at %s", szDate, szSize);

      CFileStatus cfStatus;
      BOOL bStatus = CFile::GetStatus("l_amat.zip",cfStatus);

      CTime t = cfStatus.m_mtime;
      m_szCurrentDB.Format("%d/%d/%d at %ld MB", t.GetMonth(), t.GetDay(), t.GetYear(), 
                                                 cfStatus.m_size/1000000L);

      UpdateData(FALSE);
   }
}

BOOL CFCCDbInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
   if(!m_bIsFCC)	
   {
      SetWindowText(m_szNewTitle);
      if(m_szNewTitle.Find("QRZ") != -1)
      {
         m_bIsQRZ = TRUE;
         GetDlgItem(IDC_CHECK_FCC)->SetWindowText(m_szCheckButtonText);
      }
   }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
