// FCCDbSet.cpp : implementation file
//

#include "stdafx.h"
#include "NetControl.h"
#include "FCCDbSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFCCDbSet

IMPLEMENT_DYNAMIC(CFCCDbSet, CDaoRecordset)

CFCCDbSet::CFCCDbSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CFCCDbSet)
	m_RecordType = _T("");
	m_UniqueSystemIdentifier = 0;
	m_ULSFileNumber = _T("");
	m_EBFNumber = _T("");
	m_CallSign = _T("");
	m_EntityType = _T("");
	m_LicenseID = _T("");
	m_EntityName = _T("");
	m_FirstName = _T("");
	m_MI = _T("");
	m_LastName = _T("");
	m_Suffix = _T("");
	m_Phone = _T("");
	m_Fax = _T("");
	m_Email = _T("");
	m_StreetAddress = _T("");
	m_City = _T("");
	m_State = _T("");
	m_ZipCode = 0;
	m_POBox = _T("");
	m_AttentionLine = _T("");
	m_SGIN = 0;
	m_FRN = _T("");
	m_ApplicantTypeCode = _T("");
	m_ApplicantTypeCodeOther = _T("");
	m_StatusCode = _T("");
	m_nFields = 26;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CFCCDbSet::GetDefaultDBName()
{
   if(m_szDBName.IsEmpty())
      return _T("FCC97.mdb");
   else
      return m_szDBName;
}

CString CFCCDbSet::GetDefaultSQL()
{
	return _T("[EN]");
}

void CFCCDbSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CFCCDbSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[RecordType]"), m_RecordType);
	DFX_Long(pFX, _T("[UniqueSystemIdentifier]"), m_UniqueSystemIdentifier);
	DFX_Text(pFX, _T("[ULSFileNumber]"), m_ULSFileNumber);
	DFX_Text(pFX, _T("[EBFNumber]"), m_EBFNumber);
	DFX_Text(pFX, _T("[CallSign]"), m_CallSign);
	DFX_Text(pFX, _T("[EntityType]"), m_EntityType);
	DFX_Text(pFX, _T("[LicenseID]"), m_LicenseID);
	DFX_Text(pFX, _T("[EntityName]"), m_EntityName);
	DFX_Text(pFX, _T("[FirstName]"), m_FirstName);
	DFX_Text(pFX, _T("[MI]"), m_MI);
	DFX_Text(pFX, _T("[LastName]"), m_LastName);
	DFX_Text(pFX, _T("[Suffix]"), m_Suffix);
	DFX_Text(pFX, _T("[Phone]"), m_Phone);
	DFX_Text(pFX, _T("[Fax]"), m_Fax);
	DFX_Text(pFX, _T("[Email]"), m_Email);
	DFX_Text(pFX, _T("[StreetAddress]"), m_StreetAddress);
	DFX_Text(pFX, _T("[City]"), m_City);
	DFX_Text(pFX, _T("[State]"), m_State);
	DFX_Long(pFX, _T("[ZipCode]"), m_ZipCode);
	DFX_Text(pFX, _T("[POBox]"), m_POBox);
	DFX_Text(pFX, _T("[AttentionLine]"), m_AttentionLine);
	DFX_Long(pFX, _T("[SGIN]"), m_SGIN);
	DFX_Text(pFX, _T("[FRN]"), m_FRN);
	DFX_Text(pFX, _T("[ApplicantTypeCode]"), m_ApplicantTypeCode);
	DFX_Text(pFX, _T("[ApplicantTypeCodeOther]"), m_ApplicantTypeCodeOther);
	DFX_Text(pFX, _T("[StatusCode]"), m_StatusCode);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CFCCDbSet diagnostics

#ifdef _DEBUG
void CFCCDbSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CFCCDbSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

void CFCCDbSet::SetDBName(CString szDBName)
{
   m_szDBName = szDBName;
}
