// FCCHDSet.cpp : implementation file
//

#include "stdafx.h"
#include "netcontrol.h"
#include "FCCHDSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFCCHDSet

IMPLEMENT_DYNAMIC(CFCCHDSet, CDaoRecordset)

CFCCHDSet::CFCCHDSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CFCCHDSet)
   m_RecordType = _T("");
   m_UniqueSystemIdentifier = 0;
   m_ULSFileNumber = _T("");
   m_EBFNumber = _T("");
   m_CallSign = _T("");
   m_LicenseStatus = _T("");
   m_RadioServiceCode = _T("");
   m_GrantDate = _T("");
   m_ExpiredDate = _T("");
   m_CancellationDate = _T("");
   m_EligibilityRuleNum = _T("");
   m_Reserved1 = _T("");
   m_Alien = _T("");
   m_AlienGovernment = _T("");
   m_AlienCorporation = _T("");
   m_AlienOfficer = _T("");
   m_AlienControl = _T("");
   m_Revoked = _T("");
   m_Convicted = _T("");
   m_Adjudged = _T("");
   m_Reserved2 = _T("");
   m_CommonCarrier = _T("");
   m_NonCommonCarrier = _T("");
   m_PrivateComm = _T("");
   m_Fixed = _T("");
   m_Mobile = _T("");
   m_Radiolocation = _T("");
   m_Satellite = _T("");
   m_DevelopmentalorSTA = _T("");
   m_InterconnectedService = _T("");
   m_CertifierFirstName = _T("");
   m_CertifierMI = _T("");
   m_CertifierLastName = _T("");
   m_CertifierSuffix = _T("");
   m_CertifierTitle = _T("");
   m_Female = _T("");
   m_BlackorAfricanAmerican = _T("");
   m_NativeAmerican = _T("");
   m_Hawaiian = _T("");
   m_Asian = _T("");
   m_White = _T("");
   m_Hispanic = _T("");
   m_EffectiveDate = _T("");
   m_LastActionDate = _T("");
   m_AuctionID = _T("");
   m_BroadcastServices1 = _T("");
   m_BandManager = _T("");
   m_BroadcastServices2 = _T("");
   m_AlienRuling = _T("");
   m_LicenseeNameChange = _T("");
	m_nFields = 50;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
   m_szDBName.Empty();
}


CString CFCCHDSet::GetDefaultDBName()
{
   if(m_szDBName.IsEmpty())
      return _T("FCC97.mdb");
   else
      return m_szDBName;
}

CString CFCCHDSet::GetDefaultSQL()
{
	return _T("[HD]");
}

void CFCCHDSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CFCCHDSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[RecordType]"),m_RecordType);
	DFX_Long(pFX, _T("[UniqueSystemIdentifier]"),m_UniqueSystemIdentifier);
	DFX_Text(pFX, _T("[ULSFileNumber]"),m_ULSFileNumber);
	DFX_Text(pFX, _T("[EBFNumber]"),m_EBFNumber);
	DFX_Text(pFX, _T("[CallSign]"),m_CallSign);
	DFX_Text(pFX, _T("[LicenseStatus]"),m_LicenseStatus);
	DFX_Text(pFX, _T("[RadioServiceCode]"),m_RadioServiceCode);
	DFX_Text(pFX, _T("[GrantDate]"),m_GrantDate);
	DFX_Text(pFX, _T("[ExpiredDate]"),m_ExpiredDate);
	DFX_Text(pFX, _T("[CancellationDate]"),m_CancellationDate);
	DFX_Text(pFX, _T("[EligibilityRuleNum]"),m_EligibilityRuleNum);
	DFX_Text(pFX, _T("[Reserved1]"),m_Reserved1);
	DFX_Text(pFX, _T("[Alien]"),m_Alien);
	DFX_Text(pFX, _T("[AlienGovernment]"),m_AlienGovernment);
	DFX_Text(pFX, _T("[AlienCorporation]"),m_AlienCorporation);
	DFX_Text(pFX, _T("[AlienOfficer]"),m_AlienOfficer);
	DFX_Text(pFX, _T("[AlienControl]"),m_AlienControl);
	DFX_Text(pFX, _T("[Revoked]"),m_Revoked);
	DFX_Text(pFX, _T("[Convicted]"),m_Convicted);
	DFX_Text(pFX, _T("[Adjudged]"),m_Adjudged);
	DFX_Text(pFX, _T("[Reserved2]"),m_Reserved2);
	DFX_Text(pFX, _T("[CommonCarrier]"),m_CommonCarrier);
	DFX_Text(pFX, _T("[NonCommonCarrier]"),m_NonCommonCarrier);
	DFX_Text(pFX, _T("[PrivateComm]"),m_PrivateComm);
	DFX_Text(pFX, _T("[Fixed]"),m_Fixed);
	DFX_Text(pFX, _T("[Mobile]"),m_Mobile);
	DFX_Text(pFX, _T("[Radiolocation]"),m_Radiolocation);
	DFX_Text(pFX, _T("[Satellite]"),m_Satellite);
	DFX_Text(pFX, _T("[DevelopmentalorSTA]"),m_DevelopmentalorSTA);
	DFX_Text(pFX, _T("[InterconnectedService]"),m_InterconnectedService);
	DFX_Text(pFX, _T("[CertifierFirstName]"),m_CertifierFirstName);
	DFX_Text(pFX, _T("[CertifierMI]"),m_CertifierMI);
	DFX_Text(pFX, _T("[CertifierLastName]"),m_CertifierLastName);
	DFX_Text(pFX, _T("[CertifierSuffix]"),m_CertifierSuffix);
	DFX_Text(pFX, _T("[CertifierTitle]"),m_CertifierTitle);
	DFX_Text(pFX, _T("[Female]"),m_Female);
	DFX_Text(pFX, _T("[BlackorAfricanAmerican]"),m_BlackorAfricanAmerican);
	DFX_Text(pFX, _T("[NativeAmerican]"),m_NativeAmerican);
	DFX_Text(pFX, _T("[Hawaiian]"),m_Hawaiian);
	DFX_Text(pFX, _T("[Asian]"),m_Asian);
	DFX_Text(pFX, _T("[White]"),m_White);
	DFX_Text(pFX, _T("[Hispanic]"),m_Hispanic);
	DFX_Text(pFX, _T("[EffectiveDate]"),m_EffectiveDate);
	DFX_Text(pFX, _T("[LastActionDate]"),m_LastActionDate);
	DFX_Text(pFX, _T("[AuctionID]"),m_AuctionID);
	DFX_Text(pFX, _T("[BroadcastServices1]"),m_BroadcastServices1);
	DFX_Text(pFX, _T("[BandManager]"),m_BandManager);
	DFX_Text(pFX, _T("[BroadcastServices2]"),m_BroadcastServices2);
	DFX_Text(pFX, _T("[AlienRuling]"),m_AlienRuling);
	DFX_Text(pFX, _T("[LicenseeNameChange]"),m_LicenseeNameChange);
   //}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CFCCHDSet diagnostics

#ifdef _DEBUG
void CFCCHDSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CFCCHDSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

void CFCCHDSet::SetDBName(CString szDBName)
{
   m_szDBName = szDBName;
}
