// HistoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetControl.h"
#include "HistoryDlg.h"
#include "NetControlSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHistoryDlg dialog


CHistoryDlg::CHistoryDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CHistoryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHistoryDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CHistoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHistoryDlg)
	DDX_Control(pDX, IDC_HISTORY_LIST, m_ctrlHistoryLst);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHistoryDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CHistoryDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
   ON_BN_CLICKED(IDC_SEE_ALL, &CHistoryDlg::OnBnClickedSeeAll)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHistoryDlg message handlers

BOOL CHistoryDlg::OnInitDialog() 
{

   m_bUnfiltered = false;

	CResizableDialog::OnInitDialog();
	
   AddAnchor(IDC_HISTORY_LIST, CSize( 0,0), CSize(99,99));
   AddAnchor(IDC_SEE_ALL, CSize(45, 99), CSize(55, 99));
   AddAnchor(IDOK, CSize( 99,99), CSize(99,99));
   AddAnchor(IDCANCEL, CSize( 99,99), CSize(99,99));
   AddAnchor(IDC_STATIC_MSG, CSize( 0,99), CSize(45,99));
	
	int colwidths[12] = { 40, 40, 80, 180, 180, 180, 180, 40, 80, 40, 40, 500 };	// sixty-fourths

	TCHAR *	lpszHeaders[] = { _T("#"),
                              _T("ID"),
      					         _T("Call"),
							         _T("Name"),
							         _T("Street"),
							         _T("Location"),
                              _T("eMail"),
							         _T("Class"),
							         _T("Date"),
							         _T("Traffic"),
							         _T("Comments"),
							         _T("Comments"),
							         NULL };
	int total_cx = 0;
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));

	// add columns
	for (int i = 0; ; i++)
	{
		if (lpszHeaders[i] == NULL)
			break;

		lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
		lvcolumn.fmt = ((i==3)||(i==4)||(i==5)||(i==11)) ? LVCFMT_LEFT : LVCFMT_CENTER;
		lvcolumn.pszText = lpszHeaders[i];
		lvcolumn.iSubItem = i;
		lvcolumn.cx = colwidths[i];
		total_cx += lvcolumn.cx;
		m_ctrlHistoryLst.InsertColumn(i, &lvcolumn);
	}

   SetTimer(UPDATE_LIST,125,NULL);

   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
   int x  = pApp->GetProfileInt(_T("WindowSettings"), _T("HistLeft"), 100);
   int y  = pApp->GetProfileInt(_T("WindowSettings"), _T("HistTop"), 100);
   int cx = pApp->GetProfileInt(_T("WindowSettings"), _T("HistRight"), 600);
   int cy = pApp->GetProfileInt(_T("WindowSettings"), _T("HistBottom"), 800);

   SetWindowPos(NULL, x,y,cx-x,cy-y, SWP_NOREDRAW);

   return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHistoryDlg::SetCallSign(CString szCallSign)
{
   m_szCallSign = szCallSign;
}

void CHistoryDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 1)
   {
      LoadOperatorList();
      KillTimer(1);
   }
	
	CResizableDialog::OnTimer(nIDEvent);
}

void CHistoryDlg::LoadOperatorList()
{
   CWaitCursor cursor; // this will automatically display a wait cursor

   m_ctrlHistoryLst.SetExtendedStyle(LVS_EX_CHECKBOXES |
                                     LVS_EX_HEADERDRAGDROP |
                                     LVS_EX_ONECLICKACTIVATE |
                                     LVS_EX_FULLROWSELECT |
                                     LVS_EX_GRIDLINES );

	m_ctrlHistoryLst.LockWindowUpdate();	// ***** lock window updates while filling list *****

   int iCurSel = m_ctrlHistoryLst.GetCurSel();
   m_ctrlHistoryLst.DeleteAllItems();

   CNetControlSet* pSet = new CNetControlSet();
   if(!m_bUnfiltered)
      pSet->m_strFilter.Format("CallSign = '%s'", m_szCallSign);

   pSet->m_strSort.Format("ID DESC");

   try {
      
      pSet->Open();
      
      int iCount = 1;
      CString szCount, szID;
      COLORREF rgb = RGB(249,249,233);
      
      for(; !pSet->IsEOF(); pSet->MoveNext())
      {
         if((pSet->GetAbsolutePosition()+1 %3) != 0)
         {
            int iRed = GetRValue(rgb);
            int iGrn = GetGValue(rgb);
            int iBlu = GetBValue(rgb);
            rgb = RGB(iGrn,iBlu,iRed);
         }
         szCount.Format("%d", iCount++);
         int iIdx = m_ctrlHistoryLst.InsertItem(iCount-1, pSet->m_CallSign);
         try {
            szID.Format("%d", pSet->m_ID); 
            m_ctrlHistoryLst.SetItemText(iIdx,0, szCount, RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,1, szID, RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,2, pSet->m_CallSign, RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,3, pSet->m_Name,     RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,4, pSet->m_Street,   RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,5, pSet->m_Location, RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,6, pSet->m_eMailAddr,RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,7, pSet->m_Class,    RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,8, pSet->m_Date.Format("%m/%d/%Y"), RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,9, pSet->m_HasTraffic ? "True" : "False", RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,10, pSet->m_HasComments? "True" : "False", RGB(0,0,0), rgb);
            m_ctrlHistoryLst.SetItemText(iIdx,11, pSet->m_Comment, RGB(0,0,0), rgb);
         }
         catch (...) {
            break;
         }
      }
   }
   catch (...) {
      AfxMessageBox("No History");
   }
   

   m_iRecordCount = pSet->GetRecordCount();

   CString szMsg;
   if(m_bUnfiltered)
      szMsg.Format("%d Occurrences of --> %s <-- found", m_iRecordCount, "*");
   else
      szMsg.Format("%d Occurrences of --> %s <-- found", m_iRecordCount, m_szCallSign);

   GetDlgItem(IDC_STATIC_MSG)->SetWindowText(szMsg);

   pSet->Close();
   delete pSet;
   pSet = NULL;

   m_ctrlHistoryLst.UnlockWindowUpdate();	// ***** unlock window updates *****
}

void CHistoryDlg::OnOK() 
{
   CRect rect;
	this->GetWindowRect(rect);
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
	
   pApp->WriteProfileInt(_T("WindowSettings"), _T("HistLeft"),   rect.left);
   pApp->WriteProfileInt(_T("WindowSettings"), _T("HistTop"),    rect.top);
   pApp->WriteProfileInt(_T("WindowSettings"), _T("HistRight"),  rect.right);
   pApp->WriteProfileInt(_T("WindowSettings"), _T("HistBottom"), rect.bottom);

   CResizableDialog::OnOK();
}


void CHistoryDlg::OnBnClickedSeeAll()
{
   if(m_bUnfiltered)
      m_bUnfiltered = false;
   else
      m_bUnfiltered = true;

   LoadOperatorList();
}
