//JobExecuter.h: interface for the CJobExecuter class.
//Author : Pradeep K Sahu
//Email : sahupk@yahoo.com
//Date  : 15-May-2003
//Note   : You are free to use the code, and modify. Provided you
//         don't remove this comments. It will be great if you can provide
//		   your feedback.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JOBEXECUTER_H__633B27FB_4A26_4ECC_AA39_8A21B09E6F36__INCLUDED_)
#define AFX_JOBEXECUTER_H__633B27FB_4A26_4ECC_AA39_8A21B09E6F36__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Job.h"
#include "MThreadedJobQ.h"
class CMThreadedJobQ;

//This class is responsible to execute the jobs. This class is asociated with 
//one theread. The thread is created in the constructed and the instace is 
//passed to the thread as the parameter. The user no need to create any 
//instce of this class and also do't need to access or use any of it's attributes
// or methods.
class CJobExecuter
{
public:
	//This function stops the Executer. Your code should not call this method.
	void stop();
	
	//This points to the CMThreadedJobQ to which this instace belongs.
	CMThreadedJobQ* m_pJobQ;

	//This contain the refarence to a instance of CJob or it's child class. 
	//The executer remains idle if this is NULL. That is when no job to do.
	CJob* m_pJob2Do;
	
	//This is used as a Flag. Two defind constats are
	//defined for this variable, they are  STOP_WORKING (Value is  -1),  
	//KEEP_WORKING (value is  0 ). If the m_flaag value is set to STOP_WORKING then 
	//the thread associated with the instance exists, else that thread is keep working.
	int m_flag;
	
	//This pointer keep a reference to the thread that
	//is associated with the class.
	CWinThread* m_pExecuterThread;

	//This operation is responsible for executing a job. The CMThreadedJobQ 
	//class will call this function to get a job done. User should not call 
	//this method, this is only for the use of the implementation of the
	//multithreaded job queue.
	void execute(CJob* pJob);

	//This is the static thread function. This function is used while 
	//creating the thread in the constructor.
	static UINT ThreadFunction(LPVOID pParam);

	//Constructor
	CJobExecuter(CMThreadedJobQ *pJobQ);
	
	virtual ~CJobExecuter();

};

#endif // !defined(AFX_JOBEXECUTER_H__633B27FB_4A26_4ECC_AA39_8A21B09E6F36__INCLUDED_)
