// LeftView.cpp : implementation of the CLeftView class
//

#include "stdafx.h"
#include "NetControl.h"

#include "NetControlDoc.h"
#include "NetControlView.h"
#include "LeftView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CTreeView)

BEGIN_MESSAGE_MAP(CLeftView, CTreeView)
	//{{AFX_MSG_MAP(CLeftView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)

	ON_BN_CLICKED(IDC_FCC_CHECK, OnFccCheck)
	ON_BN_CLICKED(IDC_FCC_DOWNLOAD, OnFccDownload)
	ON_BN_CLICKED(IDC_FCC_EXTRACT, OnFccExtract)
	ON_BN_CLICKED(IDC_FCC_COMPILE, OnFccCompile)

   ON_BN_CLICKED(IDC_QRZ_CHECK, OnQrzCheck)
	ON_BN_CLICKED(IDC_QRZ_DOWNLOAD, OnQrzDownload)
	ON_BN_CLICKED(IDC_QRZ_EXTRACT, OnQrzExtract)
	ON_BN_CLICKED(IDC_QRZ_COMPILE, OnQrzCompile)

   ON_BN_CLICKED(IDC_UPLOAD_BRARS, OnUploadBrars)
   ON_BN_CLICKED(IDC_UPLOAD_AUTO, OnUploadAuto)
   ON_BN_CLICKED(IDC_REVERSE, OnUploadReverse)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_EDIT_GOHOME, OnEditGohome)
	ON_COMMAND(ID_VIEW_FCCDBSTATUS, OnViewFccdbstatus)
	ON_COMMAND(ID_RECORD_PURGE, OnRecordPurge)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeftView construction/destruction

CLeftView::CLeftView()
   : m_theTree(GetTreeCtrl())
{
	m_pImageList = new CImageList();
}

CLeftView::~CLeftView()
{
   if(m_pImageList != NULL)
   {
      m_pImageList->DeleteImageList();
   }
}

BOOL CLeftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CLeftView drawing

void CLeftView::OnDraw(CDC* pDC)
{
	CNetControlDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}


void CLeftView::OnInitialUpdate()
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
   int i = 0, j = 0, k = 0;
	CStringArray aszDates;
   COleDateTimeSpan dts;
   dts.SetDateTimeSpan(MAX_TREE_SIZE/2,0,0,0);
   COleDateTime cdt = COleDateTime::GetCurrentTime() - dts;
   dts.SetDateTimeSpan(1,0,0,0);

	CBitmap bitmap;
	m_pImageList->Create(16, 16, ILC_COLOR24|ILC_MASK, 6, 4);

	bitmap.LoadBitmap(IDB_BEFORE);
	m_pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

   bitmap.LoadBitmap(IDB_BEFORE_SEL);
	m_pImageList->Add(&bitmap, (COLORREF)0x000000);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_CURRENT);
	m_pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_CURRENT_SEL);
	m_pImageList->Add(&bitmap, (COLORREF)0x000000);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_AFTER);
	m_pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_AFTER_SEL);
	m_pImageList->Add(&bitmap, (COLORREF)0x000000);
	bitmap.DeleteObject();
	
   VERIFY(m_theTree.DeleteAllItems());

   for(i = 0; i < MAX_TREE_SIZE; i++)
   {
      CString szDate = cdt.Format("%Y %m %d");
      aszDates.InsertAt(i,szDate);
      m_treeItems[i].item.hItem = NULL;
      cdt += dts;
   }

   CTreeView::OnInitialUpdate();
   HTREEITEM hItem = NULL;
	HTREEITEM hItemParent = NULL;
	m_theTree.SetImageList(m_pImageList, TVSIL_NORMAL);

	for(i = 0; i < aszDates.GetSize(); i++) {

		m_treeItems[i].hParent = TVI_ROOT;
		m_treeItems[i].hInsertAfter = TVI_SORT;
		m_treeItems[i].item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT;
		CString szTemp = aszDates.GetAt(i);
		m_treeItems[i].item.pszText = szTemp.GetBuffer();
		m_treeItems[i].item.hItem = m_theTree.InsertItem(aszDates.GetAt(i));
      
      if(i == MAX_TREE_SIZE/2)
      {
         hItem = m_treeItems[i].item.hItem;
         m_theTree.SelectItem(hItem);
      }
	}

   m_theTree.Select(hItem,TVGN_FIRSTVISIBLE);

	long lStyleOld;
	long lStyleMask = TVS_SHOWSELALWAYS | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT;
	BOOL bSetBits = TRUE;
	
	lStyleOld = GetWindowLong(m_hWnd, GWL_STYLE);
	lStyleOld &= ~lStyleMask;
	if (bSetBits)
		lStyleOld |= lStyleMask;
	
	SetWindowLong(m_hWnd, GWL_STYLE, lStyleOld);
	m_theTree.SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER);

	for(i = 0; i < aszDates.GetSize(); i++) {
      if(i < MAX_TREE_SIZE/2)
         m_theTree.SetItemImage(m_treeItems[i].item.hItem,0,1);
      else if(i == MAX_TREE_SIZE/2) 
         m_theTree.SetItemImage(m_treeItems[i].item.hItem,2,3);
      else 
         m_theTree.SetItemImage(m_treeItems[i].item.hItem,4,5);
   }
   int iVisibleCount = m_theTree.GetVisibleCount();
   m_theTree.EnsureVisible(m_treeItems[(MAX_TREE_SIZE/2)-(iVisibleCount/2)].item.hItem);	
   pApp->m_pLeftView = this;
}

/////////////////////////////////////////////////////////////////////////////
// CLeftView diagnostics

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CNetControlDoc* CLeftView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNetControlDoc)));
	return (CNetControlDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLeftView message handlers

void CLeftView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

   HTREEITEM theSelection = m_theTree.GetSelectedItem();
   CString szSelectedDate(m_theTree.GetItemText(theSelection));

   GetDocument()->m_szSelectedDate = szSelectedDate;
   if(pApp->m_pView)
   {
      TRACE("LeftView:: Setting Significant Event to TRUE...\n");
      pApp->m_pView->SelectDay(szSelectedDate);
      pApp->m_pView->OnUpdate(this,NULL,NULL);
		pApp->m_pView->UpdateStartGroup();
   }

	*pResult = 0;
}

void CLeftView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
   int iVisibleCount = m_theTree.GetVisibleCount();
   m_theTree.EnsureVisible(m_treeItems[(MAX_TREE_SIZE/2)-(iVisibleCount/2)].item.hItem);	
}

void CLeftView::OnFileNew() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->m_ctrlCall.SetFocus();
	pApp->m_pView->PostMessage(ID_FILE_NEW);
}

void CLeftView::OnFileSave() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->m_ctrlCall.SetFocus();
	pApp->m_pView->PostMessage(ID_FILE_SAVE);
}

void CLeftView::OnEditGohome() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->m_ctrlCall.SetFocus();
	pApp->m_pView->m_ctrlCall.SetSel(0,-1,TRUE);

}

bool CLeftView::SelectDay(CString szDay)
{
   bool bSuccess = false;
   int iTreeSize = m_theTree.GetCount();

   for (int i = 0; i < iTreeSize; i++)
   {
      HTREEITEM hItem = m_treeItems[i].item.hItem;
      CString szDate(m_theTree.GetItemText(hItem));
      if(szDate.Compare(szDay) == 0)
      {
         m_theTree.SelectItem(hItem);
         m_theTree.EnsureVisible(hItem);
         bSuccess = true;
         break;
      }
   }
   return bSuccess;
}

void CLeftView::OnFccDownload() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallFCCDownload();
}

void CLeftView::OnFccExtract() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallFCCExtract();
}

void CLeftView::OnFccCompile() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallFCCCompile();
}

void CLeftView::OnUploadBrars()
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallUploadBrars();
}

/*************************/
/****************************/
/*************************/

void CLeftView::OnQrzDownload() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallQrzDownload();
}

void CLeftView::OnQrzExtract() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallQrzExtract();
}

void CLeftView::OnQrzCompile() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallQrzCompile();
}

void CLeftView::OnQrzCheck() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallQrzCheck();
}

/*************************/
/****************************/
/*************************/


void CLeftView::OnUploadReverse()
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallUploadReverse();
}

void CLeftView::OnUploadAuto()
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallUploadAuto();
}

void CLeftView::OnViewFccdbstatus() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallFccdbstatus();
}

void CLeftView::OnFccCheck() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallFccCheck();
}

void CLeftView::OnRecordPurge() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	pApp->m_pView->CallRecordPurge();
}
