// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "NetControl.h"

#include "MainFrm.h"
#include "LeftView.h"
#include "NetControlView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_PROGRESS,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_lpRect = new RECT;
}

CMainFrame::~CMainFrame()
{
#ifndef _DEBUG
   if(m_lpRect != NULL)
      delete m_lpRect;
#endif

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create mainframe toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create mainframe dialogbar\n");
		return -1;		// fail to create
	}


   /*
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_UPLOAD))
	{
		TRACE0("Failed to create upload toolbar\n");
		return -1;      // fail to create
	}
   */
	/*
	if (!m_wndDlgBar2.Create(this, IDR_UPLOAD, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create upload dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndDlgBar3.Create(this, IDR_QRZDATABASE, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create QRZ Database Dialog Bar\n");
		return -1;		// fail to create
	}
	*/
	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar)  /* ||
		!m_wndReBar.AddBar(&m_wndDlgBar3) ||
      !m_wndReBar.AddBar(&m_wndDlgBar2) */)
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

   try {
      LoadBarState(_T("NetControlApp"));
   }
   catch (...)
   {
   }

   return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	// create splitter window
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CLeftView), CSize(125, 100), pContext) ||
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CNetControlView), CSize(125, 100), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}

	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

   if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

   cs.x  = pApp->GetProfileInt(_T("WindowSettings"), _T("TopLeftX"), 200);
   cs.y  = pApp->GetProfileInt(_T("WindowSettings"), _T("TopLeftY"), 100);
   cs.cx = pApp->GetProfileInt(_T("WindowSettings"), _T("SizeX"), 875);
   cs.cy = pApp->GetProfileInt(_T("WindowSettings"), _T("SizeY"), 700);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnClose() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

   int startx, starty, endx, endy;

   GetWindowRect(m_lpRect);
	SaveBarState(_T("NetControlApp"));

   startx = m_lpRect->left;
   starty = m_lpRect->top;
   endx   = m_lpRect->right - m_lpRect->left;
   endy   = m_lpRect->bottom - m_lpRect->top;

   if(startx >= -4 && startx < 2000)
   {
      if(starty >= -4 && starty < 2000)
      {
         if(endx > 0 && endx < 2000)
         {
            if(endy > 0 && endy < 2000)
            {
               pApp->WriteProfileInt(_T("WindowSettings"), _T("TopLeftX"), startx);
               pApp->WriteProfileInt(_T("WindowSettings"), _T("TopLeftY"), starty);
               pApp->WriteProfileInt(_T("WindowSettings"), _T("SizeX"),    endx);
               pApp->WriteProfileInt(_T("WindowSettings"), _T("SizeY"),    endy);
            }
         }
      }
   }

	CFrameWnd::OnClose();
}
