// NetControlSet.cpp : implementation of the CNetControlSet class
//

#include "stdafx.h"
#include "NetControl.h"
#include "NetControlSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNetControlSet implementation

IMPLEMENT_DYNAMIC(CNetControlSet, CDaoRecordset)

CNetControlSet::CNetControlSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CNetControlSet)
	m_ID = 0;
	m_CallSign = _T("");
	m_Name = _T("");
	m_Street = _T("");
	m_Location = _T("");
	m_Comment = _T("");
	m_Date = (DATE)0;
	m_HasComments = FALSE;
	m_HasTraffic = FALSE;
	m_Acknowledged = FALSE;
	m_Class = _T("");
	m_YourGrid = _T("");
	m_eMailAddr = _T("");
	m_nFields = 13;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CNetControlSet::GetDefaultDBName()
{
	return _T("NetControl-97.mdb");
}


CString CNetControlSet::GetDefaultSQL()
{
	return _T("[NetControlTab]");
}

void CNetControlSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CNetControlSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[ID]"), m_ID);
	DFX_Text(pFX, _T("[CallSign]"), m_CallSign);
	DFX_Text(pFX, _T("[Name]"), m_Name);
	DFX_Text(pFX, _T("[Street]"), m_Street);
	DFX_Text(pFX, _T("[Location]"), m_Location);
	DFX_Text(pFX, _T("[Comment]"), m_Comment);
	DFX_DateTime(pFX, _T("[Date]"), m_Date);
	DFX_Bool(pFX, _T("[HasComments]"), m_HasComments);
	DFX_Bool(pFX, _T("[HasTraffic]"), m_HasTraffic);
	DFX_Bool(pFX, _T("[Acknowledged]"), m_Acknowledged);
	DFX_Text(pFX, _T("[Class]"), m_Class);
	DFX_Text(pFX, _T("[YourGrid]"), m_YourGrid);
	DFX_Text(pFX, _T("[eMailAddr]"), m_eMailAddr);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CNetControlSet diagnostics

#ifdef _DEBUG
void CNetControlSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CNetControlSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
