// NetControlView.cpp : implementation of the CNetControlView class
//

#include "stdafx.h"
#include "NetControl.h"

#include "LeftView.h"
#include "NetControlSet.h"
#include "NetControlDoc.h"
#include "BlastEmailDlg.h"
#include "NetControlView.h"
#include "FileDialogST.h"
#include "WaveFileDlg.h"
#include "MainFrm.h"
#include "WebRequest.h"
#include "WebPageParser.h"
#include "HistoryDlg.h"
#include "ZipArchive.h"
#include "UploadLog.h"
#include "FCCDbInfo.h"
#include "BuildFCCDbDlg.h"
#include "QRZCDb.h"

#include "fourier.h"
#include <math.h>
#include <process.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNetControlView

IMPLEMENT_DYNCREATE(CNetControlView, CResizableDaoRecordView)

BEGIN_MESSAGE_MAP(CNetControlView, CResizableDaoRecordView)
   ON_MESSAGE(WM_GOODBYE_DNLD, OnGoodbyeDnld)
   ON_MESSAGE(WM_GOODBYE_FCCBUILD, OnGoodbyeFccBuild)
   //{{AFX_MSG_MAP(CNetControlView)
   ON_BN_CLICKED(IDC_RECORD, OnRecord)
   ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
   ON_COMMAND(ID_EDIT_CUT, OnEditCut)
   ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
   ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
   ON_COMMAND(ID_FILE_NEW, OnFileNew)
   ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
   ON_COMMAND(ID_FILE_SAVE, OnFileSave)
   ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
   ON_BN_CLICKED(IDC_QRZ_LOOKUP, OnQrzLookup)
   ON_BN_CLICKED(IDC_FCC_LOOKUP, OnFccLookup)

   ON_BN_CLICKED(IDC_FCC_CHECK, OnFccCheck)
   ON_BN_CLICKED(IDC_FCC_DOWNLOAD, OnFccDownload)
   ON_BN_CLICKED(IDC_FCC_EXTRACT, OnFccExtract)
   ON_BN_CLICKED(IDC_FCC_COMPILE, OnFccCompile)

   ON_BN_CLICKED(IDC_QRZ_CHECK, OnQrzCheck)
   ON_BN_CLICKED(IDC_QRZ_DOWNLOAD, OnQrzDownload)
   ON_BN_CLICKED(IDC_QRZ_EXTRACT, OnQrzExtract)
   ON_BN_CLICKED(IDC_QRZ_COMPILE, OnQrzCompile)

   ON_BN_CLICKED(IDC_UPLOAD_BRARS, OnUploadBrars)
   ON_BN_CLICKED(IDC_UPLOAD_AUTO, OnUploadAuto)
   ON_BN_CLICKED(IDC_REVERSE, OnUploadReverse)
   ON_COMMAND(ID_RECORD_DELETE, OnRecordDelete)
   ON_COMMAND(ID_RECORD_FIRST, OnRecordFirst)
   ON_COMMAND(ID_RECORD_PREV, OnRecordPrev)
   ON_COMMAND(ID_RECORD_NEXT, OnRecordNext)
   ON_COMMAND(ID_RECORD_LAST, OnRecordLast)
   ON_WM_HSCROLL()
   ON_NOTIFY(NM_RCLICK, IDC_OPERATOR_LIST, OnRclickOperatorList)
   ON_NOTIFY(NM_CLICK, IDC_OPERATOR_LIST, OnClickOperatorList)
   ON_WM_TIMER()
   ON_EN_CHANGE(IDC_CALL, OnChangeCall)
   ON_LBN_SELCHANGE(IDC_LOCAL_LIST, OnSelchangeLocalList)
   ON_EN_CHANGE(IDC_FIND, OnChangeFind)
   ON_BN_CLICKED(IDC_SOUND, OnSound)
   ON_BN_CLICKED(IDC_PHONICS, OnPhonics)
   ON_NOTIFY(LVN_KEYDOWN, IDC_OPERATOR_LIST, OnKeydownOperatorList)
   ON_NOTIFY(LVN_KEYDOWN, IDC_CALL, OnKeydownCallSign)
   ON_BN_CLICKED(IDC_HISTORY, OnHistory)
   ON_NOTIFY(NM_DBLCLK, IDC_OPERATOR_LIST, OnDblclkOperatorList)
   ON_COMMAND(ID_EDIT_GOHOME, OnEditGohome)
   ON_WM_CTLCOLOR()
   ON_COMMAND(ID_EDIT_SEL_MATCH1, OnEditSelMatch1)
   ON_COMMAND(ID_EDIT_SEL_MATCH2, OnEditSelMatch2)
   ON_COMMAND(ID_EDIT_SEL_MATCH3, OnEditSelMatch3)
   ON_WM_VSCROLL()
   ON_BN_CLICKED(IDC_LOCAL_LOOKUP, OnLocalLookup)
   ON_BN_CLICKED(IDC_CLEAR, OnClear)
   ON_COMMAND(ID_FILE_EXPORT_TXT, OnFileExportTxt)
   ON_COMMAND(ID_FILE_FULL_EXPORT, OnFileFullExport)
   ON_EN_KILLFOCUS(IDC_MY_GRID, OnKillfocusMyGrid)
   ON_NOTIFY(MCN_SELCHANGE, IDC_CALENDAR, OnSelchangeCalendar)
   ON_NOTIFY(MCN_SELECT, IDC_CALENDAR, OnSelectCalendar)
   ON_BN_CLICKED(IDC_BLAST_EMAIL, OnBlastEmail)
   ON_COMMAND(ID_EDIT_CAMELCASE, OnEditCamelcase)
   ON_COMMAND(ID_VIEW_FCCDBSTATUS, OnViewFccdbstatus)
   ON_BN_CLICKED(IDC_NEW_ENTRY, OnFileNew)
   ON_BN_CLICKED(IDC_UPDATE_ENTRY, OnFileSave)
   ON_COMMAND(ID_FILE_EXPORT_TXT, OnFileExportTxt)
   ON_COMMAND(ID_RECORD_PURGE, OnRecordPurge)
   ON_COMMAND(ID_RECORD_EMPTYDATABASE, OnEmptyDatabase)
   ON_BN_CLICKED(IDC_TRANSMIT, OnBnClickedTransmit)
   ON_BN_CLICKED(IDC_PRENET_REFRESH, OnBnClickedPrenetRefresh)
    //}}AFX_MSG_MAP

   ON_COMMAND_RANGE(IDC_M_PLACE1, IDC_M_PLACE6, OnChangePlace)   

   //ON_BN_CLICKED(IDC_SHOW_GRAPH, OnShowGraph)
   //ON_LBN_SELCHANGE(IDC_GRAPH, OnSelchangeGraph)

    ON_NOTIFY(NM_DBLCLK, IDC_PRENET_LIST, &CNetControlView::OnNMDblclkPrenetList)
    ON_EN_CHANGE(IDC_PRENET_URL, &CNetControlView::OnEnChangePrenetUrl)
    ON_BN_CLICKED(IDC_NET_REPORT, &CNetControlView::OnBnClickedNetReport)
    ON_BN_CLICKED(IDC_MOVE_ALL, &CNetControlView::OnBnClickedMoveAll)
   ON_BN_CLICKED(IDC_ECHO_REFRESH, &CNetControlView::OnBnClickedEchoRefresh)
   ON_LBN_DBLCLK(IDC_ECHO_LOGINS, &CNetControlView::OnLbnDblclkEchoLogins)
   ON_BN_CLICKED(IDC_FIND_CLEAR, &CNetControlView::OnBnClickedFindClear)
END_MESSAGE_MAP()

inline double GetFrequencyIntensity(double re, double im)
{
   return sqrt((re*re)+(im*im));
}

BOOL Process(void* lpData, LPWAVEHDR pwh)
{
#define FFT_LEN 1024
   double fin[FFT_LEN],fout[FFT_LEN],foutimg[FFT_LEN],fdraw[FFT_LEN/2];
   for (DWORD dw = 0; dw < FFT_LEN; dw++)
   {
      {
         //copy audio signal to fft real component.
         fin[dw] = (double)((short*)pwh->lpData)[dw];
      }
   }
   fft_double(FFT_LEN,0,fin,NULL,fout,foutimg);
   float re,im;
   for(int i=0;i<FFT_LEN/2;i++)
   {
      re = (float)fout[i];
      im = (float)foutimg[i];
      //get frequency intensity and scale to 0..256 range
      //fdraw[i]=(GetFrequencyIntensity(re,im))/256;
      fdraw[i]=((sqrt((re*re)+(im*im))))/256;
   }
   CFrequencyGraph* pPeak = (CFrequencyGraph*)lpData;
   if (::IsWindow(pPeak->GetSafeHwnd()))
      pPeak->Update(FFT_LEN/2,fdraw);
   return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CNetControlView construction/destruction

CNetControlView::CNetControlView()
   : CResizableDaoRecordView(CNetControlView::IDD)
   , m_bTransmitToggle(false)
   , m_szRemoteTX(_T("piEcho2"))
   , m_szPrenetURL(_T("brars.ham-radio-op.net"))
   , m_szEchoRefInt(_T("5"))
{
   //{{AFX_DATA_INIT(CNetControlView)
   m_pSet = NULL;
   m_iMyPlaceInd = 0;
	m_szMyGrid = _T("");
	m_szDistance = _T("");
	m_Time = COleDateTime::GetCurrentTime();
	//}}AFX_DATA_INIT
   // TODO: add construction code here
   m_pRec = NULL;
   m_pFrame = NULL;
   m_bDisableCallMonitor = false;
   m_bWasBackSpaceKey = false;
   m_lAbsolutePosition = -1;
   m_pMonWave = NULL;
   m_hMixer = NULL;
   m_pFCCDbSet = NULL;
   m_bRecordSession = false;
   m_iDayLab = IDC_M_PLACE1;
   m_bPerformFullExport = false;
   //m_bSignificantEvent = TRUE;

   char szPath[512];
   _getcwd(szPath,_MAX_PATH);
   m_szHome.Format("%s", szPath);
   m_bUploadReverse = false;
   m_bUploadAuto    = false;

   COleDateTime cdt = COleDateTime::GetCurrentTime();
   m_szSelectedDate = cdt.Format("%Y %m %d");
   m_pDownloadDlg   = new CDownloadDlg(this);
}

CNetControlView::~CNetControlView()
{
   delete m_pDownloadDlg;
}

void CNetControlView::DoDataExchange(CDataExchange* pDX)
{
   CResizableDaoRecordView::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CNetControlView)
   DDX_Control(pDX, IDC_CALENDAR, m_ctrlCalendar);
   DDX_Control(pDX, IDC_VOLUME, m_ctrlVolume);
   DDX_Control(pDX, IDC_FIND, m_ctrlFind);
   DDX_Control(pDX, IDC_LOCAL_LIST, m_ctrlLocalList);
   DDX_Control(pDX, IDC_SOUND, m_bSound);
   DDX_Control(pDX, IDC_PHONICS, m_bPhonics);
   DDX_Control(pDX, IDC_NEW_ENTRY, m_bFileNew);
   DDX_Control(pDX, IDC_UPDATE_ENTRY, m_bFileSave);
   DDX_Control(pDX, IDC_RECORD, m_bRecord);
   DDX_Control(pDX, IDC_BLAST_EMAIL, m_bMail);
   DDX_Control(pDX, IDC_TRANSMIT, m_buttonTransmit);
   //DDX_Control(pDX, IDC_PRENET_REFRESH, m_buttonRefreshPrenet);
   DDX_Control(pDX, IDC_CALL, m_ctrlCall);
   DDX_Control(pDX, IDC_OPERATOR_LIST, m_ctrlOperatorList);
   DDX_Control(pDX, IDC_SLIDER1, m_ctrlSlider1);
   DDX_Control(pDX, IDC_DATE, m_ctrlSelectedDate);
   DDX_Radio(pDX, IDC_M_PLACE1, m_iMyPlaceInd);
   DDX_Text(pDX, IDC_MY_GRID, m_szMyGrid);
   DDX_Text(pDX, IDC_STATIC_DISTANCE, m_szDistance);
   DDX_FieldText(pDX, IDC_CALL, m_pSet->m_CallSign, m_pSet);
   DDX_FieldText(pDX, IDC_NAME, m_pSet->m_Name, m_pSet);
   DDX_FieldText(pDX, IDC_STREET, m_pSet->m_Street, m_pSet);
   DDX_FieldText(pDX, IDC_LOCATION, m_pSet->m_Location, m_pSet);
   DDX_Text(pDX, IDC_COMMENT, m_pSet->m_Comment);
   DDX_Text(pDX, IDC_REMOTE_TX, m_szRemoteTX);
   DDX_Text(pDX, IDC_PRENET_URL, m_szPrenetURL);
   DDX_DateTimeCtrl(pDX, IDC_DATE, m_pSet->m_Date);
   DDX_FieldText(pDX, IDC_CLASS, m_pSet->m_Class, m_pSet);
   DDX_Control(pDX, IDC_CLOCKFRAME, m_Clock);
   DDX_FieldText(pDX, IDC_YOUR_GRID, m_pSet->m_YourGrid, m_pSet);
   DDX_FieldText(pDX, IDC_EMAIL_ADDRESS, m_pSet->m_eMailAddr, m_pSet);
   DDX_DateTimeCtrl(pDX, IDC_TIME, m_Time);
   //}}AFX_DATA_MAP
   //DDX_Control(pDX, IDC_GRAPH, m_ctrlGraph);
   DDX_Control(pDX, IDC_REMOTE_TX, m_ctlRemoteTX);
   DDX_Control(pDX, IDC_PRENET_LIST, m_ctrlPreNetCkList);
   DDX_Control(pDX, IDC_TIME, m_ctrTime);
   DDX_Control(pDX, IDC_ECHO_LOGINS, m_ctrlEchoLogins);
   DDX_Control(pDX, IDC_ECHO_REFRESH, m_ctrlEchoRefresh);
   DDX_Text(pDX, IDC_ECHO_INTERVAL, m_szEchoRefInt);
}

BOOL CNetControlView::PreCreateWindow(CREATESTRUCT& cs)
{
   // TODO: Modify the Window class or styles here by modifying
   //  the CREATESTRUCT cs

   return CResizableDaoRecordView::PreCreateWindow(cs);
}

void CNetControlView::OnInitialUpdate()
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
   pApp->m_pView = this;
   m_pSet = &GetDocument()->m_netControlSet;
   m_pSet->m_strSort.Format("ID");

   m_szMyGrid = pApp->GetProfileString(_T("UserSetting"), _T("MyGrid"), "");

   AddAnchor(IDC_CALL,           CSize( 0,0), CSize( 0,0));

   AddAnchor(IDC_LOCAL_LOOKUP,   CSize( 0,0), CSize(15,0));
   AddAnchor(IDC_CLEAR,          CSize( 0,0), CSize(15,0));
   AddAnchor(IDC_NEW_ENTRY,      CSize( 0,0), CSize(15,0));
   AddAnchor(IDC_UPDATE_ENTRY,   CSize( 0,0), CSize(15,0));

   AddAnchor(IDC_STATIC_NAME,    CSize(15,0), CSize(15,0));     /* #1 */
   AddAnchor(IDC_NAME,           CSize(15,0), CSize(20,0));
   
   AddAnchor(IDC_STATIC_PRENET,  CSize(30, 0), CSize(100,0));
   AddAnchor(IDC_CLOCKFRAME,     CSize(100,0), CSize(100,0));
   AddAnchor(IDC_STATIC_DISTANCE,CSize(100,0), CSize(100,0));
   AddAnchor(IDC_BLAST_EMAIL,    CSize(100,0), CSize(100,0));
   AddAnchor(IDC_TRANSMIT,       CSize(100,0), CSize(100,0));
   AddAnchor(IDC_REMOTE_TX,      CSize(100,0), CSize(100,0));
   AddAnchor(IDC_ECHO_LOGINS,    CSize(100,0), CSize(100,0));
   AddAnchor(IDC_ECHO_INTERVAL,  CSize(100,0), CSize(100,0));
   AddAnchor(IDC_ECHO_REFRESH,   CSize(100,0), CSize(100,0));
   AddAnchor(IDC_ECHO_UNIT,      CSize(100,0), CSize(100,0));
   AddAnchor(IDC_ECHO_INSTR,     CSize(100,0), CSize(100,0));

   AddAnchor(IDC_LOCAL_LIST,     CSize( 0,0), CSize( 0,0));

   AddAnchor(IDC_STATIC_STRT,    CSize(15,0), CSize(15,0));     /* #2 */
   AddAnchor(IDC_STREET,         CSize(15,0), CSize(20,0));
   AddAnchor(IDC_STATIC_LOC,     CSize(15,0), CSize(15,0));     /* #3 */
   AddAnchor(IDC_LOCATION,       CSize(15,0), CSize(20,0));

   AddAnchor(IDC_PRENET_URL,     CSize(30, 0), CSize(100, 0));
   AddAnchor(IDC_PRENET_LIST,    CSize(30, 0), CSize(100, 0));
   AddAnchor(IDC_PRENET_REFRESH, CSize(30, 0), CSize(100, 0));
   AddAnchor(IDC_NET_REPORT,     CSize(30, 0), CSize(100, 0));

   AddAnchor(IDC_STATIC_DATE,    CSize(15,0), CSize(15,0));     /* #4 */
   AddAnchor(IDC_DATE,           CSize(15,0), CSize(20,0));

   AddAnchor(IDC_STATIC_TIME,    CSize( 0,0), CSize(15,0));
   AddAnchor(IDC_TIME,           CSize(15,0), CSize(20,0));

   AddAnchor(IDC_STATIC_EMAIL,   CSize( 0,0), CSize(15,0));
   AddAnchor(IDC_EMAIL_ADDRESS,  CSize(15,0), CSize(20,0));

   AddAnchor(IDC_STATIC_CLASS,   CSize( 0,0), CSize(12,0));
   AddAnchor(IDC_CLASS,          CSize(15,0), CSize(16,0));

   AddAnchor(IDC_STATIC_MYGRID,  CSize(16,0), CSize(17,0));
   AddAnchor(IDC_MY_GRID,        CSize(17,0), CSize(18,0));

   AddAnchor(IDC_STATIC_YOURGRID,CSize(18,0), CSize(19,0));
   AddAnchor(IDC_YOUR_GRID,      CSize(19,0), CSize(20,0));

   AddAnchor(IDC_STATIC_VOL,     CSize(0,0), CSize(0,0));
   AddAnchor(IDC_VOLUME,         CSize(0,0), CSize(20,0));

   AddAnchor(IDC_RECORD,         CSize(20,0), CSize(20,0));
   AddAnchor(IDC_SOUND,          CSize(20,0), CSize(20,0));
   AddAnchor(IDC_PHONICS,        CSize(20,0), CSize(20,0));

   AddAnchor(IDC_M_PLACE1,       CSize(20,0), CSize(25,0));
   AddAnchor(IDC_M_PLACE2,       CSize(20,0), CSize(25,0));
   AddAnchor(IDC_M_PLACE3,       CSize(20,0), CSize(25,0));
   AddAnchor(IDC_M_PLACE4,       CSize(20,0), CSize(25,0));
   AddAnchor(IDC_M_PLACE5,       CSize(20,0), CSize(25,0));
   AddAnchor(IDC_M_PLACE6,       CSize(20,0), CSize(25,0));

   AddAnchor(IDC_CALL_01,        CSize(0, 0), CSize(50,0));

   AddAnchor(IDC_MOVE_ALL,       CSize(20,0), CSize(30,0));
   //AddAnchor(IDC_SHOW_GRAPH,   CSize(30,0), CSize(30,0));
   //AddAnchor(IDC_GRAPH,        CSize(30,0), CSize(30,0));
   AddAnchor(IDC_CALENDAR,       CSize(20,0), CSize(30,0));

   AddAnchor(IDC_COMMENT,        CSize( 0,0), CSize(20,0));

   AddAnchor(IDC_FCC_LOOKUP,     CSize( 0,0), CSize( 0,0));
   AddAnchor(IDC_QRZ_LOOKUP,     CSize( 0,0), CSize( 0,0)); 

   AddAnchor(IDC_SLIDER1,        CSize( 0,0), CSize(20,0));

   AddAnchor(IDC_OPERATOR_LIST,  CSize( 0,0), CSize(99,99));

   m_bSound.SubclassDlgItem( IDC_SOUND, GetParent());
   m_bSound.SetIcon( IDR_SOUND, 16, 16 );
   m_bSound.SetImagePos(CPoint(6, SXBUTTON_CENTER ));
   m_bSound.SetTextPos(CPoint(30, SXBUTTON_CENTER ));
   
   m_bMail.SubclassDlgItem( IDC_BLAST_EMAIL, GetParent());
   m_bMail.SetIcon( IDR_MAIL, 16, 16 );
   m_bMail.SetImagePos(CPoint(20, SXBUTTON_CENTER ));
   m_bMail.SetTextPos(CPoint(60, SXBUTTON_CENTER ));

   m_bPhonics.SubclassDlgItem( IDC_PHONICS, GetParent());
   m_bPhonics.SetIcon( IDR_PHONICS, 16, 16 );
   m_bPhonics.SetImagePos(CPoint(60, SXBUTTON_CENTER ));
   m_bPhonics.SetTextPos(CPoint(16, SXBUTTON_CENTER ));

   m_bFileNew.SubclassDlgItem( IDC_NEW_ENTRY, GetParent());
   m_bFileNew.SetIcon( IDR_FILE_NEW, 16, 16 );
   m_bFileNew.SetImagePos(CPoint(3, SXBUTTON_CENTER ));
   m_bFileNew.SetTextPos(CPoint(20, SXBUTTON_CENTER ));

   m_bFileSave.SubclassDlgItem( IDC_UPDATE_ENTRY, GetParent());
   m_bFileSave.SetIcon( IDR_FILE_SAVE, 16, 16 );
   m_bFileSave.SetImagePos(CPoint(3, SXBUTTON_CENTER ));
   m_bFileSave.SetTextPos(CPoint(20, SXBUTTON_CENTER ));

   m_bRecord.SubclassDlgItem( IDC_RECORD, GetParent());
   m_bRecord.SetIcon( IDI_RECORD, 32, 32 );
   m_bRecord.SetImagePos(CPoint(10, SXBUTTON_CENTER ));
   m_bRecord.SetTextPos(CPoint(55, SXBUTTON_CENTER ));

   m_buttonTransmit.SubclassDlgItem( IDC_TRANSMIT, GetParent());
   m_buttonTransmit.SetIcon( IDR_TRANSMIT, 16, 16 );
   m_buttonTransmit.SetImagePos(CPoint(10, SXBUTTON_CENTER ));
   m_buttonTransmit.SetTextPos(CPoint(55, SXBUTTON_CENTER ));

   CResizableDaoRecordView::OnInitialUpdate();

   m_Clock.Start(IDB_CLOCKST_PANE, IDB_CLOCKST_BIG, IDB_CLOCKST_SMALL, TRUE);

   //OnShowGraph();
   m_pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;

   //
   // PreNet Checkin list
   //

   int prenet_colwidths[12] = { 30, 60, 80, 120 };   // sixty-fourths

   TCHAR* lpszPreNetHdrs[] = { _T("Ack"),
                               _T("Call"),
                               _T("Name"),
                               _T("Location"), NULL };
   int prenet_total_cx = 0, i = 0;
   LV_COLUMN prenet_lvcolumn;
   memset(&prenet_lvcolumn, 0, sizeof(prenet_lvcolumn));

   // add columns
   for (i = 0; ; i++)
   {
       if (lpszPreNetHdrs[i] == NULL)
           break;

       prenet_lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
       prenet_lvcolumn.fmt = ((i == 4) || (i == 5) || (i == 6) || (i == 11)) ? LVCFMT_LEFT : LVCFMT_CENTER;
       prenet_lvcolumn.pszText = lpszPreNetHdrs[i];
       prenet_lvcolumn.iSubItem = i;
       prenet_lvcolumn.cx = prenet_colwidths[i];
       prenet_total_cx += prenet_lvcolumn.cx;
       m_ctrlPreNetCkList.InsertColumn(i, &prenet_lvcolumn);
   }

   // iterate through header items and attach the image list
   HDITEM prenet_hditem;

   for (i = 0; i < m_ctrlPreNetCkList.m_HeaderCtrl.GetItemCount(); i++)
   {
       prenet_hditem.mask = HDI_IMAGE | HDI_FORMAT;
       m_ctrlPreNetCkList.m_HeaderCtrl.GetItem(i, &prenet_hditem);
       prenet_hditem.fmt |= HDF_IMAGE;
       prenet_hditem.iImage = XHEADERCTRL_NO_IMAGE;
       m_ctrlPreNetCkList.m_HeaderCtrl.SetItem(i, &prenet_hditem);
   }

   //
   // Main checkin list
   //

   int colwidths[12] = { 20, 30, 40, 80, 180, 180, 180, 40, 80, 40, 40, 500 };   // sixty-fourths
   TCHAR* lpszHeaders[] = { _T("#"),    _T("ID"),      _T("Ack"),      _T("Call"),
                            _T("Name"), _T("Street"),  _T("Location"), _T("Class"),
                            _T("Date"), _T("Traffic"), _T("Comments"), _T("Comments"), NULL };
   int total_cx = 0;
   LV_COLUMN lvcolumn;
   memset(&lvcolumn, 0, sizeof(lvcolumn));

   // add columns
   for (i = 0; ; i++)
   {
      if (lpszHeaders[i] == NULL)
         break;

      lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
      lvcolumn.fmt = ((i==4)||(i==5)||(i==6)||(i==11)) ? LVCFMT_LEFT : LVCFMT_CENTER;
      lvcolumn.pszText = lpszHeaders[i];
      lvcolumn.iSubItem = i;
      lvcolumn.cx = colwidths[i];
      total_cx += lvcolumn.cx;
      m_ctrlOperatorList.InsertColumn(i, &lvcolumn);
   }

   // iterate through header items and attach the image list
   HDITEM hditem;

   for (i = 0; i < m_ctrlOperatorList.m_HeaderCtrl.GetItemCount(); i++)
   {
      hditem.mask = HDI_IMAGE | HDI_FORMAT;
      m_ctrlOperatorList.m_HeaderCtrl.GetItem(i, &hditem);
      hditem.fmt |=  HDF_IMAGE;
      hditem.iImage = XHEADERCTRL_NO_IMAGE;
      m_ctrlOperatorList.m_HeaderCtrl.SetItem(i, &hditem);
   }   


   //SetTimer(UPDATE_VOLUME,250,NULL);
   SetTimer(CHECK_RECORD_TIME, 1000, NULL);

   m_ctrlEchoRefresh.SetCheck(BST_UNCHECKED);
   m_ctrlEchoLogins.SetFont(&m_boldFont);
   //GetDlgItem(IDC_ECHO_LOGINS)->ModifyStyleEx(NULL, WS_EX_RIGHT);

   m_ctrlVolume.SetRange(0, 10);
   m_smMixer.SetVolumeControl(&m_ctrlVolume);
   m_smMixer.SoundInit();
   
   CString szVolume;
   DWORD dwMax = m_smMixer.amdGetMasterVolumeMaximum();
   //szVolume.Format("Volume: %d", m_ctrlVolume.GetPos()/(dwMax/10));
   //GetDlgItem(IDC_STATIC_VOL)->SetWindowText(szVolume);

   CClientDC dc( this );   // need a DC for GetDeviceCaps() below

   LOGFONT lf;            // logical font structure
   ::ZeroMemory( &lf, sizeof( lf ) );
   lf.lfHeight          = -MulDiv(10, dc.GetDeviceCaps( LOGPIXELSX ), 72 );
   lf.lfWidth           = 0;
   lf.lfEscapement      = 0;
   lf.lfOrientation     = 0;
   lf.lfWeight          = FW_BOLD;
   lf.lfItalic          = FALSE;
   lf.lfUnderline       = FALSE;
   lf.lfStrikeOut       = FALSE;
   lf.lfCharSet         = DEFAULT_CHARSET;
   lf.lfOutPrecision    = OUT_DEFAULT_PRECIS;
   lf.lfClipPrecision   = CLIP_DEFAULT_PRECIS;
   lf.lfQuality         = DEFAULT_QUALITY;
   lf.lfPitchAndFamily  = VARIABLE_PITCH | FF_MODERN;

   // Create font
   m_boldFont.CreateFontIndirect( &lf );

   // Get the system message box font
   NONCLIENTMETRICS ncm;
   ncm.cbSize = sizeof(ncm);
   SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0);
   LOGFONT lfDlgFont = ncm.lfMessageFont;
   m_DefaultFont.CreateFontIndirect(&lfDlgFont);

   GetDlgItem(IDC_M_PLACE1)->SetFont(&m_DefaultFont);
   GetDlgItem(IDC_M_PLACE2)->SetFont(&m_DefaultFont);
   GetDlgItem(IDC_M_PLACE3)->SetFont(&m_DefaultFont);
   GetDlgItem(IDC_M_PLACE4)->SetFont(&m_DefaultFont);
   GetDlgItem(IDC_M_PLACE5)->SetFont(&m_DefaultFont);
   GetDlgItem(IDC_M_PLACE6)->SetFont(&m_DefaultFont);

   COleDateTime cdt = COleDateTime::GetCurrentTime();

   UpdateStartGroup();

   GetDlgItem( IDC_CALL_01  )->SetFont( &m_boldFont);
   GetDlgItem( IDC_STATIC_DISTANCE  )->SetFont( &m_boldFont);
   SetCallPhonics();

   if (m_szPrenetURL.Compare(GetDocument()->GetPrenetURL()) != 0) {
       m_szPrenetURL.Format(GetDocument()->GetPrenetURL());
   }
   else if (GetDocument()->GetPrenetURL().IsEmpty()) {
       GetDocument()->SetPrenetURL(m_szPrenetURL);
   }
}

void CNetControlView::SetCallPhonics()
{
   SetDlgItemText(IDC_CALL_01, "");

   CString szCallSoFar;
   m_ctrlCall.GetWindowText(szCallSoFar);

   CString szCall(szCallSoFar), szWord, szTotal;
   for(int i = 0; i < szCall.GetLength(); i++)
   {
      switch(szCall.GetAt(i))
      {
      case 'A': { szWord = "Alpha";    } break;
      case 'B': { szWord = "Brovo";    } break;
      case 'C': { szWord = "Charlie";  } break;
      case 'D': { szWord = "Delta";    } break;
      case 'E': { szWord = "Echo";     } break;
      case 'F': { szWord = "Foxtrot";  } break;
      case 'G': { szWord = "Golf";     } break;
      case 'H': { szWord = "Hotel";    } break;
      case 'I': { szWord = "India";    } break;
      case 'J': { szWord = "Juliet";   } break;
      case 'K': { szWord = "Kilo";     } break;
      case 'L': { szWord = "Lima";     } break;
      case 'M': { szWord = "Mike";     } break;
      case 'N': { szWord = "November"; } break;
      case 'O': { szWord = "Oscar";    } break;
      case 'P': { szWord = "Papa";     } break;
      case 'Q': { szWord = "Quebec";   } break;
      case 'R': { szWord = "Romeo";    } break;
      case 'S': { szWord = "Sierra";   } break;
      case 'T': { szWord = "Tango";    } break;
      case 'U': { szWord = "Uniform";  } break;
      case 'V': { szWord = "Victor";   } break;
      case 'W': { szWord = "Whisky";   } break;
      case 'X': { szWord = "X-ray";    } break;
      case 'Y': { szWord = "Yankee";   } break;
      case 'Z': { szWord = "Zulu";     } break;
      default:  {szWord = szCall.GetAt(i);};
      }
      if(i == 0)
         szTotal = szWord;
      else
         szTotal += " - " + szWord;
   }
   SetDlgItemText(IDC_CALL_01, szTotal);
   CalculateDistance();
}

/////////////////////////////////////////////////////////////////////////////
// CNetControlView diagnostics

#ifdef _DEBUG
void CNetControlView::AssertValid() const
{
   CResizableDaoRecordView::AssertValid();
}

void CNetControlView::Dump(CDumpContext& dc) const
{
   CResizableDaoRecordView::Dump(dc);
}

CNetControlDoc* CNetControlView::GetDocument() // non-debug version is inline
{
   ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNetControlDoc)));
   return (CNetControlDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNetControlView database support
CDaoRecordset* CNetControlView::OnGetRecordset()
{
   return m_pSet;
}

/////////////////////////////////////////////////////////////////////////////
// CNetControlView message handlers

void CNetControlView::OnRclickOperatorList(NMHDR* pNMHDR, LRESULT* pResult) 
{
   OnClickOperatorList(NULL,NULL);
   CString szCallSoFar(m_pSet->m_CallSign);

   m_queryQRZ.LookupCallSign(szCallSoFar);

   /*
   m_NameFirst        = m_queryQRZ.m_NameFirst;
   m_NameMI           = m_queryQRZ.m_NameMI;
   m_NameLast         = m_queryQRZ.m_NameLast;
   m_City             = m_queryQRZ.m_City;
   m_AddressLine1     = m_queryQRZ.m_AddressLine1;
   m_AddressLine2     = m_queryQRZ.m_AddressLine2;
   m_EmailAddress     = m_queryQRZ.m_EmailAddress;
   m_LicenseClass     = m_queryQRZ.m_LicenseClass;
   m_State            = m_queryQRZ.m_State;
   m_Zip              = m_queryQRZ.m_Zip;
   m_County           = m_queryQRZ.m_County;
   m_Country          = m_queryQRZ.m_Country;
   m_Lookups          = m_queryQRZ.m_Lookups;
   m_ExpirationDate   = m_queryQRZ.m_ExpirationDate;
   */

   m_pSet->Edit();
   if(m_pSet->m_Name.IsEmpty()) 
      m_pSet->m_Name = m_queryQRZ.m_NameLast + ", " + m_queryQRZ.m_NameFirst + " " + m_queryQRZ.m_NameMI;

   if(m_pSet->m_Street.IsEmpty()) 
      m_pSet->m_Street= m_queryQRZ.m_AddressLine1;

   if(m_pSet->m_Location.IsEmpty()) 
      m_pSet->m_Location = m_queryQRZ.m_City + ", " + m_queryQRZ.m_State + " (" + m_queryQRZ.m_Country + ")";

   if(m_pSet->m_Class.IsEmpty()) 
      m_pSet->m_Class = m_queryQRZ.m_LicenseClass;

   if(m_pSet->m_YourGrid.IsEmpty()) 
      m_pSet->m_YourGrid = m_queryQRZ.m_Grid;

   if(m_pSet->m_eMailAddr.IsEmpty()) 
      m_pSet->m_eMailAddr = m_queryQRZ.m_EmailAddress;

   m_pSet->Update();
   CalculateDistance();

   UpdateData(FALSE);
   
   *pResult = 0;
}

void CNetControlView::OnClickOperatorList(NMHDR* pNMHDR, LRESULT* pResult) 
{
   if(m_pSet != NULL && m_pSet->IsOpen())
   {
      int iMove = 0;
      int iCurPos = m_pSet->GetAbsolutePosition();
      int iCurSel = m_ctrlOperatorList.GetCurSel();
      
      if(iCurSel > -1)
      {
         CString szID;
         char* pszUID = (char*) new char[8];
         m_ctrlOperatorList.GetItemText(iCurSel,1,pszUID,8);

         long lUID = atol(pszUID);
         if(!m_pSet->IsEOF() && !m_pSet->IsBOF())
         {
            for(m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
            {
               if(m_pSet->m_ID == lUID)
               {
                  UpdateData(FALSE);
                  ReportCurrentPos();
                  SetCallPhonics();
                  m_ctrTime.SetTime(m_pSet->m_Date);
                  if(m_pSet->m_Comment.IsEmpty())
                     GetDlgItem(IDC_COMMENT)->SetWindowText("");
                  break;
               }
            }
         }
         delete pszUID;
         pszUID = NULL;
         //m_pSet->SetAbsolutePosition((long)iCurSel);
      }
   }
   if(pResult != NULL)
      *pResult = 0;
}

void CNetControlView::OnBnClickedNetReport()
{
    m_pNetReportDlg = new CNetReportDlg;

    m_pNetReportDlg->m_szName = GetDocument()->GetReportName();
    m_pNetReportDlg->m_szCall = GetDocument()->GetReportCall();
    m_pNetReportDlg->m_szDate = GetDocument()->GetReportDate();
    m_pNetReportDlg->m_szMessage = GetDocument()->GetReportMessage();
    m_pNetReportDlg->m_szCheckIns.Format("%ld", m_pSet->GetRecordCount());
    m_pNetReportDlg->m_szTraffic = GetDocument()->GetReportTraffic();
    m_pNetReportDlg->m_bAnnounce = GetDocument()->GetReportAnnounce();

    if (m_pNetReportDlg->DoModal() == IDOK) {

        GetDocument()->SetReportName(m_pNetReportDlg->m_szName);
        GetDocument()->SetReportCall(m_pNetReportDlg->m_szCall);
        GetDocument()->SetReportDate(m_pNetReportDlg->m_szDate);
        GetDocument()->SetReportMessage(m_pNetReportDlg->m_szMessage);
        GetDocument()->SetReportCheckIns(m_pNetReportDlg->m_szCheckIns);
        GetDocument()->SetReportTraffic(m_pNetReportDlg->m_szTraffic);
        GetDocument()->SetReportAnnounce(m_pNetReportDlg->m_bAnnounce);

        m_webRequest.SetServer(m_szPrenetURL.GetString());
        CString szURI;
        ////////////////////////
        // Example URL plus URI
        // 'http://192.168.20.101/cgi-bin/netReport?f=Dave&s=W4DJW&d=07%2F11%2F2020&m=442&c=56&t=1&a=Yes
        ////////////////////////

        szURI.Format("%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s", 
                    "cgi-bin/netReport",
                    "?f=", m_pNetReportDlg->m_szName,
                    "&s=", m_pNetReportDlg->m_szCall,
                    "&d=", m_pNetReportDlg->m_szDate,
                    "&m=", m_pNetReportDlg->m_szMessage,
                    "&c=", m_pNetReportDlg->m_szCheckIns,
                    "&t=", m_pNetReportDlg->m_szTraffic,
                    "&a=", m_pNetReportDlg->m_bAnnounce ? "Yes": "No");

        m_webRequest.SetProcessor(szURI);
        m_webRequest.SetUserName("");
        m_webRequest.SetPassWord("");
        CString szResults(m_webRequest.SubmitRequest(szURI));
    }
}

void CNetControlView::OnEnChangePrenetUrl()
{
    UpdateData(TRUE);
    GetDocument()->SetPrenetURL(m_szPrenetURL);
}

void CNetControlView::OnNMDblclkPrenetList(NMHDR* pNMHDR, LRESULT* pResult)
{
    LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

    char* pszCall = (char*) new char[8];
    int iCurSel = m_ctrlPreNetCkList.GetCurSel();
    m_ctrlPreNetCkList.GetItemText(iCurSel, 1, pszCall, 8);
    CString szCall(pszCall);
    delete pszCall;
    pszCall = NULL;

    OnClear();
    GetDlgItem(IDC_CALL)->SetWindowText(szCall);
    OnLocalLookup();
    m_ctrlCall.SetFocus();
    m_ctrlCall.SetSel(0, -1, TRUE);

    *pResult = 0;
}

void CNetControlView::LoadEcholinkLogins()
{
   CString szCalls, szSelectedCall;

   m_ctrlEchoLogins.LockWindowUpdate();

   int iCurSel= m_ctrlEchoLogins.GetCurSel();

   if (iCurSel != LB_ERR) {
      m_ctrlEchoLogins.GetText(iCurSel, szSelectedCall);
   }

   m_ctrlEchoLogins.ResetContent();

   m_szPrenetURL.Format(GetDocument()->GetPrenetURL());
   m_webRequest.SetServer(m_szPrenetURL.GetString());
   m_webRequest.SetProcessor("cgi-bin/echoLogin");
   m_webRequest.SetUserName("");
   m_webRequest.SetPassWord("");
   m_webRequest.m_bVerbose = false;
   CString szResults(m_webRequest.SubmitRequest("cgi-bin/echoLogin"));

   int iStart = szResults.Find(_T("<body>"));
   int iEnd   = szResults.Find(_T("</body>"));

   if (iStart != -1) {
      iStart += 6;
      szCalls = szResults.Mid(iStart,iEnd-iStart);
      int iPos = 0;
      int iSpace = szCalls.Find(' ', iPos);
      if (iSpace != -1) {
         while (iSpace != -1) {
            m_ctrlEchoLogins.AddString(szCalls.Mid(iPos, iSpace - iPos));
            iPos = iSpace + 1;
            iSpace = szCalls.Find(' ', iPos);
            if (iPos == iSpace)
               iSpace = -1;
         }
      } else {
         m_ctrlEchoLogins.AddString(szCalls);
      }
   }
   if (iCurSel != LB_ERR) {
      if (m_ctrlEchoLogins.GetCount() >= iCurSel) {
         m_ctrlEchoLogins.SelectString(0, szSelectedCall);
      }
   }
   m_ctrlEchoLogins.UnlockWindowUpdate();
}

void CNetControlView::OnLbnDblclkEchoLogins()
{
   CString szCall;
   int iCurSel = m_ctrlEchoLogins.GetCurSel();

   m_ctrlEchoLogins.GetText(iCurSel, szCall);

   m_ctrlCall.SetFocus();
   m_ctrlCall.SetSel(0, -1, FALSE);
   m_ctrlCall.ReplaceSel(szCall, FALSE);

   if (m_ctrlLocalList.GetCount() >= 1) {
      OnEditSelMatch1();
   }
}

void CNetControlView::LoadPreNetList()
{
   m_ctrlPreNetCkList.SetExtendedStyle(LVS_EX_CHECKBOXES |
      LVS_EX_HEADERDRAGDROP |
      LVS_EX_ONECLICKACTIVATE |
      LVS_EX_FULLROWSELECT |
      LVS_EX_GRIDLINES);

   int iCurSel = m_ctrlPreNetCkList.GetCurSel();

   CString szCurrentID;
   CString szID = m_ctrlPreNetCkList.GetItemText(0, 1);

   m_ctrlPreNetCkList.LockWindowUpdate();   // ***** lock window updates while filling list *****

   // Now it is safe to empty the list.
   m_ctrlPreNetCkList.DeleteAllItems();

   m_szPrenetURL.Format(GetDocument()->GetPrenetURL());
   m_webRequest.SetServer(m_szPrenetURL.GetString());
   m_webRequest.SetProcessor("cgi-bin/preCheckIn");
   m_webRequest.SetUserName("");
   m_webRequest.SetPassWord("");
   //m_webRequest.m_bVerbose = false;
   CString szResults(m_webRequest.SubmitRequest("cgi-bin/preCheckIn"));

   bool done = false;
   int iStart = szResults.Find("/form>"), iCount = 1;
   CString szCall, szName, szLocation;
   COLORREF rgb = RGB(249, 249, 233);

   int iLength = szResults.GetLength();

   if ((szResults.Find("404") < 0) && (iLength > 1375)) {
      while (!done) {

         //int iFirst = szResults.Find("<tr><td>", iStart) + 8;
         int iFirst = szResults.Find("<li>", iStart) + 4;
         int iEnd = szResults.Find(",", iFirst);
         szCall.Format(szResults.Mid(iFirst, iEnd - iFirst));
         szCall.Replace("+", "");
         szCall.Trim();

         bool bNoLoc = false;
         iFirst = iEnd + 2;
         int iMax = szResults.Find("<", iFirst);
         iEnd = szResults.Find(",", iFirst);
         if (iEnd < 0 || iEnd > iMax) {
            iEnd = iMax;
            bNoLoc = true;
         }

         szName.Format(szResults.Mid(iFirst, iEnd - iFirst));
         szName.Replace("+", "");
         szName.Replace(",", "");
         szName.Trim();

         if (!bNoLoc) {
            iFirst = iEnd + 1;
            iEnd = iMax;
            szLocation.Format(szResults.Mid(iFirst, iEnd - iFirst));
            szLocation.Trim();
         }

         iStart = szResults.Find("<li>", iFirst);

         /////////////////////////////////
         int iIdx = 0;
         BOOL bAlreadyLogged = FALSE;
         if (!m_pSet->IsEOF() && !m_pSet->IsBOF())
         {
            long absPosition = m_pSet->GetAbsolutePosition();
            for (m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
            {
               szID.Format("%d", m_pSet->m_ID);
               if (szCall.Compare(m_ctrlOperatorList.GetItemText(iIdx++, 3)) == 0)
                  bAlreadyLogged = TRUE;
            }
            m_pSet->SetAbsolutePosition(absPosition);
         }
         /////////////////////////////////

         iIdx = m_ctrlPreNetCkList.InsertItem(iCount - 1, szCall);
         try {
            szID.Format("%d", m_pSet->m_ID);
            m_ctrlPreNetCkList.SetCheckbox(iIdx, 0, bAlreadyLogged);
            m_ctrlPreNetCkList.SetItemText(iIdx, 0, "", RGB(0, 0, 0), rgb);
            m_ctrlPreNetCkList.SetItemText(iIdx, 1, szCall, RGB(0, 0, 0), rgb);
            m_ctrlPreNetCkList.SetItemText(iIdx, 2, szName, RGB(0, 0, 0), rgb);
            m_ctrlPreNetCkList.SetItemText(iIdx, 3, szLocation, RGB(0, 0, 0), rgb);
         }
         catch (...) {
         }

         if (iStart < 0) {
            done = true;
            m_ctrlPreNetCkList.SetCurSel(iCount);
            m_ctrlPreNetCkList.EnsureVisible(iCount, FALSE);
            m_ctrlPreNetCkList.Scroll(CSize(0, 300));
         }
         iCount += 1;
      }
   }
   else {
      if (iLength == 1375)
         AfxMessageBox("Nothing found so far for today");
      else
         AfxMessageBox("Bad Server Name perhaps?");
   }
   m_ctrlPreNetCkList.UnlockWindowUpdate();   // ***** unlock window updates *****

}

/*
 * Move all the pre-checkins from the pre-checkin listing to the logbook 
 * 9/10/2022
 */
 void CNetControlView::OnBnClickedMoveAll()
 {
    char* pszCall = (char*) new char[8];
    char* pszName = (char*) new char[20];
    char* pszLocation = (char*) new char[30];

    for (int i = 0; i < m_ctrlPreNetCkList.GetItemCount(); i++) {

       bool alreadyThere = false;
       m_ctrlPreNetCkList.SetCurSel(i);

       // extract name and call from the pre-net checkin listing
       m_ctrlPreNetCkList.GetItemText(i, 1, pszCall, 8);
       m_ctrlPreNetCkList.GetItemText(i, 2, pszName, 20);
       m_ctrlPreNetCkList.GetItemText(i, 3, pszLocation, 30);
       CString szCall(pszCall);
       CString szName(pszName);
       CString szLocation(pszLocation);
       
       // check for existance in the logbook below
       for (int iCount = 0; !alreadyThere && iCount < m_ctrlOperatorList.GetItemCount(); iCount++) {
          m_ctrlOperatorList.GetItemText(iCount, 3, pszCall, 8);
          int iLocation = szCall.Find(pszCall);
          if (iLocation == 0)
             alreadyThere = true;
       }

       // If not already there, add here. make first attempt from the local log database, 
       // if not available from local logbook then add from the fcc database
       if (!alreadyThere) {

          m_ctrlCall.SetFocus();
          m_ctrlCall.SetSel(0, -1, FALSE);
          m_ctrlCall.ReplaceSel(szCall, FALSE);

          CNetControlSet* pSet = new CNetControlSet();
          pSet->m_strSort.Format("CallSign DESC");
          pSet->m_strFilter.Format("CallSign = '%s'", szCall);

          m_ctrlLocalList.EnableWindow(TRUE);
          m_ctrlLocalList.GetDC()->SetBkColor(RGB(255, 255, 255));
          m_ctrlLocalList.ResetContent();

          int i = 0;
          pSet->Open();
          if (pSet->m_CallSign.Compare(szCall) == 0) {
             m_ctrlLocalList.AddString(pSet->m_CallSign);
             OnEditSelMatch1();
             OnFileNew();
          } else {
             OnLocalLookup();
             OnFileNew();
          }
          pSet->Close();
          delete pSet;
          pSet = NULL;
       }
    }
 }

void CNetControlView::LoadOperatorList()
{
   m_ctrlOperatorList.SetExtendedStyle(LVS_EX_CHECKBOXES |
                                       LVS_EX_HEADERDRAGDROP |
                                       LVS_EX_ONECLICKACTIVATE |
                                       LVS_EX_FULLROWSELECT |
                                       LVS_EX_GRIDLINES );

   //if(m_bSignificantEvent == FALSE)
   //{
   //   return;
   //}
   
   TRACE("LoadOperatorList:: Significant Event was TRUE, setting it to FALSE!\n");
   //m_bSignificantEvent = FALSE;

   int iCurSel = m_ctrlOperatorList.GetCurSel();
   int iSliderPos = m_ctrlSlider1.GetPos();
   int iCurrDBPos = m_pSet->GetAbsolutePosition();

   /*
    * Add code here to read the check boxes and modify 
    * the database.
    * Complete this before deleting the existing items.
    */

   CString szCurrentID;
   CString szID = m_ctrlOperatorList.GetItemText(0,1);

   m_ctrlOperatorList.LockWindowUpdate();   // ***** lock window updates while filling list *****
   
   if(!szID.IsEmpty())
   {
      CNetControlSet* pSet = new CNetControlSet();
      pSet->m_strFilter.Format("ID = %s", szID);
      pSet->m_strSort.Format("ID DESC");
      pSet->Open();
      
      for( int iCurrentLoc = 0; iCurrentLoc < m_ctrlOperatorList.GetItemCount(); iCurrentLoc++)
      {
         int iAcknowl = m_ctrlOperatorList.GetCheckbox(iCurrentLoc,2);
         int iTraffic = m_ctrlOperatorList.GetCheckbox(iCurrentLoc,9);
         int iComment = m_ctrlOperatorList.GetCheckbox(iCurrentLoc,10);
         szID = m_ctrlOperatorList.GetItemText(iCurrentLoc,1);
         
         if(!szID.IsEmpty())
         {         
            pSet->m_strFilter.Format("ID = %s", szID);
            pSet->m_strSort.Format("ID DESC");
            pSet->Requery();
            
            if(!pSet->IsEOF() && !pSet->IsBOF()) // Could have been deleted (better double check)
            {
               for(pSet->MoveFirst(); !pSet->IsEOF(); pSet->MoveNext())
               {
                  szCurrentID.Format("%ld", pSet->m_ID);
                  if(!szCurrentID.IsEmpty() && szCurrentID.Compare(szID) == 0)
                  {
                     pSet->Edit();
                     pSet->m_Acknowledged = (BOOL)iAcknowl;
                     pSet->m_HasComments  = (BOOL)iComment;
                     pSet->m_HasTraffic   = (BOOL)iTraffic;
                     pSet->Update();
                     break;
                  }
               }
            }
         }
      }
      pSet->Close();
      delete pSet;
      pSet = NULL;
   }

   // Now it is safe to empty the list.
   m_ctrlOperatorList.DeleteAllItems();

   COLORREF rgb = RGB(249,249,233);
   long lCurrentLocation = m_pSet->GetAbsolutePosition();
   if(lCurrentLocation == -1)
   {
      if(!m_pSet->IsEOF() && !m_pSet->IsBOF())
      {
         m_pSet->MoveFirst();
         lCurrentLocation = 0;
      } else {
         m_ctrlOperatorList.UnlockWindowUpdate();   // ***** unlock window updates *****
         return;
      }
   }

   int iCount = 1;
   CString szCount;
   if(!m_pSet->IsEOF() && !m_pSet->IsBOF())
   {
      for(m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
      {
         if((m_pSet->GetAbsolutePosition()+1 %3) != 0)
         {
            int iRed = GetRValue(rgb);
            int iGrn = GetGValue(rgb);
            int iBlu = GetBValue(rgb);
            rgb = RGB(iGrn,iBlu,iRed);
         }
         szCount.Format("%d", iCount++);
         int iIdx = m_ctrlOperatorList.InsertItem(iCount-1, m_pSet->m_CallSign);
         try {
            szID.Format("%d", m_pSet->m_ID); 
            m_ctrlOperatorList.SetItemText(iIdx,0, szCount, RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,1, szID, RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetCheckbox(iIdx,2, m_pSet->m_Acknowledged);
            m_ctrlOperatorList.SetItemText(iIdx,2, "", RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,3, m_pSet->m_CallSign, RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,4, m_pSet->m_Name,     RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,5, m_pSet->m_Street,   RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,6, m_pSet->m_Location, RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,7, m_pSet->m_Class,    RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,8, m_pSet->m_Date.Format("%m/%d/%Y"), RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetCheckbox(iIdx,9, m_pSet->m_HasTraffic);
            m_ctrlOperatorList.SetItemText(iIdx,9, "", RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetCheckbox(iIdx,10, m_pSet->m_HasComments);
            m_ctrlOperatorList.SetItemText(iIdx,10, "", RGB(0,0,0), rgb);
            m_ctrlOperatorList.SetItemText(iIdx,11, m_pSet->m_Comment, RGB(0,0,0), rgb);
         }
         catch (...) {
         }
      }
   }
   m_ctrlOperatorList.UnlockWindowUpdate();   // ***** unlock window updates *****
   if(lCurrentLocation != -1)
      m_pSet->SetAbsolutePosition(lCurrentLocation);

   if(iCurSel != -1)
   {
      m_ctrlOperatorList.SetCurSel(iCurSel);
      m_ctrlOperatorList.EnsureVisible(iCurSel,FALSE);
      m_ctrlOperatorList.Scroll(CSize(0,300));
   }
}

void CNetControlView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
   TRACE("Entering: OnUpdate\n");
   CString szDate(GetDocument()->GetSelectedDate()), szMsg;
   if(m_pSet != NULL)
   {
      LockDatabaseCursor();

      if(!m_pSet->IsEOF())
      {
         m_pSet->MoveFirst();
         while(!m_pSet->IsEOF())
         {
            m_pSet->MoveNext();
         }
         m_ctrlSlider1.SetRange(1,m_pSet->GetRecordCount(),TRUE);
         m_ctrlSlider1.SetPos(1);
         m_pSet->MoveFirst();
         szMsg.Format("%d Checkins on %s", 
            m_pSet->GetRecordCount(), m_pSet->m_Date.Format("%m/%d/%Y"));
         StatusMsg(szMsg);
      } else {
         COleDateTime cdt;
         cdt.SetDate(atoi(szDate.Mid(0,4).GetBuffer(0)),
                     atoi(szDate.Mid(5,2).GetBuffer(0)),
                     atoi(szDate.Mid(8,2).GetBuffer(0)));
         m_pSet->m_Name.Empty();
         m_pSet->m_Date = cdt;
         m_pSet->m_CallSign.Empty();
         m_pSet->m_Comment.Empty();
         m_pSet->m_HasTraffic = FALSE;
         m_pSet->m_HasComments = FALSE;
         m_pSet->m_Acknowledged = FALSE;
         StatusMsg("Ready");
      }
      UpdateData(FALSE);
      TRACE("OnUpdate:: Setting timer for updating the operator list\n");
      SetTimer(UPDATE_LIST,250,NULL);
      m_ctrlLocalList.EnableWindow(FALSE);
      m_ctrlLocalList.GetDC()->SetBkColor(RGB(55,55,55));
      m_szSelectedDate = szDate;
   }
   TRACE("Exiting: OnUpdate\n\n");
}

void CNetControlView::OnTimer(UINT nIDEvent) 
{
   DWORD dwVal = 0;
   if(nIDEvent == UPDATE_LIST)
   {
      TRACE("OnTimer: %s\n", "UPDATE_LIST");
      LoadOperatorList();
      ReportCurrentPos();
      KillTimer(UPDATE_LIST);
   }
   else if(nIDEvent == UPDATE_VOLUME)
   {
      TRACE("OnTimer: %s\n", "UPDATE_VOLUME");
      if (m_smMixer.amdGetMasterVolumeValue(dwVal))
         m_ctrlVolume.SetPos(dwVal);
   }
   else if (nIDEvent == UPDATE_ECHOLINK)
   {
      LoadEcholinkLogins();
   }
   else if(nIDEvent == CHECK_RECORD_TIME)
   {
      /*
      COleDateTime cdt = COleDateTime::GetCurrentTime();
      int iHour = cdt.GetHour();
      int iMinute = cdt.GetMinute();
      if(iHour == 20 && iMinute == 55 && m_bRecordSession == false)
         OnRecord();
      if(iHour == 22 && iMinute == 30 && m_bRecordSession == true)
         OnRecord();
      */
   }
   
   CResizableDaoRecordView::OnTimer(nIDEvent);
}

void CNetControlView::OnSelchangeLocalList() 
{
   /////////////////////////////////////////
   // This function is for matching from the
   // list under the call sign entry box
   /////////////////////////////////////////

   m_bDisableCallMonitor = true;

   CString szSelection;
   BOOL bWasFound = FALSE;
   int iCurSel = m_ctrlLocalList.GetCurSel();

   FreeDatabaseCursor();

   if(iCurSel != -1)
   {
      //UpdateData(TRUE);
      m_ctrlLocalList.GetText(iCurSel,szSelection);
      m_pSet->m_CallSign = szSelection;
      m_pSet->SetFieldDirty(&m_pSet->m_CallSign);
      
      CNetControlSet* pSet = new CNetControlSet();
      pSet->m_strSort.Format("ID DESC");
      pSet->m_strFilter.Format("CallSign = '%s'", szSelection);
      pSet->Open();

      if(pSet->IsOpen())
      {
         pSet->MoveFirst();
         for(m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
         {
            if(m_pSet->m_ID == pSet->m_ID)
            {
               m_pSet->m_Comment.Empty();
               //m_pSet->m_YourGrid.Empty();
               m_pSet->m_HasComments  = FALSE;
               m_pSet->m_HasTraffic   = FALSE;
               m_pSet->m_Acknowledged = FALSE;
               
               bWasFound = m_ctrlSelectedDate.GetTime(m_pSet->m_Date);
               break;
            }
         }
         
         pSet->Close();
         delete pSet;
         pSet = NULL;
      }

      UpdateData(FALSE);
      SetCallPhonics();
   }

   LockDatabaseCursor();

   m_bDisableCallMonitor = false;
   TRACE("OnSelchangeLocalList:: Entry = %s, %s, %s, %s\n", 
      m_pSet->m_CallSign, m_pSet->m_Name, 
      m_pSet->m_Location, m_pSet->m_Class);
}

void CNetControlView::OnFccLookup() 
{
   UpdateData(TRUE); // Pull from the UI

   if(!m_pSet->m_CallSign.IsEmpty())
   {
      CString szUID;
      CFCCHDSet hd;
      CWaitCursor cursor; 
      hd.m_strSort.Format("CallSign DESC");
      hd.m_strFilter.Format("CallSign like '%s'", m_pSet->m_CallSign);
      hd.Open();  long lUID = hd.m_UniqueSystemIdentifier;  hd.Close();

      szUID.Format("%ld", lUID);

      CString szURL("http://wireless2.fcc.gov/UlsApp/UlsSearch/license.jsp?licKey=");
      int iLength = szURL.GetLength();
      szURL.Insert(iLength,szUID);
      LaunchDefaultBrowserTo(szURL);
   }
   return;
}

void CNetControlView::OnQrzLookup() 
{
   UpdateData(TRUE); // Pull from the UI
   CString szURL("http://www.qrz.com/db/");
   int iLength = szURL.GetLength();
   szURL.Insert(iLength,m_pSet->m_CallSign);
   LaunchDefaultBrowserTo(szURL);
}

void CNetControlView::LaunchDefaultBrowserTo(CString szURL) 
{
  ShellExecute(NULL, "open", szURL, NULL, NULL, SW_SHOWNORMAL);
}

void CNetControlView::OnEditCopy() 
{
   CWnd* pWnd = GetFocus();
   CEdit* pEdit = (CEdit*)pWnd;
   
   if(pEdit)
      pEdit->Copy();   
}

void CNetControlView::OnEditCut() 
{
   CWnd* pWnd = GetFocus();
   CEdit* pEdit = (CEdit*)pWnd;
   
   if(pEdit)
      pEdit->Cut();   
}

void CNetControlView::OnEditPaste() 
{
   CWnd* pWnd = GetFocus();
   CEdit* pEdit = (CEdit*)pWnd;
   
   if(pEdit)
      pEdit->Paste();   
}

void CNetControlView::OnEditUndo() 
{
   CWnd* pWnd = GetFocus();
   CEdit* pEdit = (CEdit*)pWnd;
   
   if(pEdit)
      pEdit->Undo();   
}

void CNetControlView::OnFileNew() 
{
   ////////////////////////////////////////////////////////////////////////////////
   // Added 2022/09/15 to make sure the call we are adding isn't already in the log
   // Before we do this, lets make sure that call isn't already in the log by going
   // through the 

   int iCount = 0;
   CString szMessage, szCall;
   char* pszCall = (char*) new char[8];
   m_ctrlCall.GetWindowText(szCall);
   for (iCount = 0; iCount < m_ctrlOperatorList.GetItemCount(); iCount++)
   {
      m_ctrlOperatorList.GetItemText(iCount, 3, pszCall, 8);
      CString szMatch(pszCall);
      //m_ctrlOperatorList.GetItemBkColor(iCount,4);
      if (szMatch.Find(szCall, 0) == 0) {
         szMessage.Format(_T("%s Already logged as entry #%d"), szCall, iCount +1);
         AfxMessageBox(szMessage, MB_OK);
         return;
      }
   }
            
   m_ctrlCall.SetFocus();
   if(!m_pSet->IsEOF())
      m_pSet->MoveLast();
   m_pSet->AddNew();
   UpdateData(TRUE);

   COleDateTime cdt = COleDateTime::GetCurrentTime();
   int iHour = cdt.GetHour();
   int iMinute = cdt.GetMinute();
   int iSecond = cdt.GetSecond();
   m_pSet->m_Date = cdt;

   ////////////////////////////////////////////////////////////////////////////////////
   // Added 2022/09/13 to permit shadowing another net controller on a day other than
   // today via a recording of a net going back in time.
   // Sync the year, month and day with operator selected date 
   // Sync the hour, minute and second with the time of the current day the operator 
   // is practicing on...
   CTime timeTime;
   m_ctrlSelectedDate.GetTime(timeTime);
   cdt.SetDateTime(timeTime.GetYear(), timeTime.GetMonth(), timeTime.GetDay(), iHour, iMinute, iSecond);
   m_pSet->m_Date = cdt;
   ////////////////////////////////////////////////////////////////////////////////////

   m_pSet->Update();
   m_pSet->MoveLast();
   UpdateData(FALSE);
   CalculateDistance();

   if(m_bUploadAuto)
      CallUploadBrars();

   TRACE("OnFileNew:: Setting timer for updating the operator list, setting SE = TRUE\n");
   //m_bSignificantEvent = TRUE;
   SetTimer(UPDATE_LIST,250,NULL);
}

void CNetControlView::OnFileOpen() 
{
   // TODO: Add your command handler code here   
}

void CNetControlView::OnFileSave() 
{
   bool bIsFirstRecord = false;
   if(!m_pSet->IsEOF())
      m_pSet->Edit();
   else {
      bIsFirstRecord = true;
      FreeDatabaseCursor();
      m_pSet->MoveLast();
      m_pSet->AddNew();
   }

   UpdateData(TRUE);
   m_pSet->Update();

   if(bIsFirstRecord)
   {
      m_pSet->MoveLast();
      LockDatabaseCursor();
      m_pSet->MoveLast();
   }
   TRACE("OnFileSave:: Setting timer for updating the operator list, setting SE = TRUE\n");
   //m_bSignificantEvent = TRUE;
   SetTimer(UPDATE_LIST,250,NULL);
}

void CNetControlView::OnFileSaveAs() 
{
   // TODO: Add your command handler code here
}

void CNetControlView::OnKeydownOperatorList(NMHDR* pNMHDR, LRESULT* pResult) 
{
   LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

   if(pLVKeyDow->wVKey == 46)
      if(AfxMessageBox("Do you really want to delete the selected record(s)?", MB_YESNO) == IDYES)
         OnRecordDelete();
   
   *pResult = 0;
}

void CNetControlView::OnRecordDelete() 
{
   CWnd* pWnd = GetFocus();
   CXListCtrl* pListCtrl = (CXListCtrl*)pWnd;
   
   if((pListCtrl == &m_ctrlOperatorList) && !m_pSet->IsBOF() && !m_pSet->IsEOF())
   {
      try
      {
         int iSelCount = m_ctrlOperatorList.GetSelectedCount();
         if(iSelCount > 1)
         {
            int iArray[255];
            int iNext = 0, idx = 0;
            POSITION pos = m_ctrlOperatorList.GetFirstSelectedItemPosition();
            while(pos)
            {
               int iNext = m_ctrlOperatorList.GetNextSelectedItem(pos);
               iArray[idx++] = iNext;
            }
            for(idx -= 1; idx >= 0; idx--)
            {
               m_pSet->SetAbsolutePosition(iArray[idx]);
               m_pSet->Delete();
            }
            OnRecordFirst();
         } else {
            ReportCurrentPos();
            long lCurPos = m_pSet->GetAbsolutePosition() -1;
            m_pSet->Delete();
            OnRecordFirst();
            for(int iCount = 0; iCount < lCurPos; iCount++)
               OnRecordNext();
         }
      }
      catch (CDaoException* pEx)
      {
         if (!m_pSet->IsBOF())
            m_pSet->MovePrev();
         else
         {
            m_pSet->AddNew();
            m_pSet->m_CallSign.Empty();
            m_pSet->m_Name.Empty();
            m_pSet->m_Street.Empty();
            m_pSet->m_Location.Empty();
            m_pSet->m_Class.Empty();
            m_pSet->m_HasTraffic = FALSE;
            m_pSet->m_HasComments = FALSE;
            m_pSet->m_Acknowledged = FALSE;
            m_pSet->m_Comment.Empty();
            m_pSet->m_Date = COleDateTime::GetCurrentTime();
            m_pSet->Update();
         }

         CString szMsg;
         TCHAR   szCause[255];
         pEx->GetErrorMessage(szCause,255);
         szMsg.Format("There was a error: %s", szCause);
         StatusMsg(szMsg);
      }
      UpdateData(FALSE); // Push to the UI
      TRACE("OnRecordDelete:: Setting timer for updating the operator list, setting SE = TRUE\n");
      //m_bSignificantEvent = TRUE;
      SetTimer(UPDATE_LIST,250,NULL);
   }
}

void CNetControlView::ReportCurrentPos()
{
   CString szMsg;
   if(!m_pSet->IsEOF() && !m_pSet->IsBOF())
   {
      int iCount = 0;
      long lCurPos = m_pSet->GetAbsolutePosition();
      for(m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext()) iCount++;

      if(lCurPos == 0)
         m_pSet->MoveFirst();
      else
         m_pSet->SetAbsolutePosition(lCurPos);

      TRACE("\nReportCurrentPos: Range: 1 to %d\n", iCount);
      TRACE("ReportCurrentPos: Current: %ld\n", lCurPos+1);
      m_ctrlSlider1.SetRange(1,iCount);
      m_ctrlSlider1.SetPos(lCurPos+1);
      m_ctrlOperatorList.EnsureVisible(lCurPos,FALSE);
      szMsg.Format("Record %ld of %d", lCurPos+1, iCount);
      CheckForWaveFile();
      m_Time = m_pSet->m_Date;

   } else {
      m_ctrlSlider1.SetRange(1,1);
      m_ctrlSlider1.SetPos(1);
      szMsg.Format("No Checkins Recorded for selected Date");
   }

   StatusMsg(szMsg);
   UpdateData(FALSE);
}

void CNetControlView::StatusMsg(CString szMsg)
{
   if(m_pFrame)
   {
      CStatusBar* pStatus = &m_pFrame->m_wndStatusBar;
      if(pStatus)
         pStatus->SetPaneText(0, szMsg.GetBuffer(1));
   }
}

void CNetControlView::OnRecordFirst() 
{
   if(!m_pSet->IsBOF())
      CResizableDaoRecordView::OnMove(ID_RECORD_FIRST);
   ReportCurrentPos();
}
void CNetControlView::OnRecordPrev() 
{
   if(!m_pSet->IsBOF())
      CResizableDaoRecordView::OnMove(ID_RECORD_PREV);
   ReportCurrentPos();
}
void CNetControlView::OnRecordNext() 
{
   if(!m_pSet->IsEOF())
      CResizableDaoRecordView::OnMove(ID_RECORD_NEXT);
   ReportCurrentPos();
}
void CNetControlView::OnRecordLast() 
{
   if(!m_pSet->IsEOF())
      CResizableDaoRecordView::OnMove(ID_RECORD_LAST);
   ReportCurrentPos();
}


void CNetControlView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   // TODO: Add your message handler code here and/or call default
   
   CResizableDaoRecordView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CNetControlView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   CString szMsg;
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
   CSliderCtrl* pSlide = (CSliderCtrl*) pScrollBar;

   if(pScrollBar != NULL) {
      int pid = pScrollBar->GetDlgCtrlID();
      if(m_ctrlSlider1.GetDlgCtrlID() == pid)
      {
         long lRecordNum = m_ctrlSlider1.GetPos()-1;
         if(m_pSet->GetRecordCount() >= lRecordNum)
         {
            m_pSet->SetAbsolutePosition(lRecordNum);
            if(m_pSet->m_Comment.IsEmpty())
               GetDlgItem(IDC_COMMENT)->SetWindowText("");
            m_ctrlOperatorList.EnsureVisible(lRecordNum,FALSE);
            szMsg.Format("Record %ld of %d", lRecordNum+1, m_pSet->GetRecordCount());
            StatusMsg(szMsg);
            CheckForWaveFile();
            UpdateData(FALSE);
            m_ctrTime.SetTime(m_pSet->m_Date);
            SetCallPhonics();
         }
      } else if (m_ctrlVolume.GetDlgCtrlID() == pid)
      {
         ASSERT(m_ctrlVolume.IsWindowEnabled());
         VERIFY(m_smMixer.amdSetMasterVolumeValue(
            reinterpret_cast<CSliderCtrl *>(pScrollBar)->GetPos()));
         CString szVolume;
         DWORD dwMax = m_smMixer.amdGetMasterVolumeMaximum();
         szVolume.Format("Volume: %d", m_ctrlVolume.GetPos()/(dwMax/10));
         GetDlgItem(IDC_STATIC_VOL)->SetWindowText(szVolume);
         UpdateData(FALSE);
      }
   } else {
      CResizableDaoRecordView::OnHScroll(nSBCode, nPos, pScrollBar);
   }
}

void CNetControlView::OnKeydownCallSign(NMHDR* pNMHDR, LRESULT* pResult) 
{
   LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

   if(pLVKeyDow->wVKey == 46)
   {
      m_bDisableCallMonitor = true;
      m_bWasBackSpaceKey = true;
   }
   
   *pResult = 0;
}

void CNetControlView::OnChangeCall() 
{
   if(m_bDisableCallMonitor)
   {
      if(m_bWasBackSpaceKey)
      {
         m_bDisableCallMonitor = false;
         m_bWasBackSpaceKey = false;
      }
      return;
   }

   CString szCallSoFar;
   m_ctrlCall.GetWindowText(szCallSoFar);

   CNetControlSet* pSet = new CNetControlSet();
   pSet->m_strSort.Format("CallSign DESC");
   pSet->m_strFilter.Format("CallSign like '%s*'", szCallSoFar);

   m_ctrlLocalList.EnableWindow(TRUE);
   m_ctrlLocalList.GetDC()->SetBkColor(RGB(255,255,255));

   m_ctrlLocalList.ResetContent();
   
   int i = 0;
   pSet->Open();
   if(!pSet->IsEOF())
   {
      for(pSet->MoveFirst(); !pSet->IsEOF(); pSet->MoveNext())
      {
         if(m_ctrlLocalList.FindString(0,pSet->m_CallSign) == -1) {
            m_ctrlLocalList.AddString(pSet->m_CallSign);
            if (i++ > 20)
               break;
         }
      }
   }

   szCallSoFar.Format("%d Matches :", m_ctrlLocalList.GetCount());
   GetDlgItem(IDC_STATIC_MATCH)->SetWindowText(szCallSoFar);
   pSet->Close();
   delete pSet;
   pSet = NULL;

   SetCallPhonics();
}

void CNetControlView::OnBnClickedFindClear()
{
   m_ctrlFind.SetWindowTextA(_T(""));
   UpdateData(FALSE);
   m_ctrlFind.SetFocus();
}

void CNetControlView::OnChangeFind() 
{
   //LoadOperatorList();
   m_ctrlOperatorList.SetAllItemStates(LVIS_FOCUSED,LVIS_FOCUSED);

   CString szCallSoFar, szMsg;
   m_ctrlFind.GetWindowText(szCallSoFar);

   if(szCallSoFar.IsEmpty())
   {
      TRACE("OnChangeFind:: setting SE = TRUE\n");
      //m_bSignificantEvent = TRUE;
      LoadOperatorList();
      return;
   }

   m_ctrlOperatorList.LockWindowUpdate(); // Lock 

   CNetControlSet* pSet = new CNetControlSet();
   pSet->m_strSort.Format("CallSign DESC");
   pSet->m_strFilter.Format("CallSign like '%s*'", szCallSoFar);

   pSet->Open();
   int iFound = 0, iCount = 0;
   COLORREF rgb = RGB(249,249,233);
   rgb = RGB(0,0,0);
   LVFINDINFO* pFindInfo = new LVFINDINFO;
   char* pszCall = (char*) new char[8];
   for(iCount = 0; iCount < m_ctrlOperatorList.GetItemCount(); iCount++)
   {
      m_ctrlOperatorList.GetItemText(iCount,3,pszCall,8);
      CString szResult(pszCall);
      //m_ctrlOperatorList.GetItemBkColor(iCount,4);
      if(szResult.Find(szCallSoFar,0) == 0)
      {
         m_ctrlOperatorList.SetItemText(iCount,3, szResult, RGB(0,255,255), rgb);
         m_ctrlOperatorList.EnsureVisible(iCount,FALSE);
         iFound++;
      } else {
         m_ctrlOperatorList.SetItemText(iCount,3, szResult, RGB(0,0,0), RGB(255,255,255));
      }
   }
   szMsg.Format("%d of %d match", iFound, iCount);

   delete pszCall; pszCall = NULL;
   pSet->Close();  delete pSet;  pSet = NULL;

   StatusMsg(szMsg);
   m_ctrlOperatorList.UnlockWindowUpdate();// Unlock 
}

void CNetControlView::OnSound() 
{
   CString szSpeek;
   szSpeek.Format("CALLS\\%s.wav", m_pSet->m_CallSign);
   PlaySound(szSpeek,0,SND_FILENAME|SND_NODEFAULT|SND_ASYNC);   
   //PlaySound(szSpeek,0,SND_RESOURCE|SND_NODEFAULT|SND_ASYNC);   
}

void CNetControlView::CheckForWaveFile()
{
   CFile cfCallWaveFile;
   CString szCallWaveFilePath;
   szCallWaveFilePath.Format("CALLS\\%s.wav", m_pSet->m_CallSign);
   
   CFileStatus rStatus;
   if(cfCallWaveFile.GetStatus(szCallWaveFilePath,rStatus))
      m_bSound.EnableWindow(TRUE);
   else
      m_bSound.EnableWindow(FALSE);
}

void CNetControlView::OnPhonics() 
{
   CString szSpeek;
   CWaitCursor cursor; 
   int iCallLength = m_pSet->m_CallSign.GetLength();
   for(int i = 0; i < iCallLength; i++)
   {
      int iChar = m_pSet->m_CallSign.GetAt(i);
      szSpeek.Format("#%d", iChar);
      PlaySound(szSpeek,0,SND_RESOURCE|SND_NODEFAULT|SND_ASYNC);
      Sleep(600);
   }
}

void CNetControlView::FreeDatabaseCursor()
{
   m_lAbsolutePosition = m_pSet->GetAbsolutePosition();
   m_pSet->m_strFilter.Empty();
   m_pSet->Requery();

}

void CNetControlView::LockDatabaseCursor()
{
   CString szDate(GetDocument()->GetSelectedDate());
   m_pSet->m_strFilter.Format("Date like '%d/%d/%s*'", atoi(szDate.Mid(5,2)), 
                                                       atoi(szDate.Mid(8,2)), 
                                                       szDate.Mid(0,4));
   m_pSet->Requery();

   if(m_lAbsolutePosition != -1 && !m_pSet->IsEOF())
      m_pSet->SetAbsolutePosition(m_lAbsolutePosition);

   m_lAbsolutePosition = -1;
}

/*
void CNetControlView::OnShowGraph() 
{
   CRect rect;
   this->GetWindowRect(rect);
   CRect rct(0,0,rect.right,50);
   m_graph.Create("STATIC","",WS_VISIBLE|WS_CHILD,rct,this,1001);
   m_pRec = new Recorder();
   m_pRec->Open();
   m_pRec->SetBufferFunction((void*)&m_graph,Process);
   m_pRec->Start();
   m_graph.SetGraphType(FG_EQ_CHANNEL);
}
*/
/*
void CNetControlView::OnSelchangeGraph() 
{
   CString szSelection;
   int iCurSel = m_ctrlGraph.GetCurSel();
   if(iCurSel != -1)
      m_ctrlGraph.GetText(iCurSel,szSelection);

   if(szSelection.Compare(_T("Turn Off")) == 0)
   {
      if(m_pRec != NULL)
      {
         m_pRec->Stop();
         m_pRec->Close();
         delete m_pRec;
         m_pRec = NULL;
         m_graph.EnableWindow(FALSE);
      }
      return;
   }      

   if(m_pRec == NULL)
   {
      m_pRec = new Recorder();
      m_pRec->Open();
      m_pRec->SetBufferFunction((void*)&m_graph,Process);
      m_pRec->Start();
      m_graph.EnableWindow(TRUE);
      m_graph.SetGraphType(FG_EQ_CHANNEL);
   }

   if(szSelection.Compare(_T("EQ Mode")) == 0)
      m_graph.SetGraphType(FG_EQ_CHANNEL);
   else if(szSelection.Compare(_T("Spectrum")) == 0)
      m_graph.SetGraphType(FG_SPECTRUM);
   else if(szSelection.Compare(_T("Peak")) == 0)
      m_graph.SetGraphType(FG_PEAK);
   else if(szSelection.Compare(_T("Peak Alt")) == 0)
      m_graph.SetGraphType(FG_PEAK2);
   else if(szSelection.Compare(_T("Micro EQ")) == 0)
      m_graph.SetGraphType(FG_MICRO_EQ);
   else if(szSelection.Compare(_T("Oscilloscope")) == 0)
      m_graph.SetGraphType(FG_OSCILLOSCOPE);
   else if(szSelection.Compare(_T("PixelGram")) == 0)
      m_graph.SetGraphType(FG_PIXELGRAM);
}
*/
void CNetControlView::OnHistory() 
{
   CHistoryDlg   dlg;
   CString szCall;
   m_ctrlCall.GetWindowText(szCall);

   dlg.SetCallSign(szCall);
   dlg.DoModal();
}

void CNetControlView::OnDblclkOperatorList(NMHDR* pNMHDR, LRESULT* pResult) 
{
   OnHistory();
   
   *pResult = 0;
}

void CNetControlView::OnRecord() 
{
   if(m_bRecordSession) {
      m_bRecordSession = false;
      m_bRecord.SetIcon( IDI_RECORD, 32, 32 );
      m_bRecord.RedrawWindow();
      StatusMsg("Session Recording is OFF");

      if(m_pMonWave != NULL)
      {
         delete m_pMonWave;
         m_pMonWave = NULL;
      }

      if ( !m_pWaveIn->Close() ) {
         AfxMessageBox( m_pWaveIn->GetError() );
         return;
      }
      
      m_pMonWave = m_pWaveIn->MakeWave();
      
      CFile cfOutputFile;
      CFileStatus rStatus;
      CString szMsg, szPathName, szFileName;

      bool bPermission2Save = true;
      szFileName = GetDocument()->GetWaveFileName();
      szPathName = GetDocument()->GetWaveFilePath();

      CFileDialogST	dlg(FALSE, _T("wav"), szPathName, NULL, _T("All wave files\0*.wav\0"), NULL);

      if(dlg.DoModal() == IDOK)
      {
         POSITION Pos = dlg.GetStartPosition();
         szPathName = dlg.GetNextPathName(Pos);

         int iNameLoc = szPathName.ReverseFind('\\');
         
         if(iNameLoc != -1)
            szFileName = szPathName.Mid(iNameLoc+1);
         else
            szFileName = szPathName;

         if(cfOutputFile.GetStatus(szPathName,rStatus))
         {
            szMsg.Format("File %s exists! Overwrite?", szPathName);
            if(AfxMessageBox(szMsg, MB_YESNO) != IDYES)
               bPermission2Save = false;
         }

         if(bPermission2Save)
         {
            // this will automatically display a wait cursor
            CWaitCursor cursor; 
            m_pMonWave->Save(szPathName);
            GetDocument()->SetWaveFile(szFileName,szPathName,TRUE);
         }
      }
      
      delete m_pWaveIn;
      delete m_pWaveOut;

      m_pWaveIn = NULL;
      m_pWaveOut = NULL;
      
      GetDlgItem(IDC_RECORD)->SetWindowText("Off");

   } else {

      m_bRecordSession = true;
      m_bRecord.SetIcon( IDI_RECORD_ON, 40, 32 );
      m_bRecord.RedrawWindow();
      StatusMsg("Session Recording is ON");

      m_pMonWave = new CWave();
      m_pWaveIn  = new CWaveIn();
      m_pWaveOut = new CWaveOut();
      
      m_pMonWave->BuildFormat(1, 44100, 16);
      
      if ( !m_monDevice.IsInputFormat(*m_pMonWave) ) {
         AfxMessageBox("Format not supported");
         return;
      }
      
      m_pWaveIn->SetWaveFormat( m_pMonWave->GetFormat() );
      m_pWaveIn->SetDevice(m_monDevice);
      
      if ( !m_pWaveIn->Open() ) {
         AfxMessageBox( m_pWaveIn->GetError() );
         return;
      }
      if ( !m_pWaveIn->Record() ) {
         AfxMessageBox( m_pWaveIn->GetError() );
         return;
      }
      
      GetDlgItem(IDC_RECORD)->SetWindowText("On");
   }
}

void CNetControlView::OnEditGohome() 
{
   m_ctrlCall.SetFocus();
   m_ctrlCall.SetSel(0,-1,TRUE);
}

HBRUSH CNetControlView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
   HBRUSH hbr = CResizableDaoRecordView::OnCtlColor(pDC, pWnd, nCtlColor);
   
   // Day of the week when that day is today
   if( pWnd->GetDlgCtrlID() == m_iDayLab)
   {
      pDC->SetTextColor( RGB( 255, 0, 0 ) );
   }
   // Bring attention to an echolink login
   if (pWnd->GetDlgCtrlID() == IDC_ECHO_LOGINS)
   {
      pDC->SetBkColor(RGB(255, 0, 0));
      pDC->SetTextColor(RGB(255, 255, 255));
   }
   return hbr;
}

void CNetControlView::OnEditSelMatch1() 
{
   if(m_ctrlLocalList.GetCount() >= 1)
   {
      m_ctrlLocalList.SetCurSel(0);
      OnSelchangeLocalList() ;
   } else {
      OnLocalLookup();
   }
}

void CNetControlView::OnEditSelMatch2() 
{
   if(m_ctrlLocalList.GetCount() >= 2)
   {
      m_ctrlLocalList.SetCurSel(1);
      OnSelchangeLocalList() ;
   } else {
      OnLocalLookup();
   }
}

void CNetControlView::OnEditSelMatch3() 
{
   if(m_ctrlLocalList.GetCount() >= 3)
   {
      m_ctrlLocalList.SetCurSel(2);
      OnSelchangeLocalList() ;
   } else {
      OnLocalLookup();
   }
}

void CNetControlView::OnLocalLookup() 
{
   CString szCallSoFar;
   long lUniqueSystemIdentifier = 0;
   m_ctrlCall.GetWindowText(szCallSoFar);
   m_pFCCDbSet = new CFCCDbSet();
   m_pFCCDbSet->m_strFilter.Format("CallSign = '%s'", szCallSoFar);
   m_pFCCDbSet->Open();
   if(m_pFCCDbSet->IsOpen())
   {
       if (!m_pFCCDbSet->IsEOF() && !m_pFCCDbSet->IsBOF()) {

           m_pFCCDbSet->MoveFirst();

           for (m_pFCCDbSet->MoveFirst(); !m_pFCCDbSet->IsEOF(); m_pFCCDbSet->MoveNext())
           {
               if (!m_pFCCDbSet->m_CallSign.IsEmpty() && m_pFCCDbSet->m_CallSign.Compare(szCallSoFar) == 0)
               {
                   OnClear();
                   CString szLocation;
                   lUniqueSystemIdentifier = m_pFCCDbSet->m_UniqueSystemIdentifier;

                   GetDlgItem(IDC_CALL)->SetWindowText(m_pFCCDbSet->m_CallSign);
                   GetDlgItem(IDC_NAME)->SetWindowText(m_pFCCDbSet->m_EntityName);
                   m_pFCCDbSet->m_StreetAddress.TrimLeft();
                   if (!m_pFCCDbSet->m_StreetAddress.IsEmpty())
                   {
                       m_pSet->m_Street.Format("%s", m_pFCCDbSet->m_StreetAddress);
                       GetDlgItem(IDC_STREET)->SetWindowText(m_pFCCDbSet->m_StreetAddress);
                   }
                   else {
                       CString szPO(m_pFCCDbSet->m_POBox); szPO.Insert(0, "P.O. Box ");
                       m_pSet->m_Street = szPO;
                       GetDlgItem(IDC_STREET)->SetWindowText(szPO);
                   }
                   szLocation.Format("%s, %s %ld", m_pFCCDbSet->m_City,
                       m_pFCCDbSet->m_State,
                       m_pFCCDbSet->m_ZipCode);
                   GetDlgItem(IDC_LOCATION)->SetWindowText(szLocation);
               }
           }
       }
      GetDlgItem(IDC_CLASS)->SetWindowText("");
      GetDlgItem(IDC_COMMENT)->SetWindowText("");
      GetDlgItem(IDC_YOUR_GRID)->SetWindowText("");
      m_pSet->m_HasComments  = FALSE;
      m_pSet->m_HasTraffic   = FALSE;
      m_pSet->m_Acknowledged = FALSE;
      m_pSet->m_YourGrid.Empty();

      m_ctrlSelectedDate.GetTime(m_pSet->m_Date);
      m_pFCCDbSet->Close();

      m_pCallInfoSet = new CCallInfoSet();
      m_pCallInfoSet->m_strFilter.Format("UniqueSystemIdentifier = %ld", lUniqueSystemIdentifier);
      m_pCallInfoSet->Open();
      if(m_pCallInfoSet->IsOpen())
      {
          if (!m_pCallInfoSet->IsEOF() && !m_pCallInfoSet->IsBOF()) {

              m_pCallInfoSet->MoveFirst();

              for (m_pCallInfoSet->MoveFirst(); !m_pCallInfoSet->IsEOF(); m_pCallInfoSet->MoveNext())
              {
                  if (!m_pCallInfoSet->m_CallSign.IsEmpty() && m_pCallInfoSet->m_CallSign.Compare(szCallSoFar) == 0)
                  {
                      GetDlgItem(IDC_CLASS)->SetWindowText(m_pCallInfoSet->m_OperatorClass);
                  }
              }
          }
         m_pCallInfoSet->Close();
      }
      delete m_pCallInfoSet;
      m_pCallInfoSet = NULL;

      m_pSet->SetFieldDirty(&m_pSet->m_CallSign);
      m_pSet->SetFieldDirty(&m_pSet->m_Name);
      m_pSet->SetFieldDirty(&m_pSet->m_Street);
      m_pSet->SetFieldDirty(&m_pSet->m_Location);
      m_pSet->SetFieldDirty(&m_pSet->m_Class);
      m_pSet->SetFieldDirty(&m_pSet->m_Comment);
      m_pSet->SetFieldDirty(&m_pSet->m_HasComments);
      m_pSet->SetFieldDirty(&m_pSet->m_HasTraffic);
      m_pSet->SetFieldDirty(&m_pSet->m_Acknowledged);

   }
   delete m_pFCCDbSet;
   m_pFCCDbSet = NULL;   

}

void CNetControlView::OnClear() 
{
   //m_pSet->m_CallSign.Empty();
   m_pSet->m_Name.Empty();
   m_pSet->m_Street.Empty();
   m_pSet->m_Location.Empty();
   m_pSet->m_Class.Empty();
   m_pSet->m_Comment.Empty();
   m_pSet->m_eMailAddr.Empty();
   m_pSet->m_YourGrid.Empty();
   m_pSet->m_HasComments  = FALSE;
   m_pSet->m_HasTraffic   = FALSE;
   m_pSet->m_Acknowledged = FALSE;
   m_ctrlSelectedDate.GetTime(m_pSet->m_Date);
   m_pSet->SetFieldDirty(&m_pSet->m_CallSign);
   UpdateData(FALSE);
   m_ctrlCall.SetFocus();
   m_ctrlCall.SetSel(0, -1, TRUE);
}

void CNetControlView::OnChangePlace(UINT nID)
{
   UpdateData(TRUE);
	m_ctrlCall.SetFocus();
	m_ctrlCall.SetSel(0,-1,TRUE);
}

void CNetControlView::OnFileExportTxt() 
{
   CFile cf;
   bool bPermission2Save = true;
   COleDateTime cdt = COleDateTime::GetCurrentTime();
   int iYear  = cdt.GetYear();
   int iMonth = cdt.GetMonth();
   int iDay   = cdt.GetDay();
   CString szProposedFileName;
   szProposedFileName.Format("NetControl_%d-%d-%d", iYear, iMonth, iDay);
   CFileDialogST	dlg(FALSE, _T("TXT"), szProposedFileName, NULL, _T("All TEXT files\0*.txt\0"), NULL);
   
   if(dlg.DoModal() == IDOK)
   {
      POSITION Pos = dlg.GetStartPosition();
      CString szFileName, szPathName = dlg.GetNextPathName(Pos);
      
      int iNameLoc = szPathName.ReverseFind('\\');
      
      if(iNameLoc != -1)
         szFileName = szPathName.Mid(iNameLoc+1);
      else
         szFileName = szPathName;
      
      CFileStatus rStatus;
      if(cf.GetStatus(szPathName,rStatus))
      {
         CString szMsg = "File " + szPathName + " exists! Overwrite?";
         if(AfxMessageBox(szMsg, MB_YESNO) != IDYES)
            bPermission2Save = false;
      }
      
      if(bPermission2Save)
      {
         // this will automatically display a wait cursor
         CWaitCursor cursor; 
         
         if(m_pSet->IsOpen())
         {
            CFile cfRequest;
            CFileException e;
            
            cfRequest.Open(szFileName, CFile::modeCreate|CFile::modeWrite,&e);
            
            CString szFilter(m_pSet->m_strFilter);
            long lAbsPos = m_pSet->GetAbsolutePosition();
            
            if(m_bPerformFullExport || (!m_pSet->IsEOF() && !m_pSet->IsBOF()))
            {
               if(m_bPerformFullExport)
               {
                  m_pSet->m_strFilter.Empty();
                  m_pSet->Requery();
               }
               int nCount = 1;
               m_pSet->MoveFirst();
               CString szHeader;
               szHeader.Format("Num|UUID|Ack|Call|Name|Street|City State Zip|Class|Date|Comment\n");
               cfRequest.Write(szHeader,szHeader.GetLength());
               while(!m_pSet->IsEOF())
               {
                  CString szOutput;
                  szOutput.Format("%d|%d|%d|%s|%s|%s|%s|%s|%s|%s\n", 
                                  nCount++,
                                  m_pSet->m_ID,
                                  m_pSet->m_Acknowledged,
                                  m_pSet->m_CallSign,
                                  m_pSet->m_Name,
                                  m_pSet->m_Street,
                                  m_pSet->m_Location,
                                  m_pSet->m_Class,
                                  m_pSet->m_Date.Format("%m/%d/%Y"),
                                  m_pSet->m_Comment);
                  
                  if(!szOutput.IsEmpty())
                     cfRequest.Write(szOutput,szOutput.GetLength());
                  
                  m_pSet->MoveNext();
               }
            }
            if(m_bPerformFullExport)
            {
               m_pSet->m_strFilter = szFilter;
               m_pSet->Requery();
            }
            if(lAbsPos > -1)
               m_pSet->SetAbsolutePosition(lAbsPos);
            
            cfRequest.Close();
            
            CString szMsg;
            szMsg.Format("%s written to disk.", szFileName);
            StatusMsg(szMsg);
         }
      }
   } 
}

void CNetControlView::OnFileFullExport() 
{
   m_bPerformFullExport	= true;
   OnFileExportTxt();
   m_bPerformFullExport	= false;
}

void CNetControlView::OnKillfocusMyGrid() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
	UpdateData(TRUE);
   pApp->WriteProfileString(_T("UserSetting"), _T("MyGrid"), m_szMyGrid);
}

void CNetControlView::CalculateDistance()
{
   CString szDistance, szLongitude, szLatitude; 
   if(m_pSet->m_YourGrid.GetLength() == 6 )
   {
      if(m_szMyGrid.GetLength() == 6)
      {
         // Calculate my location in latitude longitude
         
         CString szLocator(m_szMyGrid), szNumberFormat;
         CString szHisLocator(m_pSet->m_YourGrid);
         CString szMeasurementUnit("miles");

         szLocator.MakeUpper();
         szLocator.TrimLeft();
         szLocator.TrimRight();

         szHisLocator.MakeUpper();
         szHisLocator.TrimLeft();
         szHisLocator.TrimRight();
         
         ///////////////////////////////////////////////////////
         //  EM84ux = 34degs 58' 15" North x 82deg 17' 30" West
         //           34.979166             -82.291666
         ///////////////////////////////////////////////////////
         
         double myLongitude = (szLocator.GetAt(0) - 'A') * 20 + 
                              (szLocator.GetAt(2) - '0') *  2 + 
                              (szLocator.GetAt(4) - 'A' + 0.5) / 12 - 180;
         double myLatitude  = (szLocator.GetAt(1) - 'A') * 10 + 
                              (szLocator.GetAt(3) - '0') + 
                              (szLocator.GetAt(5) - 'A' + 0.5) / 24 - 90;
         double hisLongitude = (szHisLocator.GetAt(0) - 'A') * 20 + 
                               (szHisLocator.GetAt(2) - '0') *  2 + 
                               (szHisLocator.GetAt(4) - 'A' + 0.5) / 12 - 180;
         double hisLatitude  = (szHisLocator.GetAt(1) - 'A') * 10 + 
                               (szHisLocator.GetAt(3) - '0') + 
                               (szHisLocator.GetAt(5) - 'A' + 0.5) / 24 - 90;

         szLongitude.Format("%8.3f", hisLongitude);
         szLatitude.Format("%8.3f", hisLatitude);

         double hn = myLatitude   / 180 * PI;
         double he = myLongitude  / 180 * PI;
         double n  = hisLatitude  / 180 * PI;
         double e  = hisLongitude / 180 * PI;
         
         double co = cos(he - e) * cos(hn) * cos(n) + sin(hn) * sin(n);
         double pk = sqrt(1 - co * co) / co;
         double pj = fabs(pk);
         double ca = atan(fabs(pj));
         if (co < 0) ca = PI - ca;
         double dx = (3964 * ca) * (szMeasurementUnit.Compare("kilometers") == 0 ? 1.609 : 1);
         szNumberFormat.Format("%ld", (long)dx);
         if(szNumberFormat.GetLength() > 3)
            szNumberFormat.Insert(szNumberFormat.GetLength()-3, ",");

         szDistance.Format("%s %s", szNumberFormat, szMeasurementUnit);

         m_szDistance.Format("Distance: %s", szDistance);

         if(m_pSet->m_Comment.Find("Distance:") == -1)
         {
            m_pSet->Edit();
            m_pSet->m_Comment += " " + m_szDistance;
            m_pSet->Update();
         }

      } else {
         m_szDistance.Format("Distance: Unknown");
      }
   } else {
      m_szDistance.Format("Distance: Unknown");
   }
   SetDlgItemText(IDC_STATIC_DISTANCE, m_szDistance);
}

void CNetControlView::OnSelchangeCalendar(NMHDR* pNMHDR, LRESULT* pResult) 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

   CString szSelectedDate;
   LPSYSTEMTIME pDateTime = new SYSTEMTIME;

   m_ctrlCalendar.GetCurSel(pDateTime);
   szSelectedDate.Format("%04d %02d %02d", pDateTime->wYear, pDateTime->wMonth, pDateTime->wDay);

   GetDocument()->m_szSelectedDate = szSelectedDate;

   TRACE("OnSelchangeCalendar:: setting SE = TRUE and calling OnUpdate\n");

   if(m_szSelectedDate.Compare(szSelectedDate) != 0)
   {
      if(!pApp->m_pLeftView->SelectDay(szSelectedDate))
      {
         //m_bSignificantEvent = TRUE;
         OnUpdate(this,NULL,NULL);
         m_szSelectedDate = szSelectedDate;
         UpdateData(FALSE);
      }
   }
   delete pDateTime;
   UpdateStartGroup();

	*pResult = 0;
}

void CNetControlView::UpdateStartGroup()
{
   LPSYSTEMTIME pDateTime = new SYSTEMTIME;
   m_ctrlCalendar.GetCurSel(pDateTime);
   m_iMyPlaceInd = pDateTime->wDayOfWeek;
   int previousSelectedDay = m_iDayLab;
   GetDlgItem(m_iDayLab)->SetFont(&m_DefaultFont);

   switch (m_iMyPlaceInd + 1)
   {
   case 1: { m_iDayLab = IDC_M_PLACE1; break; } // Sunday
   case 2: { m_iDayLab = IDC_M_PLACE2; break; } // Monday
   case 3: { m_iDayLab = IDC_M_PLACE3; break; } // Tuesday
   case 4: { m_iDayLab = IDC_M_PLACE4; break; } // Wednesday
   case 5: { m_iDayLab = IDC_M_PLACE5; break; } // Thrusday
   case 6: { m_iDayLab = IDC_M_PLACE6; break; } // Friday
   case 7: { m_iDayLab = IDC_M_PLACE1; break; } // Saturday
   }

   if (m_iMyPlaceInd == 6) m_iMyPlaceInd = 0;
   GetDlgItem(m_iDayLab)->SetFont(&m_boldFont);
   delete pDateTime;
}

void CNetControlView::OnSelectCalendar(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

bool CNetControlView::SelectDay(CString szDay)
{
   bool bSuccess = false;
   int nYear, nMonth, nDay, nHour = 0, nMin = 0, nSec = 0;
   nYear  = atoi(szDay.Mid(0,4).GetBuffer(0));
   nMonth = atoi(szDay.Mid(5,2).GetBuffer(0));
   nDay   = atoi(szDay.Mid(8,2).GetBuffer(0));
   CTime ct(nYear, nMonth, nDay, nHour, nMin, nSec);
   m_ctrlCalendar.SetCurSel(ct);
   return bSuccess;
}

void CNetControlView::OnBlastEmail() 
{
	CBlastEmailDlg dlg;
   dlg.m_szSelectedDate = m_pSet->m_Date.Format("%m/%d/%Y");
   dlg.DoModal();
   _chdir(m_szHome.GetBuffer(0));	
}

void CNetControlView::OnBnClickedTransmit()
{
	// Push indication to pi3 its time to transmit
   ToggleTransmitter();

	//FILE* fp = NULL;
	//fp=fopen("C:\\cygwin64\\home\\watson_d\\pi3\\toggle.txt", "w");
	if(m_bTransmitToggle) {
		//fputc('0', fp);
		m_bTransmitToggle = false;
		   m_buttonTransmit.SetIcon( IDR_TRANSMIT, 16, 16 );
	} else {
		//fputc('1', fp);
		m_bTransmitToggle = true;
		m_buttonTransmit.SetIcon( IDR_TRANSMIT_ON, 24, 24 );
	}
	//fclose(fp);
}

void CNetControlView::OnBnClickedPrenetRefresh()
{
    LoadPreNetList();
}

void CNetControlView::OnFccCheck()
{
	CFCCDbInfo fCCDbInfo;
   fCCDbInfo.DoModal();
}

void CNetControlView::OnQrzCheck()
{
	CFCCDbInfo qRZDbInfo;
   qRZDbInfo.m_bIsFCC = false;
   qRZDbInfo.m_szNewTitle = "QRZ Database Dialog";
   qRZDbInfo.m_szStatic1 = "Current QRZ Database: ";
   qRZDbInfo.m_szStatic2 = "Available QRZ Database: ";
   qRZDbInfo.m_szCheckButtonText = "Check QRZ Website";
   qRZDbInfo.DoModal();
}

void CNetControlView::OnFccDownload() 
{
   // creates the dialog if not already created
   if (m_pDownloadDlg->GetSafeHwnd() == 0) {
      m_pDownloadDlg->Create(); // displays the dialog window
   }
}

void CNetControlView::OnQrzDownload() 
{
   // creates the dialog if not already created
   //if (m_pDownloadDlg->GetSafeHwnd() == 0) {
   //   m_pDownloadDlg->Create(); // displays the dialog window
   //}
}

long CNetControlView::OnGoodbyeDnld(UINT wParam, LONG lParam)
{
   m_pDownloadDlg->DestroyWindow();

   return 0L;
}

long CNetControlView::OnGoodbyeFccBuild(UINT wParam, LONG lParam)
{
   CString szErr;
   LPSTR lpszError = new char[100];
   // try {
      m_pBuildFCCDbDlg->DestroyWindow();
      delete m_pBuildFCCDbDlg;
   /* } catch (CDaoException e) {
      e.GetErrorMessage(lpszError, 100);
      szErr.Format("%s", lpszError);
      AfxMessageBox(szErr);
   } catch (CException e) {
      e.GetErrorMessage(lpszError, 100);
      szErr.Format("%s", lpszError);
      AfxMessageBox(szErr);
   } catch (...) {
      AfxMessageBox("Unknown Error closing the FCC Database Compiler");
   }*/
   
   delete lpszError;
   return 0L;
}

void CNetControlView::OnFccExtract() 
{
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

   CFile cfZipFile;
   CString szZipFile("l_amat.zip");
   CFileStatus rStatus;
   CZipArchive zipFile;
   CString szSaveLocation = pApp->GetProfileString(_T("Settings"), _T("StorageLocation"), "");
   CString szFullPath;
   szFullPath.Format(_T("%s\\%s"), szSaveLocation, szZipFile);
   BOOL bStatus = cfZipFile.GetStatus(szFullPath,rStatus);

   if(bStatus)
      CWaitCursor cursor;
      zipFile.Open(szFullPath, CZipArchive::open, 0);
      int nNumEntries = zipFile.GetNoEntries();
      for (int i = 0; i < nNumEntries; i++)
      {
         CFileHeader fh;
         zipFile.GetFileInfo(fh, (WORD)i);
         CString szFileName(fh.m_szFileName);
         bool isDirectory = zipFile.IsFileDirectory((WORD)i);
         DWORD dwUncomprSize = fh.m_uUncomprSize;

         if((szFileName.Find("HD.dat") != -1) ||
            (szFileName.Find("EN.dat") != -1) ||
            (szFileName.Find("AM.dat") != -1))
         {
            zipFile.ExtractFile(i, szSaveLocation);
         }
      }
}

void CNetControlView::OnQrzExtract() 
{

}

void CNetControlView::OnUploadReverse()
{
   if(m_bUploadReverse)
      m_bUploadReverse = false;
   else
      m_bUploadReverse = true;
}

void CNetControlView::OnUploadAuto()
{
   if(m_bUploadAuto)
      m_bUploadAuto = false;
   else
      m_bUploadAuto = true;
}

void CNetControlView::OnUploadBrars()
{
   CUploadLog* pUploader = new CUploadLog();
   CNetControlSet* pSet = new CNetControlSet(); //&GetDocument()->m_netControlSet;
   pSet->m_strSort.Format("ID");
   CString szDate(GetDocument()->GetSelectedDate());
   pSet->m_strFilter.Format("Date like '%d/%d/%s*'", atoi(szDate.Mid(5,2)), 
                                                     atoi(szDate.Mid(8,2)), 
                                                     szDate.Mid(0,4));
   pSet->Open();
   if(pSet->IsOpen())
   {
      try
      {
         int nCount = 1;
         pUploader->SetUploadReverse(m_bUploadReverse);
         pSet->MoveFirst();
         CString szRecordCount, szDate(pSet->m_strFilter.Mid(11));
         szDate.Replace("'", NULL);     szDate.Replace("*", NULL);
         pUploader->SetDate(szDate);
         for(pSet->MoveFirst(); !pSet->IsEOF(); pSet->MoveNext())
         {
            szRecordCount.Format("%d", nCount);
            CString szRecord(pUploader->GetRecordTemplate());
            szRecord.Replace("RECORD", szRecordCount);
            szRecord.Replace("CALL", pSet->m_CallSign);
            szRecord.Replace("NAME", pSet->m_Name);
            szRecord.Replace("LOCATION", pSet->m_Location);

            CString szComment(pSet->m_Comment);
            if(pSet->m_HasComments)
               szComment.Insert(0, "<font color=\"#00FF00\">Is staying for comments. </font><br>");
            szRecord.Replace("COMMENTS", szComment);

            pUploader->AddRecord(szRecord);
            nCount++;
         }
         pUploader->Upload();
      }
      catch (...)
      {
         CString szErrMessage;
         szErrMessage.Format("No Matching Records for %s to upload...", pSet->m_strFilter);
         AfxMessageBox(szErrMessage);
      }
      
      pSet->Close();
      delete pSet;
      pSet = NULL;
   }
   delete pUploader;
   pUploader = NULL;
}

void CNetControlView::OnFccCompile() 
{
   m_pBuildFCCDbDlg = new CBuildFCCDbDlg(this);

   if (m_pBuildFCCDbDlg->GetSafeHwnd() == 0) {
      m_pBuildFCCDbDlg->Create(); // displays the dialog window
   }

   //CBuildFCCDbDlg dlg;
   //dlg.DoModal();
   //_spawnl( _P_NOWAITO, "BuildFCCDb.exe", " ", " ", NULL);
}

void CNetControlView::OnQrzCompile() 
{
   CFile cfOutputFile;
   CFileStatus rStatus;
   bool bPermission2Save = false;
   CString szDatabasePath, szPathName, szFileName, szMsg;
   CFileDialogST	dlg(TRUE, _T("csv"), szPathName, NULL, _T("All csv files\0*.csv\0"), NULL);
   
   if(dlg.DoModal() == IDOK)
   {
      POSITION Pos = dlg.GetStartPosition();
      szPathName = dlg.GetNextPathName(Pos);
      CString m_szCSVFileName(szPathName);
      
      int iNameLoc = szPathName.ReverseFind('\\');
      
      if(iNameLoc != -1)
         szFileName = szPathName.Mid(iNameLoc+1);
      else
         szFileName = szPathName;

      szDatabasePath = szPathName.Mid(0,iNameLoc) + "\\QRZ97.mdb";
      
      if(cfOutputFile.GetStatus(szDatabasePath,rStatus))
      {
         szMsg.Format("File %s exists! Overwrite?", szDatabasePath);
         if(AfxMessageBox(szMsg, MB_YESNO) == 6)
            bPermission2Save = true;
      }
      
      if(bPermission2Save)
      {
         // this will automatically display a wait cursor
         CWaitCursor cursor; 
         CQRZCDb db;
         db.m_szOutputFolder = szDatabasePath;
         db.m_szCSVFileName = m_szCSVFileName;
         db.CompileDB(szDatabasePath);
      }
   }
}

void CNetControlView::CallFCCDownload()   { OnFccDownload();     }
void CNetControlView::CallFCCExtract()    { OnFccExtract();      }
void CNetControlView::CallFCCCompile()    { OnFccCompile();      }
void CNetControlView::CallUploadBrars()   { OnUploadBrars();     }
void CNetControlView::CallUploadReverse() { OnUploadReverse();   }
void CNetControlView::CallUploadAuto()    { OnUploadAuto();      }
void CNetControlView::CallFccdbstatus()   { OnViewFccdbstatus(); }
void CNetControlView::CallFccCheck()      { OnFccCheck();        }
void CNetControlView::CallRecordPurge()   { OnRecordPurge();     }

void CNetControlView::CallQrzCheck()      { OnQrzCheck();        }
void CNetControlView::CallQrzDownload()   { OnQrzDownload();     }
void CNetControlView::CallQrzExtract()    { OnQrzExtract();      }
void CNetControlView::CallQrzCompile()    { OnQrzCompile();      }

void CNetControlView::OnEditCamelcase() 
{
   UpdateData(TRUE);

   CString szName(m_pSet->m_Name);
   CString szStreet(m_pSet->m_Street);
   CString szLocation(m_pSet->m_Location);

   m_pSet->Edit();
   m_pSet->m_Name = Capitalize(szName);
   m_pSet->m_Street = Capitalize(szStreet);
   m_pSet->m_Location = Capitalize(szLocation);
   m_pSet->m_Location.Replace(" Sc ", " SC ");
   m_pSet->m_Location.Replace(" Ga ", " GA ");
   m_pSet->m_Location.Replace(" Nc ", " NC ");
   m_pSet->Update();
   UpdateData(FALSE);
}

CString CNetControlView::Capitalize(CString szData)
{
   bool bNextIsUpper = true;
   for(int i = 0; i < szData.GetLength(); i++)
   {
      int iChar = szData.GetAt(i);

      if(bNextIsUpper)
      {
         if (iChar > 96 && iChar < 123)
         {
            iChar -= 32;
            szData.SetAt(i, iChar);
         }
      } else {
         if (iChar > 64 && iChar < 91)
         {
            iChar += 32;
            szData.SetAt(i, iChar);
         }
      }

      if ((iChar == 32) || (iChar == 40) ||
          (iChar > 48 && iChar < 58) ||
          (iChar == 46) || (iChar == 64)) 
         bNextIsUpper = true;
      else
         bNextIsUpper = false;
   }
   return szData;
}

void CNetControlView::OnViewFccdbstatus() 
{
	CFCCDbInfo fCCDbInfo;
   fCCDbInfo.DoModal();
}


void CNetControlView::OnEmptyDatabase()
{
   if (AfxMessageBox(_T("Remove All Entries?"), MB_YESNO) == IDYES) {
      AfxMessageBox(_T("Okay, Removing all records..."));

      m_pSet->m_strFilter.Empty();
      m_pSet->Requery();

      if (!m_pSet->IsEOF() && !m_pSet->IsBOF())  {
         for (m_pSet->MoveFirst(); !m_pSet->IsEOF(); m_pSet->MoveNext())
         {
            m_pSet->Delete();
         }
         m_pSet->m_pDatabase->m_pWorkspace->Close();
         m_pSet->m_pDatabase->Close();
         m_pSet->Close();

         //CFile::Remove(_T("NetControl-97-Compressed.mdb"));
         m_pSet->m_pDatabase->m_pWorkspace->CompactDatabase(m_pSet->GetDefaultDBName(), _T("NetControl-97-Compressed.mdb"));
         CFile::Remove(m_pSet->GetDefaultDBName());
         m_pSet->m_pDatabase->m_pWorkspace->CompactDatabase(_T("NetControl-97-Compressed.mdb"), m_pSet->GetDefaultDBName());

         m_pSet->Open();
      }
   } else{
      AfxMessageBox(_T("Okay, NOT removing any records..."));
   }

}

void CNetControlView::OnRecordPurge() 
{
	// Create a unique list of all calls in the database
   CStringList uniqueCalls;
   CNetControlSet* pSet = new CNetControlSet();
   pSet->Open();
   
   if(!pSet->IsEOF() && !pSet->IsBOF()) // Could have been deleted (better double check)
   {
      for(pSet->MoveFirst(); !pSet->IsEOF(); pSet->MoveNext())
      {
         if(!uniqueCalls.Find(pSet->m_CallSign))
         {
            uniqueCalls.AddTail(pSet->m_CallSign);
         } else {
            pSet->Delete();
         }
      }
   }

   m_pSet->m_pDatabase->m_pWorkspace->Close();
   m_pSet->m_pDatabase->Close();
   m_pSet->Close();
   pSet->Close();
   delete pSet;
   pSet = NULL;

   CFile::Remove(_T("NetControl-97-Compressed.mdb"));
   m_pSet->m_pDatabase->m_pWorkspace->CompactDatabase(m_pSet->GetDefaultDBName(),_T("NetControl-97-Compressed.mdb"));
   CFile::Remove(m_pSet->GetDefaultDBName());
   m_pSet->m_pDatabase->m_pWorkspace->CompactDatabase(_T("NetControl-97-Compressed.mdb"),m_pSet->GetDefaultDBName());

   m_pSet->Open();

   // Iterate through the unique list
   // Set filter to current unique call
   // Delete all records until only one remains
   // Compress and Repair the database
}



int CNetControlView::ToggleTransmitter(void)
{
   ZeroMemory( &m_siTXToggle, sizeof(m_siTXToggle) );
   ZeroMemory( &m_piTXToggle, sizeof(m_piTXToggle) );

	m_siTXToggle.dwFlags |= STARTF_USEPOSITION;
	m_siTXToggle.dwX = 1;
	m_siTXToggle.dwY = 1;
   m_siTXToggle.cb = sizeof(m_siTXToggle);

   m_ctlRemoteTX.GetWindowText(m_szRemoteTX);
   m_ctlRemoteTX.UpdateData();
	CString szApplicationName, szCommandLine;
	szApplicationName.Format("C:\\cygwin64\\bin\\mintty.exe");
	//szCommandLine.Format("C:\\cygwin64\\bin\\mintty.exe -w hide -e /home/watson_d/bin/TXToggle.bash");
	szCommandLine.Format("C:\\cygwin64\\bin\\mintty.exe -w hide -e /usr/bin/ssh -Y %s bin/TXToggle.bash", m_szRemoteTX);
	LPCTSTR lpApplicationName = szApplicationName.GetBuffer();
	LPTSTR lpCommandLine = szCommandLine.GetBuffer();

    // Start the child process. 
    if( !CreateProcess( lpApplicationName,   // No module name (use command line)
        lpCommandLine,  // Command line
        NULL,           // Process handle not inheritable
        NULL,           // Thread handle not inheritable
        FALSE,          // Set handle inheritance to FALSE
        0,              // No creation flags
        NULL,           // Use parent's environment block
        NULL,           // Use parent's starting directory 
        &m_siTXToggle,  // Pointer to STARTUPINFO structure
        &m_piTXToggle ) // Pointer to PROCESS_INFORMATION structure
    ) 
    {
        TRACE( "CreateProcess failed (%d)\n", GetLastError() );
    }

    WaitForSingleObject(m_piTXToggle.hProcess, INFINITE);
    ::CloseHandle(m_piTXToggle.hThread);
    ::CloseHandle(m_piTXToggle.hProcess);

    return 0;
}


void CNetControlView::OnBnClickedEchoRefresh()
{
   int checked = m_ctrlEchoRefresh.GetCheck();
   KillTimer(UPDATE_ECHOLINK);
   if (checked != 0) {
      int interval = atoi(m_szEchoRefInt.GetBuffer(0)) * 1000;
      SetTimer(UPDATE_ECHOLINK, interval, NULL);
   }
   else {
      KillTimer(UPDATE_ECHOLINK);
   }
}


