// NetControlView.h : interface of the CNetControlView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETCONTROLVIEW_H__F18BA6EF_5760_4267_BDA6_FFE946DF3912__INCLUDED_)
#define AFX_NETCONTROLVIEW_H__F18BA6EF_5760_4267_BDA6_FFE946DF3912__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SXButton.h"
#include "XListCtrl.h"
#include "ResizableDaoRecordView.h"
#include "SpectrumGraph.h"
#include "SoundMixer.h"
#include "Recorder.h"
#include "FCCDbSet.h"
#include "CallInfoSet.h"
#include "ClockST.h"
#include "QRZQuery.h"
#include "DownloadDlg.h"
#include "BuildFCCDbDlg.h"
#include "NetReportDlg.h"
#include "Wave.h"
#include "WaveDevice.h"
#include "WaveInterface.h"
#include "WaveOut.h"
#include "WaveIn.h"
#include "afxwin.h"

class CLeftView;
class CMainFrame;
class CNetControlSet;

struct TXToggle {
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
};

class CNetControlView : public CResizableDaoRecordView
{
private:
   CDownloadDlg* m_pDownloadDlg;
   CBuildFCCDbDlg* m_pBuildFCCDbDlg;
   CNetReportDlg* m_pNetReportDlg;
protected: // create from serialization only
	CNetControlView();
	DECLARE_DYNCREATE(CNetControlView)

public:
	//{{AFX_DATA(CNetControlView)
	enum { IDD = IDD_NETCONTROL_FORM };
	CMonthCalCtrl	m_ctrlCalendar;
	CSliderCtrl	m_ctrlVolume;
	CEdit	m_ctrlFind;
	CListBox	m_ctrlLocalList;
	CSXButton	m_bSound;
	CSXButton	m_bPhonics;
	CSXButton	m_bFileNew;
	CSXButton	m_bFileSave;
	CSXButton	m_bRecord;
   CSXButton	m_bMail;
	CSXButton   m_buttonTransmit;
	//CSXButton   m_buttonRefreshPrenet;
	CEdit	m_ctrlCall;
	CXListCtrl	m_ctrlOperatorList;
	CXListCtrl	m_ctrlPreNetCkList;
	CSliderCtrl	m_ctrlSlider1;
	CDateTimeCtrl	m_ctrlSelectedDate;
	CNetControlSet* m_pSet;
	int		m_iMyPlaceInd;
	CString	m_szMyGrid;
	CString	m_szDistance;
	COleDateTime	m_Time;
	//}}AFX_DATA

	//CListBox	m_ctrlGraph;
// Attributes
public:
	CNetControlDoc* GetDocument();
   CMainFrame* m_pFrame;

   STARTUPINFO m_siTXToggle;
   PROCESS_INFORMATION m_piTXToggle;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNetControlView)
	public:
	virtual CDaoRecordset* OnGetRecordset();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	CString Capitalize(CString szData);
	bool m_bUploadAuto;
	bool m_bUploadReverse;
   void CallFccCheck();
   void CallFccdbstatus();
   void CallUploadAuto();
   void CallUploadReverse();
   void CallUploadBrars();
	void CallFCCDownload();
	void CallFCCExtract();
	void CallFCCCompile();

   void CallQrzCheck();
	void CallQrzDownload();
	void CallQrzExtract();
	void CallQrzCompile();

   void CallRecordPurge();
   CString m_szHome;
   CString m_szPrenetURL;
   bool SelectDay(CString szDay);
	void CalculateDistance();
	CClockST			m_Clock;
	bool m_bPerformFullExport;
	void OnChangePlace(UINT nID);
	void SetCallPhonics();
	void LockDatabaseCursor();
	void FreeDatabaseCursor();
	void CheckForWaveFile();
   void LaunchDefaultBrowserTo(CString szURL);

   CSoundMixer m_smMixer;
	bool m_bDisableCallMonitor;
	bool m_bWasBackSpaceKey;
	void LoadOperatorList();
	void ReportCurrentPos();
	void StatusMsg(CString szMsg);
	virtual ~CNetControlView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

   int m_iDayLab;
	bool m_bRecordSession;
	CFont m_boldFont;
	CFont m_DefaultFont;
	HMIXER m_hMixer;
	CWaveIn* m_pWaveIn;
	CWaveOut* m_pWaveOut;
	CWaveDevice m_monDevice;
	CWave* m_pMonWave;
   CFCCDbSet* m_pFCCDbSet;
   CCallInfoSet* m_pCallInfoSet;
	BOOL m_bRangeSelected;
   CString m_szSelectedDate;
   CWebRequest m_webRequest;

protected:
   long m_lAbsolutePosition;
	//CFrequencyGraph m_graph;
	Recorder* m_pRec;
   CQRZQuery m_queryQRZ;

// Generated message map functions
protected:
	//{{AFX_MSG(CNetControlView)
	afx_msg void OnRecord();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnEditUndo();
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnQrzLookup();
	afx_msg void OnFccLookup();

   afx_msg void OnFccCheck();
	afx_msg void OnFccDownload();
	afx_msg void OnFccExtract();
	afx_msg void OnFccCompile();

	afx_msg void OnQrzCheck();
	afx_msg void OnQrzDownload();
	afx_msg void OnQrzExtract();
	afx_msg void OnQrzCompile();

   afx_msg void OnUploadBrars();
	afx_msg void OnUploadAuto();
	afx_msg void OnUploadReverse();
	afx_msg void OnRecordDelete();
	afx_msg void OnRecordFirst();
	afx_msg void OnRecordPrev();
	afx_msg void OnRecordNext();
	afx_msg void OnRecordLast();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnRclickOperatorList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickOperatorList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnChangeCall();
	afx_msg void OnSelchangeLocalList();
	afx_msg void OnChangeFind();
	afx_msg void OnSound();
	afx_msg void OnPhonics();
	afx_msg void OnKeydownOperatorList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeydownCallSign(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHistory();
	afx_msg void OnDblclkOperatorList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditGohome();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnEditSelMatch1();
	afx_msg void OnEditSelMatch2();
	afx_msg void OnEditSelMatch3();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLocalLookup();
	afx_msg void OnClear();
	afx_msg void OnFileExportTxt();
	afx_msg void OnFileFullExport();
	afx_msg void OnKillfocusMyGrid();
	afx_msg void OnSelchangeCalendar(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelectCalendar(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBlastEmail();
	afx_msg void OnEditCamelcase();
	afx_msg void OnViewFccdbstatus();
	afx_msg void OnRecordPurge();
	//}}AFX_MSG
    afx_msg long CNetControlView::OnGoodbyeDnld(UINT wParam, LONG lParam);
    afx_msg long CNetControlView::OnGoodbyeFccBuild(UINT wParam, LONG lParam);
	DECLARE_MESSAGE_MAP()
	//afx_msg void OnShowGraph();
	//afx_msg void OnSelchangeGraph();
public:
	CDateTimeCtrl m_ctrTime;   
	CString m_szRemoteTX;
   CEdit m_ctlRemoteTX;	
	CListBox m_ctrlEchoLogins;
	CButton m_ctrlEchoRefresh;
	CString m_szEchoRefInt;	
	bool m_bTransmitToggle;

	void LoadEcholinkLogins();
	void OnEmptyDatabase();
	void LoadPreNetList();
	void UpdateStartGroup();
	int ToggleTransmitter(void);

	afx_msg void OnBnClickedTransmit();
	afx_msg void OnBnClickedPrenetRefresh();
   afx_msg void OnNMDblclkPrenetList(NMHDR* pNMHDR, LRESULT* pResult);
   afx_msg void OnEnChangePrenetUrl();
   afx_msg void OnBnClickedNetReport();
   afx_msg void OnBnClickedMoveAll();
	afx_msg void OnBnClickedEchoRefresh();
	afx_msg void OnLbnDblclkEchoLogins();
	afx_msg void OnBnClickedFindClear();
};

#ifndef _DEBUG  // debug version in NetControlView.cpp
inline CNetControlDoc* CNetControlView::GetDocument()
   { return (CNetControlDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NETCONTROLVIEW_H__F18BA6EF_5760_4267_BDA6_FFE946DF3912__INCLUDED_)
