// QRZCDb.cpp: implementation of the CQRZCDb class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "netcontrol.h"
#include "QRZCDb.h"
#include "QRZDbSet.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CQRZCDb::CQRZCDb()
{

}

CQRZCDb::~CQRZCDb()
{

}

void CQRZCDb::CompileDB(CString szDatabasePath)
{
   CFile cf;
   InitQrzDatabase();
   cf.Open(m_szCSVFileName,CFile::modeRead);

   char* buffer = new char[cf.GetLength()+1];
   int iRead = cf.Read(buffer, cf.GetLength());
   buffer[iRead] = '\0';
   CString szFileData(buffer);

   cf.Close();

   CQRZDbSet qrzDbSet;
   qrzDbSet.Open(AFX_DAO_USE_DEFAULT_TYPE,NULL,dbAppendOnly|dbInconsistent);

   int iLoc = 0, iPos = szFileData.Find(0x0a,0)+1;
   while(iPos > 0)
   {
      int i = 0;
      if(iPos > 155)
      {
         qrzDbSet.AddNew();
         CString szOneline(szFileData.Mid(iLoc,iPos));
         int iOneLineILoc = 0, iOneLineIPos = szOneline.Find(",",0);
         while (iOneLineIPos > 0)
         {
            CString szOneword(szOneline.Mid(iOneLineILoc,iOneLineIPos-iOneLineILoc));
            szOneword.Replace("\"","");
            switch (i++) {
            case 0: { qrzDbSet.m_CallSign          = szOneword.Mid(0,10); } break;
            case 1: { qrzDbSet.m_LastName          = szOneword.Mid(0,20); } break;
            case 2: { qrzDbSet.m_Country           = atoi(szOneword.GetBuffer(0)); } break;
            case 3: { qrzDbSet.m_FirstName         = szOneword.Mid(0,20); } break;
            case 4: { qrzDbSet.m_JPG               = szOneword.Mid(0,10); } break;
            case 5: { qrzDbSet.m_Unused            = szOneword.Mid(0,10); } break;
            case 6: { qrzDbSet.m_Efective          = szOneword.Mid(0,10); } break;
            case 7: { qrzDbSet.m_Expires           = szOneword.Mid(0,10); } break;
            case 8: { qrzDbSet.m_Street            = szOneword.Mid(0,60); } break;
            case 9: { qrzDbSet.m_City              = szOneword.Mid(0,20); } break;
            case 10:{ qrzDbSet.m_State             = szOneword.Mid(0, 2); } break;
            case 11:{ qrzDbSet.m_ZipCode           = szOneword.Mid(0, 9); } break;
            case 12:{ qrzDbSet.m_OperatorClass     = szOneword.Mid(0,10); } break;
            case 13:{ qrzDbSet.m_PreviousCallSign1 = szOneword.Mid(0,10); } break;
            case 14:{ qrzDbSet.m_PreviousCallSign2 = szOneword.Mid(0,10); } break;
            }
            iOneLineILoc = iOneLineIPos +1;
            iOneLineIPos = szOneline.Find(",",iOneLineILoc);
         }
         qrzDbSet.Update();
      }
      iLoc = iPos +1;
      iPos = szFileData.Find(0x0a,iLoc);
   }
   
   qrzDbSet.Close();
   delete [] buffer;
}

bool CQRZCDb::InitQrzDatabase()
{
   bool bSuccess = true;

   // try   {
      CFile cf;
      CFileStatus rStatus;
      BOOL bStatus = cf.GetStatus(m_szOutputFolder,rStatus);
      
      if(bStatus)
         CFile::Remove(m_szOutputFolder);
      
      CDaoWorkspace ws;
      CDaoDatabase db(&ws);
      ASSERT_VALID(&ws);
      
      db.Create(m_szOutputFolder);
      
      CDaoTableDef td( &db );

      // ###################################
      // Start work in the EN data set now.
      // ###################################
      //
      // "Callsign","LastName","Country","FirstName","JPG","Unused"
      // "Effective","Expires","Street","City","State","ZipCode"
      // "Class","PreviousCall","PreviousClass"

      td.Create("QRZ");
      ASSERT_VALID(&td);

      td.CreateField("CallSign",               dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("LastName",               dbText, 21, dbVariableField|dbUpdatableField);
      td.CreateField("Country",                dbLong,  0, dbFixedField|dbUpdatableField);
      td.CreateField("FirstName",              dbText, 21, dbVariableField|dbUpdatableField);
      td.CreateField("JPG",                    dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("Unused",                 dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("Efective",               dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("Expires",                dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("Street",                 dbText, 61, dbVariableField|dbUpdatableField);
      td.CreateField("City",                   dbText, 21, dbVariableField|dbUpdatableField);
      td.CreateField("State",                  dbText,  3, dbVariableField|dbUpdatableField);
      td.CreateField("ZipCode",                dbText, 10, dbVariableField|dbUpdatableField);
      td.CreateField("OperatorClass",          dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("PreviousCallSign1",      dbText, 11, dbVariableField|dbUpdatableField);
      td.CreateField("PreviousCallSign2",      dbText, 11, dbVariableField|dbUpdatableField);

      CDaoIndexFieldInfo indexFieldinfo[1];
      indexFieldinfo[0].m_strName.Format("CallSign");
      indexFieldinfo[0].m_bDescending = false;

      CDaoIndexInfo indexInfo;
      indexInfo.m_strName.Format("CallSign");
      indexInfo.m_pFieldInfos = indexFieldinfo;
      indexInfo.m_nFields = 1;
      indexInfo.m_bRequired = true;
      indexInfo.m_bUnique = false;
      indexInfo.m_bPrimary = false;

      td.CreateIndex(indexInfo);
      td.Append();
      td.Close();
      
      db.Close();

      /*}  catch (CException e) {

       LPSTR lpszError = new char[100];
       e.GetErrorMessage(lpszError, 100);
       delete lpszError;
       CString szErr(lpszError);
       AfxMessageBox(szErr);

       bSuccess = false;

   } catch (CDaoException e) {

      LPSTR lpszError = new char[100];
      e.GetErrorMessage(lpszError, 100);
      delete lpszError;
      CString szErr(lpszError);
      AfxMessageBox(szErr);

      bSuccess = false;

   }  catch (CDaoException e) {
        catch (CException e) {

      LPSTR lpszError = new char[100];
      e.GetErrorMessage(lpszError, 100);
      delete lpszError;
      CString szErr(lpszError);
      AfxMessageBox(szErr);

      bSuccess = false;
   }*/

   return bSuccess;
}