// QRZQuery.cpp: implementation of the CQRZQuery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NetControl.h"
#include "QRZQuery.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CQRZQuery::CQRZQuery()
{
   m_webRequest.SetServer("xmldata.qrz.com");
   m_webRequest.SetPort("80");
   m_szSessionKey = "4430uaa1f88491a1930c13acc0f7da303fa68";
   m_szSessionKey.Empty();
   m_szUser = "w4djw";
   m_szPass = "harrydog";
}

CQRZQuery::~CQRZQuery()
{

}


CString CQRZQuery::GetNewSessionKey()
{
   CString szQuery, szWebPage;

   szQuery.Format("bin/xml/?username=%s;password=%s;agent=w4djw.0", m_szUser, m_szPass);

   m_webRequest.SetProcessor(szQuery);

   szWebPage = m_webRequest.SubmitRequest(szQuery);

   if(!szWebPage.IsEmpty()) {

      // Store the results to the hard drive

      CFile cfRequest;
      cfRequest.Open("QrzSessionKey.xml", CFile::modeCreate|CFile::modeWrite);
      cfRequest.Write(szWebPage.GetBuffer(0),szWebPage.GetLength());
      cfRequest.Close();

   }

   int iPos = szWebPage.Find("<Key>",0) + 5;
   int iLoc = szWebPage.Find("</Key>",0) - iPos;
   if(iPos > 5)
   {
      m_szSessionKey = szWebPage.Mid(iPos,iLoc);
   }

   return m_szSessionKey;
}

CString CQRZQuery::GetSessionKey()
{
   if(!m_szSessionKey.IsEmpty())
      return m_szSessionKey;
   else 
      m_szSessionKey = ReadFromFile();

   if(m_szSessionKey.IsEmpty())

      m_szSessionKey = GetNewSessionKey();

   return m_szSessionKey;
}

CString CQRZQuery::ReadFromFile()
{
   CFile cfRequest;
   if (cfRequest.Open("QrzSessionKey.xml", CFile::modeRead) != 0)
   {
      char* buffer = new char[cfRequest.GetLength()+1];
      int iRead = cfRequest.Read(buffer, cfRequest.GetLength());
      buffer[iRead] = '\0';
      CString szFileData(buffer);
      cfRequest.Close();
      
      int iPos = szFileData.Find("<Key>",0) + 5;
      int iLoc = szFileData.Find("</Key>",0) - iPos;
      if(iPos > 5)
      {
         m_szSessionKey = szFileData.Mid(iPos,iLoc);
      }
      
      delete [] buffer;
   }
   return m_szSessionKey;
}

BOOL CQRZQuery::LookupCallSign(CString szCallSign)
{
   CString szQuery;
   BOOL bSuccess = FALSE;

   GetSessionKey();

   //szQuery.Format("bin/xml?s=%s;callsign=%s", m_szSessionKey, szCallSign);
   szQuery.Format("xml/current/?s=%s;callsign=%s", m_szSessionKey, szCallSign);
   m_webRequest.SetProcessor(szQuery);
   m_szQueryResponse = m_webRequest.SubmitRequest(szQuery);

   if(m_szQueryResponse.Find("<Error>Session Timeout</Error>") != -1 ||
      m_szQueryResponse.Find("<Error>Invalid session key</Error>") != -1 ||
      m_szQueryResponse.Find("<Error>XML access is not autho") != -1 )
   {
      GetNewSessionKey();
      szQuery.Format("bin/xml?s=%s;callsign=%s", m_szSessionKey, szCallSign);
      m_webRequest.SetProcessor(szQuery);
      m_szQueryResponse = m_webRequest.SubmitRequest(szQuery);
   }

   if(!m_szQueryResponse.IsEmpty()) {

      // Store the results to the hard drive

      CFile cfRequest;
      cfRequest.Open("QrzCallData.xml", CFile::modeCreate|CFile::modeWrite);
      cfRequest.Write(m_szQueryResponse.GetBuffer(0),m_szQueryResponse.GetLength());
      cfRequest.Close();

      // Load up the member variables

      ParseResponse();

      bSuccess = TRUE;

   }

   return bSuccess;
}

void CQRZQuery::ParseResponse()
{
   m_NameFirst    = GetTagData("fname");
   m_NameLast     = GetTagData("name");
   if(m_NameFirst.Find(" ") != -1)
   {
      int iLoc = m_NameFirst.Find(" ");
      m_NameMI    = m_NameFirst.Mid(iLoc+1);
      CString szTemp = m_NameFirst.Mid(0,iLoc);
      m_NameFirst = szTemp;
   }
   m_AddressLine1 = GetTagData("addr1");
   //m_AddressLine2 = GetTagData("addr2");
   m_City         = GetTagData("addr2");
   m_State        = GetTagData("state");
   m_Zip          = GetTagData("zip");
   m_EmailAddress = GetTagData("email");
   m_Country      = GetTagData("country");
   m_County       = GetTagData("county");
   m_Grid         = GetTagData("grid");
   m_Lookups      = atoi(GetTagData("u_views").GetBuffer(0));
   m_LicenseClass = GetTagData("class");
   m_ExpirationDate = GetExpDate();
   if(!m_Grid.IsEmpty())
      m_szDistance = GetDistance();
}

CString CQRZQuery::GetTagData(CString szTag)
{
   CString szData;
   CString szBeginTag = "<" + szTag + ">";
   CString szEndingTag = "</" + szTag + ">";
   int iLen = szTag.GetLength() + 2;

   int iPos = m_szQueryResponse.Find(szBeginTag,0) + iLen;
   if(iPos)
   {
      int iLoc = m_szQueryResponse.Find(szEndingTag,iPos) - iPos;
      szData = m_szQueryResponse.Mid(iPos,iLoc);
   }

   return szData;
}

COleDateTime CQRZQuery::GetExpDate()
{
   // Format is YYYY-MM-DD
   CString szExpDate(GetTagData("expdate"));
   COleDateTime dtExpDate, dtExp;

   // Expires
   if(!szExpDate.IsEmpty())
   {
      int iD = atoi(szExpDate.Mid(8,2));
      int iM = atoi(szExpDate.Mid(5,2));
      int iY = atoi(szExpDate.Mid(0,4));
      
      COleDateTime dtExp(iY,iM,iD,0,0,0);  

      if(dtExp.GetStatus() == 0)
         dtExpDate = dtExp;
   }
   return dtExpDate;
}

CString CQRZQuery::GetDistance()
{
   CString szDistance;
	CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();
	m_szMyGrid = pApp->GetProfileString(_T("StorageSettings"), _T("GridSquare"), _T(""));
   m_szMeasurementUnit = pApp->GetProfileString(_T("StorageSettings"), _T("MeasurementUnit"), _T("miles"));

   //Calculate Distance
   if(m_Grid.GetLength() == 6 )
   {
      if(m_szMyGrid.GetLength() == 6)
      {
         // Calculate my location in latitude longitude
         
         CString szLocator(m_szMyGrid), szNumberFormat;
         CString szHisLocator(m_Grid);
         
         szLocator.MakeUpper();
         szLocator.TrimLeft();
         szLocator.TrimRight();
         
         szHisLocator.MakeUpper();
         szHisLocator.TrimLeft();
         szHisLocator.TrimRight();
         
         ///////////////////////////////////////////////////////
         //  EM84ux = 34degs 58' 15" North x 82deg 17' 30" West
         //           34.979166             -82.291666
         ///////////////////////////////////////////////////////
         
         double myLongitude = (szLocator.GetAt(0) - 'A') * 20 + 
            (szLocator.GetAt(2) - '0') *  2 + 
            (szLocator.GetAt(4) - 'A' + 0.5) / 12 - 180;
         double myLatitude  = (szLocator.GetAt(1) - 'A') * 10 + 
            (szLocator.GetAt(3) - '0') + 
            (szLocator.GetAt(5) - 'A' + 0.5) / 24 - 90;
         double hisLongitude = (szHisLocator.GetAt(0) - 'A') * 20 + 
            (szHisLocator.GetAt(2) - '0') *  2 + 
            (szHisLocator.GetAt(4) - 'A' + 0.5) / 12 - 180;
         double hisLatitude  = (szHisLocator.GetAt(1) - 'A') * 10 + 
            (szHisLocator.GetAt(3) - '0') + 
            (szHisLocator.GetAt(5) - 'A' + 0.5) / 24 - 90;
         
         double hn = myLatitude   / 180 * 3.1415926535;
         double he = myLongitude  / 180 * 3.1415926535;
         double n  = hisLatitude  / 180 * 3.1415926535;
         double e  = hisLongitude / 180 * 3.1415926535;
         
         double co = cos(he - e) * cos(hn) * cos(n) + sin(hn) * sin(n);
         double pk = sqrt(1 - co * co) / co;
         double pj = fabs(pk);
         double ca = atan(fabs(pj));
         if (co < 0) ca = 3.1415926535 - ca;
         double dx = (3964 * ca) * (m_szMeasurementUnit.Compare("kilometers") == 0 ? 1.609 : 1);
         szNumberFormat.Format("%ld", (long)dx);
         if(szNumberFormat.GetLength() > 3)
            szNumberFormat.Insert(szNumberFormat.GetLength()-3, ",");
         
         szDistance.Format("%s %s", szNumberFormat, m_szMeasurementUnit);
         
         
      } else {
         szDistance.Empty();
      }
   } else {
      szDistance.Empty();
   }
   return szDistance;
}
