// ResizableDaoRecordView.cpp : implementation file
//
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2001 by Paolo Messina
// (http://www.geocities.com/ppescher - ppescher@yahoo.com)
//
// The contents of this file are subject to the Artistic License (the "License").
// You may not use this file except in compliance with the License. 
// You may obtain a copy of the License at:
// http://www.opensource.org/licenses/artistic-license.html
//
// If you find this code useful, credits would be nice!
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ResizableDaoRecordView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResizableDaoRecordView

IMPLEMENT_DYNAMIC(CResizableDaoRecordView, CDaoRecordView)

inline void CResizableDaoRecordView::Construct()
{
	m_bInitDone = FALSE;
}

CResizableDaoRecordView::CResizableDaoRecordView(UINT nIDTemplate)
	: CDaoRecordView(nIDTemplate)
{
	Construct();
}

CResizableDaoRecordView::CResizableDaoRecordView(LPCTSTR lpszTemplateName)
	: CDaoRecordView(lpszTemplateName)
{
	Construct();
}

CResizableDaoRecordView::~CResizableDaoRecordView()
{
}


BEGIN_MESSAGE_MAP(CResizableDaoRecordView, CDaoRecordView)
	//{{AFX_MSG_MAP(CResizableDaoRecordView)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResizableDaoRecordView diagnostics

#ifdef _DEBUG
void CResizableDaoRecordView::AssertValid() const
{
	CDaoRecordView::AssertValid();
}

void CResizableDaoRecordView::Dump(CDumpContext& dc) const
{
	CDaoRecordView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CResizableDaoRecordView message handlers

void CResizableDaoRecordView::OnSize(UINT nType, int cx, int cy) 
{
	CDaoRecordView::OnSize(nType, cx, cy);
	
	if (m_bInitDone)
		ArrangeLayout();
}

void CResizableDaoRecordView::OnInitialUpdate() 
{
	CDaoRecordView::OnInitialUpdate();
	
	m_bInitDone = TRUE;

	// MDI child need this
	ArrangeLayout();
}

void CResizableDaoRecordView::GetTotalClientRect(LPRECT lpRect)
{
	GetClientRect(lpRect);

	// get scrollable size
	CSize size = GetTotalSize();

	// before initialization, "size" is dialog template size
	if (!m_bInitDone)
	{
		lpRect->right = lpRect->left + size.cx;
		lpRect->bottom = lpRect->top + size.cy;
		return;
	}

	// otherwise, give correct size if scrollbars active

	if (m_nMapMode < 0)	// scrollbars disabled
		return;

	// enlarge reported client area when needed
	CRect rect(lpRect);
	if (rect.Width() < size.cx)
		lpRect->right = lpRect->left + size.cx;
	if (rect.Height() < size.cy)
		lpRect->bottom = lpRect->top + size.cy;
}

BOOL CResizableDaoRecordView::OnEraseBkgnd(CDC* pDC) 
{
	ClipChildren(pDC);	// avoid flickering

	return CDaoRecordView::OnEraseBkgnd(pDC);
}
