// UploadLog.cpp: implementation of the CUploadLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "netcontrol.h"
#include "UploadLog.h"
#include "WebRequest.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUploadLog::CUploadLog()
{
   m_bUploadReverse = false;
   m_nRecordCount = 0;
   m_szTemplate = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n"
                  "        \"http://www.w3.org/TR/1999/REC.php401-19991224/loose.dtd\"> \n"
                  "<HTML> \n"
                  "<HEAD> \n"
                  "   <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text.php; charset=iso-8859-1\"> \n"
                  "   <META NAME=\"GENERATOR\" CONTENT=\"Mozilla/4.04 [en] (Win95; I) [Netscape]\"> \n"
                  "   <TITLE>BRARS Net Log</TITLE> \n"
                  "   <LINK REL=\"stylesheet\" HREF=\"/css/brars.css\" TYPE=\"text/css\" TITLE=\"BRARS Stylesheet\"> \n"
                  "   <meta http-equiv=\"refresh\" content=\"120\" /> \n"
                  "</HEAD> \n"
                  "<body style=\"filter:progid:DXImageTransform.Microsoft.Gradient(endColorstr='#def7fc',\n"
                  "             startColorstr='#FFFFFF', gradientType='0');\"> \n"
                  "<p align=\"center\"> \n"
                  "  <table border=0 align=\"center\"> \n"
                  "    <tr><td align=\"center\" colspan=3> \n"
                  "      <img src=\"NetLog.png\" alt=\"BRARS NetLog\" border=\"0\" align=\"center\"> \n"
                  "    </td></tr> \n"
                  "  </table> \n"
                  "</p> \n"
                  "<hr> \n"
                  "<center><h3><P>RECORDCOUNT Stations Checked in to the Blue Ridge 2 Meter Net on DATE<br></h3></center> \n"
                  " \n"
                  "<table cellpadding=\"3\" cellspacing=\"3\" align=\"center\" border=\"0\" width=\"80%\" bgcolor=\"#182946\" class=\"TableHeight100\"> \n"
                  "  <tr align=center> \n"
                  "   <th class=\"TableBorder-3d-i\" width=\"20\"><div align=\"left\" class=\"headline-10p\">Count</th> \n"
                  "   <th class=\"TableBorder-3d-i\" width=\"90\"><div align=\"left\" class=\"headline-10p\">Station Call</th> \n"
                  "   <th class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\">Name</th> \n"
                  "   <th class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\">Location</th> \n"
                  "   <th class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\">Comments</th> \n"
                  "  </tr> \n"
                  "RECORDENTRIESHERE"
                  "</table> \n"
                  "<hr align='center'> \n"
                  "<p align='left'><font size='-2'>Send your comments or inquiries to: <a href='mailto:brars@brars.org'>brars@brars.org</a></font></p> \n"
                  "<p align='left'><font size='-2'>2010 Blue Ridge Amateur Radio Society, Inc.</font> \n"
                  "</p><p align='left'><font size='-2'>Back to <a href='/' TARGET='_top'>BRARS</a> page</font></p><p align='left'><font size='-2'><a href='mailto:webmaster@brars.org'>Webmaster</a></font></p> \n"
                  "</BODY> \n"
                  "</HTML>\n";


   m_szRecTemplate = "  <tr align=center>\n"
                     "    <td class=\"TableBorder-3d-i\"><div align=\"right\" class=\"headline-10p\">\n"
                     "      RECORD.) \n"
                     "    </td>\n"
                     "    <td class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\">\n"
                     "      <a href=http://www.qrz.com/db/CALL>CALL</a>\n"
                     "    </td>\n"
                     "    <td class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\"><b>\n"
                     "      <font color=\"#53B5D5\">NAME</font>\n"
                     "    </td>\n"
                     "    <td class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\"><b>\n"
                     "      <font color=\"#53B5D5\">LOCATION</font>\n"
                     "    </td>\n"
                     "    <td class=\"TableBorder-3d-i\"><div align=\"left\" class=\"headline-10p\"><b>\n"
                     "      <font color=\"#53B5D5\">COMMENTS</font>\n"
                     "    </td>\n"
                     "  </tr>\n";

}

CUploadLog::~CUploadLog()
{

}

void CUploadLog::AddRecord(CString szRecord)
{
   m_nRecordCount++;
   if(m_bUploadReverse)
      m_szRecords.Insert(0, szRecord);
   else
     m_szRecords += szRecord;
}

void CUploadLog::Init()
{
   m_nRecordCount = 0;
   m_szRecords.Empty();
}

void CUploadLog::Upload()
{
   CString szPayload(m_szTemplate), szRecordCount;
   szRecordCount.Format("%d", m_nRecordCount);
   szPayload.Replace("DATE", m_szDate);
   szPayload.Replace("RECORDENTRIESHERE", m_szRecords);
   szPayload.Replace("RECORDCOUNT", szRecordCount);

   CFile cf;
   cf.Open("NetLog.html", CFile::modeCreate|CFile::modeWrite);
   cf.Write(szPayload,szPayload.GetLength());
   cf.Close();

   CWebRequest web;
   web.SetServer("bluerie8@blueridgears.org");
   web.SetPort("80");
   web.SetProcessor("cgi-bin/netlog.cgi");
   web.SubmitRequest(szPayload);
}

CString CUploadLog::GetRecordTemplate()
{
   return m_szRecTemplate;
}

void CUploadLog::SetDate(CString szDate)
{
   m_szDate = szDate;
}

void CUploadLog::SetUploadReverse(bool bUploadReverse)
{
   m_bUploadReverse = bUploadReverse;
}
