// WaveFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetControl.h"
#include "WaveFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaveFileDlg dialog


CWaveFileDlg::CWaveFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaveFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWaveFileDlg)
	m_szFileName = _T("");
	m_szFolderName = _T("");
	m_bWaveRemember = FALSE;
	//}}AFX_DATA_INIT
}


void CWaveFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaveFileDlg)
	DDX_Text(pDX, IDC_WAVE_FILE, m_szFileName);
	DDX_Text(pDX, IDC_WAVE_FOLDER, m_szFolderName);
	DDX_Check(pDX, IDC_WAVE_REMEMBER, m_bWaveRemember);
   DDX_Control(pDX, IDC_BROWSE, m_bBrowse);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWaveFileDlg, CDialog)
	//{{AFX_MSG_MAP(CWaveFileDlg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaveFileDlg message handlers

BOOL CWaveFileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
   m_bBrowse.SubclassDlgItem( IDC_BROWSE, GetParent());
   m_bBrowse.SetIcon( IDI_FOLDER, 16, 16 );
   m_bBrowse.SetImagePos(CPoint(5, SXBUTTON_CENTER ));
   m_bBrowse.SetTextPos(CPoint(SXBUTTON_CENTER, SXBUTTON_CENTER ));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CString strTmpPath;

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TCHAR szDir[MAX_PATH];
	switch(uMsg){
	case BFFM_INITIALIZED:
		if (lpData){
			strcpy(szDir, strTmpPath.GetBuffer(strTmpPath.GetLength()));
			SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)szDir);
		}
		break;
	case BFFM_SELCHANGED: {
	   if (SHGetPathFromIDList((LPITEMIDLIST) lParam ,szDir)){
		  SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)szDir);
	   }
	   break;
	}
	default:
	   break;
	}
         
	return 0;
}

BOOL CWaveFileDlg::GetFolder(CString* strSelectedFolder,
				   const char* lpszTitle,
				   const HWND hwndOwner, 
				   const char* strRootFolder, 
				   const char* strStartFolder)
{
	char pszDisplayName[MAX_PATH];
	LPITEMIDLIST lpID;
	BROWSEINFOA bi;
	
	bi.hwndOwner = hwndOwner;
	if (strRootFolder == NULL){
		bi.pidlRoot = NULL;
	}else{
	   LPITEMIDLIST  pIdl = NULL;
	   IShellFolder* pDesktopFolder;
	   char          szPath[MAX_PATH];
	   OLECHAR       olePath[MAX_PATH];
	   ULONG         chEaten;
	   ULONG         dwAttributes;

	   strcpy(szPath, (LPCTSTR)strRootFolder);
	   if (SUCCEEDED(SHGetDesktopFolder(&pDesktopFolder)))
	   {
		   MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szPath, -1, olePath, MAX_PATH);
		   pDesktopFolder->ParseDisplayName(NULL, NULL, olePath, &chEaten, &pIdl, &dwAttributes);
		   pDesktopFolder->Release();
	   }
	   bi.pidlRoot = pIdl;
	}
	bi.pszDisplayName = pszDisplayName;
	bi.lpszTitle = lpszTitle;
	bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	bi.lpfn = BrowseCallbackProc;
	if (strStartFolder == NULL){
		bi.lParam = FALSE;
	}else{
		strTmpPath.Format("%s", strStartFolder);
		bi.lParam = TRUE;
	}
	bi.iImage = NULL;
	lpID = SHBrowseForFolderA(&bi);
	if (lpID != NULL){
		BOOL b = SHGetPathFromIDList(lpID, pszDisplayName);
		if (b == TRUE){
			strSelectedFolder->Format("%s",pszDisplayName);
			return TRUE;
		}
	}else{
		strSelectedFolder->Empty();
	}
	return FALSE;
}

void CWaveFileDlg::OnBrowse() 
{
	CString strFolderPath, strFolderName;
   CNetControlApp* pApp = (CNetControlApp*)AfxGetApp();

	if (GetFolder(&strFolderPath, "Select a Folder...", this->m_hWnd, NULL, m_szFolderName)) {
		if (!strFolderPath.IsEmpty())
      {
         pApp->WriteProfileString(_T("WaveFile"),  _T("Path"), strFolderPath);
         m_szFolderName = strFolderPath;
         UpdateData(FALSE);
		}
	}	
}
