// CWebPageParser.cpp: implementation of the CWebPageParser class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NetControl.h"
#include "WebPageParser.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWebPageParser::CWebPageParser()
{
   m_szName.Empty();
   m_szCallSign.Empty();
   m_szLocation.Empty();
}

CWebPageParser::~CWebPageParser()
{

}

void CWebPageParser::SetWebPage(CString szWebPage)
{
   m_szWebPage = szWebPage;
}

BOOL CWebPageParser::ParsePage()
{
   BOOL bSuccess = FALSE;
   int iPos = 0, iLoc = 0, iPass = 0;
   char* szClassLookup[] = {"N", "Novice", "T", "Technician", "P", "Technician Plus",
                            "G", "General","A", "Advanced",   "E", "Extra" }; 

   while(iPos != -1)
   {
      CString szLocString("align=center ><FONT SIZE=-1>");
      iLoc = m_szWebPage.Find(szLocString,iPos);
      int iLocStrLen = szLocString.GetLength();
      if(iLoc != -1)
      {
         int iEor = m_szWebPage.Find("</FONT>",iLoc) - iLoc - iLocStrLen;
         switch(iPass++) {
         case  0:  // Callsign
            m_szCallSign = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break;
         case  1: break; // File Number
         case  2: break; // Applicant Type
         case  3: break; // Service
         case  4: 
            m_szName = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break; // Licensee Name
         case  5: break; // Address
         case  6: break; // PO Box
         case  7:  // City
            m_szCity = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break;
         case  8:  // State
            m_szState = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break;
         case  9:  // Zip
            m_szZip = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break;
         case 10: break; // Grant Date
         case 11: break; // Expire Date
         case 12: break; // NEPA Flag
         case 13: break; // Trustee License ID
         case 14: break; // Previous Callsign
         case 15:  // Operator Class
            m_szClass = m_szWebPage.Mid(iLoc+iLocStrLen,iEor);
            break;
         case 16: break; // Group
         case 17: break; // Previous Operator Class
         case 18: break; // Eligibility Code
         case 19: break; // Trustee Ind
         case 20: break; // Trustee_license_id
         case 21:  // Terminate while loop
            iLoc = -1;
            bSuccess = TRUE;
            break;
         }
         iPos = iLoc+1;
      } else {
         iPos = iLoc;
      }
   }
   return bSuccess;
}

CString CWebPageParser::GetName()
{
   return m_szName;
}

CString CWebPageParser::GetLocation()
{
   m_szLocation.Format("%s, %s %s", m_szCity, m_szState, m_szZip);
   return m_szLocation;
}

CString CWebPageParser::GetCallSign()
{
   return m_szCallSign;
}

CString CWebPageParser::GetClass()
{
   return m_szClass;
}
